2010-09-13  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.36 Released.

2010-08-23  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.36-rc1 Released.

2010-08-20 16:46 +0000 [r283048-283123]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Merged revision 278274 from
	  https://origsvn.digium.com/svn/asterisk/trunk .......... r278274
	  | rmudgett | 2010-07-20 17:38:13 -0500 (Tue, 20 Jul 2010) | 1
	  line Reference correct struct member for unlikely event
	  PRI_EVENT_CONFIG_ERR. ..........

	* channels/chan_dahdi.c: Q931 - Sending PROGRESS after sending
	  ALERTING is a protocol error The PRI layer in chan_dadhi will
	  check if a PROGRESS message has already been sent, and not allow
	  sending another (although that is technically allowed by the Q931
	  spec), however it does not protect against sending an ALERTING
	  and then sending a PROGRESS message, which is a violation of the
	  specification. Most switches don't seem to care too deeply about
	  this, but some do, and will disconnect the call when receiving
	  this invalid sequence. Protocol specification reference:
	  T-REC-Q.931-199805-I page 223, "Figure A.5/Q.931 -- Overview
	  protocol control (network side) point-point (sheet 3 of 8)"
	  (closes issue #17874) Reported by: nic_bellamy Patches:
	  asterisk-1.4-r282537_no-progress-after-alerting.patch uploaded by
	  nic bellamy (license 299)
	  asterisk-1.6.2-r282537_no-progress-after-alerting.patch uploaded
	  by nic bellamy (license 299)
	  asterisk-trunk-r282537_no-progress-after-alerting.patch uploaded
	  by nic bellamy (license 299)

2010-08-19 21:03 +0000 [r282893]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: tos_sip option was not being set correctly
	  When tos_sip is used, the tos of the sip socket is only set
	  correctly if the socket binding changes on a reload. If the
	  binding stays the same but the TOS changes, the new tos value
	  would not take into effect. This patch fixes that. (closes issue
	  #17712) Reported by: nickb

2010-08-19 02:12 +0000 [r282729]  Terry Wilson <twilson@digium.com>

	* configs/sip.conf.sample: Add some documentation about codec
	  negotiation to sip.conf

2010-08-16 17:06 +0000 [r282430]  Terry Wilson <twilson@digium.com>

	* main/channel.c: Send a SRCCHANGE indication when we masquerade
	  Masquerading a channel means that the src of the audio is
	  potentially changing, so send a SRCCHANGE so that RTP-based media
	  streams can get a new SSRC generated to reflect the change.
	  Original patch by addix (along with lots of testing--thanks!).
	  (closes issue #17007) Reported by: addix Patches:
	  1001-reset-SSRC-original-channel.diff uploaded by addix (license
	  1006) srcchange.diff uploaded by twilson (license 396) Tested by:
	  addix, twilson Review: https://reviewboard.asterisk.org/r/862/

2010-08-12 22:49 +0000 [r282129]  Jason Parker <jparker@digium.com>

	* pbx/pbx_config.c: Register CLI commands before parsing config, in
	  case there is a config error.

2010-08-12 03:00 +0000 [r281911]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c: Ensure SSRC is changed when media source is
	  changed to resolve audio delay. This change causes the SSRC to
	  change right before the channels are bridged, which is what used
	  to happen. It seems that fixes were made to attempt limiting SSRC
	  changes, targeted mainly at sending DTMF. DTMF is not affecting
	  the SSRC with this change. There are two other control frames
	  sent in ast_channel_bridge that probably should also be changed
	  to AST_CONTROL_SRCCHANGE as well, but I'm going to leave this
	  change up to the discretion of resolving issue #17007. For
	  reference - old review implementing new control frame SRCCHANGE:
	  https://reviewboard.asterisk.org/r/540 (closes issue #17404)
	  Reported by: sdolloff Patches: bug17404.patch uploaded by jpeeler
	  (license 325) Tested by: sdolloff

2010-08-11 18:28 +0000 [r281762-281819]  Leif Madsen <lmadsen@digium.com>

	* configs/say.conf.sample: Add Danish support to say.conf.sample
	  (closes issue #17836) Reported by: RoadKill Patches:
	  say.conf.sample.patch.dk uploaded by RoadKill (license 933)

	* configs/say.conf.sample: Allow say.conf to handle large numbers
	  ending with multiple zeros. (closes issue #17833) Reported by:
	  RoadKill Patches: say.conf.sample.patch.largenumbers uploaded by
	  RoadKill (license 933)

2010-08-10 17:45 +0000 [r281566]  Russell Bryant <russell@digium.com>

	* apps/app_dial.c: Reset visible indication after answer. (closes
	  issue #17641) Reported by: klaus3000 Patches:
	  ast1.6.2.9-app_dial-visible_indication.patch.txt uploaded by
	  klaus3000 (license 65) Tested by: schmidts

2010-08-09 20:04 +0000 [r281390]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_local.c: Prevent loss of Caller ID information set
	  on local channel after masquerade. Caller ID set on the channel
	  before a masquerade occurs when using a local channel would cause
	  the information to be lost. The problem was that the information
	  was set on a channel destined to be hung up. The somewhat
	  confusing fix is to detect if any Caller ID has been set on the
	  channel and if so preswap the Caller ID data so that basically
	  the masquerade puts the data back. (closes issue #17138) Reported
	  by: kobaz Review: https://reviewboard.asterisk.org/r/847/

2010-08-06 21:34 +0000 [r281185]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: chan_sip: fixes provisional keepalive
	  scheduled item crash There is a scheduler item in chan_sip that
	  keeps sending the last provisional message in response to an
	  INVITE Request for a period of time until a final response to
	  that INVITE is sent. Because of the way this scheduler item
	  works, it requires a reference to a sip_pvt pointer to work
	  properly. The problem with this is that it is currently possible
	  (but rare) for the sip_pvt to get destroyed and that scheduler
	  item to still exist. When this occurs, the scheduler event fires
	  and attempts to access a freed sip_pvt which causes a crash.
	  (closes issue #17497) Reported by: anonymouz666 Patches:
	  keepalive_diff_1.4_v2.diff uploaded by dvossel (license 671)
	  Review: https://reviewboard.asterisk.org/r/849/

2010-08-05 07:28 +0000 [r280982]  Tilghman Lesher <tlesher@digium.com>

	* main/pbx.c: Change context lock back to a mutex, because
	  functionality depends upon the lock being recursive. (closes
	  issue #17643) Reported by: zerohalo Patches:
	  20100726__issue17643.diff.txt uploaded by tilghman (license 14)
	  Tested by: zerohalo

2010-08-04 18:54 +0000 [r280944]  Russell Bryant <russell@digium.com>

	* contrib/scripts/astcli (added): Copy astcli back to 1.4 so it's
	  available for automated testing purposes.

2010-08-03 20:49 +0000 [r280811]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_callerid.c, channels/chan_dahdi.c: Prevent DAHDI
	  channels from overriding the callerid, once it's been set by the
	  user. (closes issue #16661) Reported by: jstapleton Patches:
	  20100414__issue16661.diff.txt uploaded by tilghman (license 14)
	  20100415__issue16661__1.6.2.diff.txt uploaded by tilghman
	  (license 14) Tested by: jstapleton

2010-07-29 19:04 +0000 [r280448]  David Vossel <dvossel@digium.com>

	* main/channel.c: fixes issue with translator frame not getting
	  freed A translator frame even if it local storage so the
	  translation path can be freed. This issue prevented g729 licenses
	  from being freed up. (closes issue #17630) Reported by: manvirr
	  Patches: encoder_fix.diff uploaded by dvossel (license 671)
	  Tested by: manvirr, dvossel

2010-07-29 15:52 +0000 [r280341]  Jean Galarneau <jgalarneau@digium.com>

	* apps/app_meetme.c: Fix a dsp structure leak occuring when a local
	  channel is put into a meetme conference, then masquaraded away.
	  ABE-2422

2010-07-28 13:50 +0000 [r280088]  Leif Madsen <lmadsen@digium.com>

	* contrib/scripts/live_ast: Update help text to be less confusing.

2010-07-27 20:33 +0000 [r279945]  David Vossel <dvossel@digium.com>

	* main/channel.c, include/asterisk/audiohook.h, main/audiohook.c:
	  remove empty audiohook write list on channel If a channel has an
	  audiohook write list created on it, that list stays on the
	  channel until the channel is destroyed. There is no reason to
	  keep that list on the channel if it becomes empty. If it is empty
	  that just means we are doing needless translating for every
	  ast_read and ast_write. This patch removes the audiohook list
	  from the channel once it is detected to be empty on either a read
	  or write. If a audiohook is added back to the channel after this
	  list is destroyed, the list just gets recreated as if it never
	  existed to begin with. (closes issue #17630) Reported by: manvirr
	  Review: https://reviewboard.asterisk.org/r/799/

2010-07-24 23:57 +0000 [r279346]  Bradley Latus <brad.latus@gmail.com>

	* doc/asterisk.8: Minor update to man page

2010-07-24 23:27 +0000 [r279344]  Jeff Peeler <jpeeler@digium.com>

	* configure, include/asterisk/autoconfig.h.in, configure.ac:
	  Provide a default value for DAHDI_TRANSCODE so when DAHDI is not
	  installed menuselect doesn't get confused: Unknown value '' found
	  in build_tools/menuselect-deps for DAHDI_TRANSCODE

2010-07-23 21:56 +0000 [r279206]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_dial.c, apps/app_queue.c: SIP promiscuous redirect could
	  fail to dial the redirect. The ast_channel was created with one
	  variable to ast_request() but the call to ast_call() that
	  initiates the outgoing call was using a different variable. The
	  two variables are not equivalent if the call_forward string
	  included a channel technology specifier. e.g., SIP/200

2010-07-23 18:04 +0000 [r279053]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Backport fixes for sip_uri_params_cmp() from
	  trunk.

2010-07-23 17:04 +0000 [r278981-278984]  Tilghman Lesher <tlesher@digium.com>

	* autoconf/ast_check_pwlib.m4, configure, configure.ac: Establish a
	  maximum version for openh323 (i.e. not opal), because chan_h323
	  will fail to load, even if it links. (issue #17679) Reported by:
	  am

	* main/asterisk.c: Avoid race with consolethread on shutdown (on
	  parallel processors). (closes issue #17080) Reported by:
	  sybasesql Patches: 20100721__issue17080.diff.txt uploaded by
	  tilghman (license 14) Tested by: sybasesql

2010-07-22 19:31 +0000 [r278701]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: DNID does not get cleard on a new call
	  when using immediate=yes with ISDN signaling. When you are using
	  chan_dahdi ISDN signaling with immediate=yes and a call comes in
	  without a DNID then you get the DNID of a previous call.
	  Chan_dahdi does not touch the DNID field on a new call if it does
	  not have a DNID. Made always copy the DNID from the new call. The
	  patches backport the relevant changes from trunk -r210387.
	  (closes issue #17568) Reported by: wuwu Patches:
	  issue17568_v1.4.patch uploaded by rmudgett (license 664)
	  issue17568_v1.6.2.patch uploaded by rmudgett (license 664)

2010-08-10  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.35 Released.

2010-07-22  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.35-rc1 Released.

2010-07-22 14:55 +0000 [r278618]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Allow PLC to function properly when channels use
	  SLIN for audio. If a channel involved in a bridge was using SLIN
	  audio, then translation paths were not guaranteed to be set up
	  properly since in all likelihood the number of translation steps
	  was only 1. This patch enforces the transcode_via_slin behavior
	  if transcode_via_slin or generic_plc is enabled and one of the
	  formats to make compatible is SLIN. AST-352

2010-07-20 22:23 +0000 [r278023-278261]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Delete IMAP messages in reverse order, to
	  ensure reordering after each expunge does not cause deletion of
	  the wrong message. (closes issue #16350) Reported by: noahisaac
	  Patches: 20100623__issue16350.diff.txt uploaded by tilghman
	  (license 14)

	* main/autoservice.c, res/res_features.c,
	  include/asterisk/channel.h: Do not queue up DTMF frames while a
	  call is on hold. (Fixes ABE-2110)

	* main/manager.c: Off-by-one error (closes issue #16506) Reported
	  by: nik600 Patches: 20100629__issue16506.diff.txt uploaded by
	  tilghman (license 14)

2010-07-19 20:56 +0000 [r277944]  Paul Belanger <paul.belanger@polybeacon.com>

	* channels/chan_sip.c: Regression with T.38 negotiation Prior to
	  1.4.26.3 T.38 negotiation worked properly, in the case of the
	  reporter. (issue #16852) Reported by: cfc (closes issue #16705)
	  Reported by: mpiazzatnetbug Patches: issue16705_2.diff uploaded
	  by ebroad (license 878) Tested by: vrban, ebroad, c0rnoTa,
	  samdell3 Review: https://reviewboard.asterisk.org/r/754/

2010-07-19 20:16 +0000 [r277906]  Jean Galarneau <jgalarneau@digium.com>

	* res/res_features.c: Avoid trying to pickup a parked extension
	  before the park operation is completed. A crash could occur if
	  the extension is picked up while the parking extension is being
	  announced. Testing pu->notquiteyet while searching for a parked
	  extension resolves this crash. (ABE-2418)

2010-07-17 16:59 +0000 [r277738]  Tilghman Lesher <tlesher@digium.com>

	* autoconf/ast_func_fork.m4, configure: Remove uclibc cross-compile
	  triplet, as uclibc has a working fork()... it's only uclinux that
	  does not. (closes issue #17616) Reported by: pprindeville

2010-07-16 22:43 +0000 [r277625]  Tim Ringenbach <tim.ringenbach@gmail.com>

	* res/res_features.c: Save and restore AST_FLAG_BRIDGE_HANGUP_DONT
	  on attended transfer. ast_bridge_call() clears
	  AST_FLAG_BRIDGE_HANGUP_DONT. But during an attended transfer,
	  ast_bridge_call() is called for a second bridge on the same
	  channel, and it clears that flag, which still needs to get set
	  for when the original ast_bridge_call() gets control back and
	  checks it. Review: https://reviewboard.asterisk.org/r/741

2010-07-16 21:54 +0000 [r277568]  Tilghman Lesher <tlesher@digium.com>

	* res/res_config_pgsql.c, res/res_config_odbc.c: Since we split
	  values at the semicolon, we should store values with a semicolon
	  as an encoded value. (closes issue #17369) Reported by: gkservice
	  Patches: 20100625__issue17369.diff.txt uploaded by tilghman
	  (license 14) Tested by: tilghman

2010-07-16 21:18 +0000 [r277497]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Default to no udptl error correction so that
	  error correction will be disabled in the event that the remote
	  end indicates that they do not support the error correction mode
	  we requested. FAX-128

2010-07-16 20:18 +0000 [r277419]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: priexclusive in chan_dahdi.conf ignored
	  when reloading dahdi module During a reload, the priexclusive and
	  outsignalling parameters are not read in from the config file as
	  intended. Unfortunately, they get set to defaults as a result.
	  This patch makes sure that they do not get set to defaults during
	  a reload. (closes issue #17441) Reported by: mtryfoss Patches:
	  issue17441_v1.4.patch uploaded by rmudgett (license 664)
	  issue17441_v1.6.2.patch uploaded by rmudgett (license 664)
	  issue17441_trunk.patch uploaded by rmudgett (license 664) Tested
	  by: rmudgett

2010-07-16 18:30 +0000 [r277327]  Matthew Nicholson <mnicholson@digium.com>

	* main/pbx.c: Interpret device state AST_DEVICE_UNKNOWN as
	  extension state AST_EXTENSION_NOT_INUSE. (closes issue #16035)
	  Reported by: francesco_r Patches: pbx.c.patch uploaded by
	  viniciusfontes (license 978) Tested by: francesco_r, agx, lawbar

2010-07-16 18:04 +0000 [r277261]  Tilghman Lesher <tlesher@digium.com>

	* main/manager.c: If variable gotten is not set, will segfault on
	  Solaris. (closes issue #17636) Reported by: bklang

2010-07-16 17:29 +0000 [r277247]  Matthew Nicholson <mnicholson@digium.com>

	* main/channel.c: For pass through DTMF tones, measure the actual
	  duration between the begin and end packets on the wire. If it is
	  detected to be less than AST_MIN_DTMF_DURATION, trigger dtmf
	  emulation. AST-362

2010-07-16 17:10 +0000 [r277182]  Paul Belanger <paul.belanger@polybeacon.com>

	* apps/app_amd.c: Total analysis time error with SIP and silence
	  suppression When using app_amd with SIP providers that have
	  silence suppression on, the iTotalTime count increases
	  exponentially. (closes issue #17656) Reported by: juls

2010-07-15 13:48 +0000 [r276652]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c: In a perfect world, the frame source would never
	  be NULL. In the meantime, don't crash when it is.

2010-07-14 11:49 +0000 [r276267]  Leif Madsen <lmadsen@digium.com>

	* configs/voicemail.conf.sample: Update documentation for
	  voicemail.conf externpass option.

2010-07-13 19:14 +0000 [r275994-276126]  Russell Bryant <russell@digium.com>

	* res/res_features.c: Only reset a CDR that exists.

	* res/res_features.c: Use chan->cdr instead of chan_cdr (just like
	  peer->cdr instead of peer_cdr in the last commit).

	* res/res_features.c: Access peer->cdr directly instead of through
	  a saved off reference. At this point in the code, it is possible
	  that peer_cdr may be invalid. Specifically, in the blind transfer
	  code, CDRs are swapped between channels. So, peer_cdr is no
	  longer == peer->cdr. The scenario that exposed a crash in this
	  code was a blind transfer that hit the system call limit, causing
	  the transferee channel to get destroyed after the transfer
	  attempt failed. Even if it succeeds and this code doesn't crash,
	  this code was still trying to reset a CDR on a channel that was
	  now owned by a different thread, which is a BadThing(tm).
	  (ABE-2417)

2010-07-13 14:47 +0000 [r275909]  Tilghman Lesher <tlesher@digium.com>

	* contrib/realtime/mysql/sipfriends.sql,
	  contrib/realtime/mysql/voicemail.sql,
	  contrib/scripts/realtime_pgsql.sql (removed),
	  contrib/scripts/vmdb.sql (removed),
	  contrib/scripts/iax-friends.sql (removed),
	  contrib/realtime/mysql/iaxfriends.sql,
	  contrib/realtime/mysql/meetme.sql, contrib/scripts/meetme.sql
	  (removed), contrib/realtime (added), contrib/realtime/postgresql,
	  contrib/realtime/postgresql/realtime.sql, contrib/realtime/mysql,
	  contrib/realtime/oracle, contrib/realtime/sqlserver,
	  contrib/scripts/sip-friends.sql (removed): Move SQL scripts into
	  their own database-specific directories.

2010-07-12 20:34 +0000 [r275665-275773]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_meetme.c: Make user removals and traversals thread safe
	  in meetme. Race conditions present in meetme involving the user
	  list where a lack of locking has the potential for a user to be
	  removed during a traversal or as in the case of the reporter
	  after checking if the list is empty could cause a crash. Fixing
	  this was done by convering the userlist to an ao2 container.
	  (closes issue #17390) Reported by: Vince Review:
	  https://reviewboard.asterisk.org/r/746/

	* main/channel.c: Change ast_write to not stop generator when
	  called from ast_prod. For SIP channels configured with the
	  progressinband option on, the ringback was being immediately
	  stopped. This problem was due to ast_prod being moved for a
	  deadlock fix in 259858. Prodding the channel after setting up the
	  generator triggered the check in ast_write to stop the generator.
	  The fix here should write the frame the same as was done before
	  the call to ast_prod was moved. (closes issue #17372) Reported
	  by: tech_admin

2010-07-09 19:28 +0000 [r275241-275290]  Paul Belanger <paul.belanger@polybeacon.com>

	* main/cli.c: fix tab-completion for unload command. (closes issue
	  #17536) Reported by: junky Patches: unload_vs_mod_unload.diff
	  uploaded by junky (license 177) Tested by: pabelanger

	* channels/chan_sip.c: Fix logging message for stale nonce. (closes
	  issue #17582) Reported by: kenner Patches: chan_sip.c.diff
	  uploaded by kenner (license 1040) Tested by: lmadsen

2010-07-09 18:23 +0000 [r275027-275182]  Matthew Nicholson <mnicholson@digium.com>

	* main/loader.c: give a better error message when attempting to
	  unload a module that is not loaded

	* main/loader.c: don't unload modules that returned
	  AST_MODULE_LOAD_DECLINE when they were loaded

	* apps/app_dial.c: Clear the AST_CDR_FLAG_DIALED flag for channels
	  going into the pbx via the G option in app_dial (closes issue
	  #17592) Reported by: jamicque Patches: G-flag-cdr-fix1.diff
	  uploaded by mnicholson (license 96) Tested by: jamicque,
	  mnicholson

2010-07-09 15:33 +0000 [r275021]  Russell Bryant <russell@digium.com>

	* include/asterisk/test.h, main/test.c: Document that a leading and
	  trailing slash is expected for test categories. Also, emit a
	  warning if a test is registered without one of these.

2010-07-07 18:12 +0000 [r274579]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Close the DAHDI FD on error when
	  processing chan_dahdi toneduration config parameter.

2010-07-07 06:13 +0000 [r274417]  Tilghman Lesher <tlesher@digium.com>

	* configs/say.conf.sample: Correct how 100, 200, 300, etc. is said.
	  Also add the crazy British numbers. (closes issue #16102)
	  Reported by: Delvar Patches: say.conf.fix.patch uploaded by
	  Delvar (license 908) (plus a few additional fixes and
	  simplifications by me)

2010-07-06 22:46 +0000 [r274283-274359]  Jeff Peeler <jpeeler@digium.com>

	* main/Makefile: Ensure file.o is built correctly. (related to
	  issue #15250)

	* configs/sip.conf.sample: Correct sip.conf.sample comments for
	  prematuremedia option. (closes issue #17513) Reported by: festr
	  Patches: patch uploaded by festr (license 443)

2010-07-06 22:08 +0000 [r274280]  Terry Wilson <twilson@digium.com>

	* channels/chan_sip.c, configs/sip.conf.sample: Add option to not
	  do a call forward on 482 Loop Detected Asterisk has always set up
	  a forwarded call when receiving a 482 Loop Detected. This
	  prevents handling the call failure by just continuing on in the
	  dialplan. Since this would be a change in behavior, the new
	  option to disable this behavior is forwardloopdetected which
	  defaults to 'yes'. Review:
	  https://reviewboard.asterisk.org/r/764/

2010-07-06 14:29 +0000 [r274157]  Mark Michelson <mmichelson@digium.com>

	* main/rtp.c: Fix problem with RFC 2833 DTMF not being accepted. A
	  recent check was added to ensure that we did not erroneously
	  detect duplicate DTMF when we received packets out of order. The
	  problem was that the check did not account for the fact that the
	  seqno of an RTP stream will roll over back to 0 after hitting
	  65535. Now, we have a secondary check that will ensure that the
	  seqno rolling over will not cause us to stop accepting DTMF.
	  (closes issue #17571) Reported by: mdeneen Patches:
	  rtp_seqno_rollover.patch uploaded by mmichelson (license 60)
	  Tested by: richardf, maxochoa, JJCinAZ

2010-07-06 13:52 +0000 [r274093]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_queue.c: Make get_member_status return QUEUE_NO_MEMBERS
	  instead of QUEUE_NO_REACHABLE_MEMBERS to make joinempty=no work
	  again. This regression was introduced in 273639. Also fixed
	  whitespace.

2010-07-05 19:48 +0000 [r273981]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_oss.c, channels/chan_iax2.c: Command 'stop
	  gracefully' doesn't.

2010-07-05 13:51 +0000 [r273884]  Paul Belanger <paul.belanger@polybeacon.com>

	* main/config.c: Remove extra line breaks from 'core show config
	  mappings' (closes issue #17583) Reported by: pabelanger Patches:
	  issue17583.patch uploaded by pabelanger (license 224) Tested by:
	  lmadsen

2010-07-02 21:36 +0000 [r273717-273793]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_dahdi.c, channels/chan_local.c, configure,
	  include/asterisk/autoconfig.h.in, channels/chan_agent.c,
	  configure.ac, channels/chan_h323.c, include/asterisk/lock.h,
	  include/asterisk/compiler.h: Have the DEADLOCK_AVOIDANCE macro
	  warn when an unlock fails, to help catch potentially large
	  software bugs. (closes issue #17407) Reported by: pdf Patches:
	  20100527__issue17407.diff.txt uploaded by tilghman (license 14)
	  Review: https://reviewboard.asterisk.org/r/751/

	* main/autoservice.c: Autoservice loop optimization causes a busy
	  loop, when channels are serviced while in hangup. (closes issue
	  #17564) Reported by: ramonpeek Patches:
	  20100630__issue17564.diff.txt uploaded by tilghman (license 14)
	  Tested by: ramonpeek

2010-07-02 15:54 +0000 [r273640]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* apps/app_voicemail.c, channels/chan_dahdi.c,
	  channels/chan_misdn.c, channels/chan_sip.c, res/res_agi.c,
	  res/res_jabber.c: Fix various typos, reported by Lintian

2010-07-02 15:46 +0000 [r273639]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_queue.c: If all members are paused, the wrong status is
	  indicated. (closes issue #17576) Reported by: ramonpeek Patches:
	  diff.txt uploaded by ramonpeek (license 266) Tested by: ramonpeek

2010-07-01 22:09 +0000 [r273565]  Russell Bryant <russell@digium.com>

	* main/channel.c: Don't return a partially initialized datastore.
	  If memory allocation fails in ast_strdup(), don't return a
	  partially initialized datastore. Bad things may happen. (related
	  to ABE-2415)

2010-07-01 20:19 +0000 [r273354-273474]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_meetme.c: Allow admin user to join conference without
	  using admin mode and no user pin. Configuring the conference in
	  meetme.conf like the following: conf => 2345,,6666 did not prompt
	  for pin when used without admin mode. This meant that the
	  conference could not be joined as an admin even if the user knew
	  the correct pin. The original bug report was submitted claiming
	  that the blank user pin should deny entry into the conference. I
	  think a better way to handle this would be with a feature
	  enhancement that used the following syntax: conf => 2345,X,6666 -
	  where X denotes no acceptable pin allowed (closes issue #15704)
	  Reported by: modelnine

	* apps/app_meetme.c: Ensure channel placed in meetme in ringing
	  state is properly hung up. An outgoing channel placed in meetme
	  while still ringing which was then hung up would not exit meetme
	  and the channel was not properly destroyed. Specifically checking
	  for this scenario by looking at the appropriate control frames
	  resolves the issue. (closes issue #15871) Reported by: Ivan
	  Patches: meetme_congestion_trunk_v2.patch uploaded by Ivan
	  (license 229)

2010-06-29 23:15 +0000 [r273057-273060]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_sip.c: Allow the "useragent" value to be restored
	  into memory from the realtime backend. This value is purely
	  informational. It does not alter configuration at all. (closes
	  issue #16029) Reported by: Guggemand Patches:
	  realtime-useragent.patch uploaded by Guggemand (license 897)
	  Tested by: Guggemand

	* main/channel.c: _Really_ skip the channel... don't just retry for
	  another 200 cycles. (Closes issue SWP-1652, ABE-2240)

2010-06-29 21:36 +0000 [r273017]  Russell Bryant <russell@digium.com>

	* /: Remove properties that were erroneously merged to 1.4 from one
	  of my branches.

2010-07-22  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.34 Released.

2010-07-07  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.34-rc2 Released.

	* Fix problem with RFC 2833 DTMF not being accepted.
  
	  A recent check was added to ensure that we did not erroneously
	  detect duplicate DTMF when we received packets out of order.
	  The problem was that the check did not account for the fact that
	  the seqno of an RTP stream will roll over back to 0 after hitting
	  65535. Now, we have a secondary check that will ensure that the
	  seqno rolling over will not cause us to stop accepting DTMF.
  
	  (closes issue 0017571)
	  Reported by: mdeneen
	  Patches:
	        rtp_seqno_rollover.patch uploaded by mmichelson (license 60)
	  Tested by: richardf, maxochoa, JJCinAZ

	* Clear the AST_CDR_FLAG_DIALED flag for channels going into the pbx
	  via the G option in app_dial
  
	  (closes issue 0017592)
	  Reported by: jamicque
	  Patches:
	        G-flag-cdr-fix1.diff uploaded by mnicholson (license 96)
	  Tested by: jamicque, mnicholson

2010-06-29  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.34-rc1 Released.

2010-06-28 21:50 +0000 [r272921-272925]  Tilghman Lesher <tlesher@digium.com>

	* main/asterisk.c: Don't change ownership/group/permissions on run
	  directory, if it already exists. (closes issue #17076) Reported
	  by: stuarth Patches: 20100324__issue17076.diff.txt uploaded by
	  tilghman (license 14) Tested by: stuarth

	* main/config.c: Also trim trailing blanks on #includes

	* main/config.c: Change the way that we read include files, to
	  accommodate for changes in GCC 4.4. (closes issue #17472)
	  Reported by: seandarcy Patches: config2.patch uploaded by nivan
	  (license 1066) Tested by: nivan

2010-06-28 18:47 +0000 [r272878-272881]  Russell Bryant <russell@digium.com>

	* tests/test_astobj2.c (added): Backport applicable parts of
	  test_astobj2.

	* main/asterisk.c, Makefile, include/asterisk/test.h (added),
	  build_tools/cflags-devmode.xml, include/asterisk.h,
	  tests/Makefile, tests/test_skel.c, /, main/Makefile, tests
	  (added), include/asterisk/linkedlists.h, main/test.c (added):
	  Backport unit test API to 1.4. Review:
	  https://reviewboard.asterisk.org/r/750/

2010-06-28 17:31 +0000 [r272804]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Decode URI in contact header of 302
	  response. ABE-2352

2010-06-28 17:11 +0000 [r272688-272763]  Russell Bryant <russell@digium.com>

	* Makefile: Force SILENTMAKE where it is needed.

	* Makefile: Backport method of setting SUBMAKE from trunk. By
	  setting the PRINT_DIR variable, SUBMAKE will print out the
	  directories it descends into, which is important for editors
	  (like vim) that watch the build output so that they can take you
	  to the file where an error occurred.

2010-06-25 20:17 +0000 [r272562]  Tilghman Lesher <tlesher@digium.com>

	* doc/voicemail_odbc_postgresql.txt: Make the structure of the
	  table specified before match the queries and results. (closes
	  issue #17557) Reported by: cmaj

2010-06-24 21:58 +0000 [r272446]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: ss_thread calls pri_grab without lock
	  during overlap dial Recent changes to chan_dahdi with relation to
	  overlap dialing call pri_grab without first obtaining a lock.
	  (closes issue #17414) Reported by: pdf Patches: bug17414.patch
	  uploaded by jpeeler (license 325)

2010-06-23 22:33 +0000 [r272367]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_queue.c: Send AgentComplete manager events in the event
	  of blind and attended transfers. (closes issue #16819) Reported
	  by: elbriga Patches: app_queue.diff uploaded by elbriga (license
	  482)

2010-06-23 20:57 +0000 [r272255]  Paul Belanger <paul.belanger@polybeacon.com>

	* apps/app_meetme.c: First caller into a dynamic conference now
	  enter pin once. If MeetMe is configured to use dynamic conference
	  numbers, then the first caller (which creates the conference) had
	  to enter the PIN number twice. (closes issue #15878) Reported by:
	  shawkris Patches: issue15878.patch uploaded by pabelanger
	  (license 224) Tested by: pabelanger

2010-06-23 18:40 +0000 [r272147]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Backport part of revision 136715 to fix
	  callerid in voicemail text files (IMAP only). (closes issue
	  #16945) Reported by: mneuhauser

2010-06-22 17:31 +0000 [r271689-271902]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Decrease the module ref count in sip_hangup
	  when SIP_DEFER_BYE_ON_TRANSFER is set. This is necessary to keep
	  the ref count correct. (closes issue #16815) Reported by: rain
	  Patches: chan_sip-unref-fix.diff uploaded by rain (license 327)
	  (modified) Tested by: rain

	* pbx/pbx_dundi.c: Allow users to specify a port for dundi peers.
	  (closes issue #17056) Reported by: klaus3000 Patches:
	  dundi-peerport-patch-trunk.txt uploaded by klaus3000 (license 65)
	  Tested by: klaus3000

	* configs/sip_notify.conf.sample, channels/chan_sip.c: Modify
	  chan_sip's packet generation api to automatically calculate the
	  Content-Length. This is done by storing packet content in a
	  buffer until it is actually time to send the packet, at which
	  time the size of the packet is calculated. This change was made
	  to ensure that the Content-Length is always correct. (closes
	  issue #17326) Reported by: kenner Tested by: mnicholson, kenner
	  Review: https://reviewboard.asterisk.org/r/693/

2010-06-21 20:37 +0000 [r271552]  Jeff Peeler <jpeeler@digium.com>

	* pbx/pbx_ael.c: Do not use sizeof to calculate size of a heap
	  allocated character array. Change left out from 271399. (closes
	  issue #16053) Reported by: diLLec

2010-06-18 20:52 +0000 [r271399-271444]  Jeff Peeler <jpeeler@digium.com>

	* pbx/pbx_ael.c: Check for newly added memory allocation failures
	  gracefully during AEL2 parsing.

	* pbx/pbx_ael.c: Fix crash when parsing some heavily nested
	  statements in AEL on reload. Due to the recursion used when
	  compiling AEL in gen_prios, all the stack space was being
	  consumed when parsing some AEL that contained nesting 13 levels
	  deep. Changing a few large buffers to be heap allocated fixed the
	  crash, although I did not test how many more levels can now be
	  safely used. (closes issue #16053) Reported by: diLLec Tested by:
	  jpeeler

2010-06-18 18:54 +0000 [r271339-271340]  Russell Bryant <russell@digium.com>

	* include/asterisk/lock.h: Remove an unnecessary assignment that
	  causes a DEBUG_THREADS build failure on mac os x.

	* configure, include/asterisk/autoconfig.h.in, configure.ac,
	  include/asterisk/lock.h: Fix a build problem on Mac OS X with
	  DEBUG_THREADS enabled. This set of changes was already in trunk.

2010-06-18 18:33 +0000 [r271335]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Eliminate deadlock potential in
	  dahdi_fixup(). (This is a backport of 269307, committed to trunk
	  by rmudgett.) Calling dahdi_indicate() when the channel private
	  lock is already held can cause a deadlock if the PRI lock is
	  needed because dahdi_indicate() will also get the channel private
	  lock. The pri_grab() function assumes that the channel private
	  lock is held once to avoid deadlock. (closes issue #17261)
	  Reported by: aragon

2010-06-22  Russell Bryant <russell@digium.com>

	* Asterisk 1.4.33.1 Released.

	* channels/chan_dahdi.c: Merge revision 270404 from the 1.4 branch.

	  fixes FXS port still ringing when answered, as reported by Tzafrir
	  on dev-list.

	  (issue #17067)
	  Reported by: tzafrir
	  Tested by: alecdavis

2010-06-17  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.33 Released.

2010-06-10  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.33-rc2 Released.

2010-06-10  Tilghman Lesher <tlesher@digium.com>

	* Ensure signals are not blocked inside other signal handlers.

	  This eliminates the annoying <beep> on the console.

	  (closes issue 0017477)
	   Reported by: jvandal
	   Patches:
	         20100610__issue17477.diff.txt uploaded by tilghman (license 14)

2010-06-09  Paul Belanger <paul.belanger@polybeacon.com>

	* Fix Debian init script to not use -c.

	  When using the init script as-is currently, it could cause issues on Debian
	  such as high CPU usage. This fix has worked for several people so I'm
	  implementing the change. We now handle color displays properly.

	  (closes issue 0016784)
	  Reported by: pabelanger
	  Patches:
	        20100530__issue16784__2.diff.txt uploaded by tilghman (license 14)
	  Tested by: pabelanger, tilghman

2010-06-01  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.33-rc1 Released.

2010-06-01 15:17 +0000 [r266585]  Tilghman Lesher <tlesher@digium.com>

	* main/asterisk.c: Prevent CLI prompt from distorting output of
	  lines shorter than the prompt. Uses the VT100 method of clearing
	  the line from the cursor position to the end of the line: Esc-0K
	  (closes issue #17160) Reported by: coolmig Patches:
	  20100531__issue17160.diff.txt uploaded by tilghman (license 14)
	  Tested by: coolmig

2010-06-01 14:57 +0000 [r266579-266580]  Paul Belanger <paul.belanger@polybeacon.com>

	* channels/chan_sip.c: Fix formatting issue with previous patch.

	* channels/chan_sip.c: Missing fallback to audio fax feature when
	  T.38 re-INVITE failed When a T.38 re-INVITE failed with an 488 or
	  606 answer, we should fallback to audio fax by send a
	  re-re-INVITE without T.38. The function is backported from 1.6
	  asterisk. (closes issue #16795) Reported by: vrban (closes issue
	  #16692) Reported by: vrban Patches:
	  t38_fallback_to_audio_v3.patch uploaded by vrban (license 756)
	  Tested by: lmadsen, vrban, haggard
	  https://reviewboard.asterisk.org/r/514/

2010-05-30 04:43 +0000 [r266437]  Tilghman Lesher <tlesher@digium.com>

	* contrib/init.d/rc.debian.asterisk: Reverting patch and reopening
	  issue #16784, as patch breaks color display.

2010-05-26 21:11 +0000 [r266142]  Tilghman Lesher <tlesher@digium.com>

	* main/asterisk.c, main/logger.c: Use sigaction for signals which
	  should persist past the initial trigger, not signal. If you call
	  signal() in a Solaris signal handler, instead of just resetting
	  the signal handler, it causes the signal to refire, because the
	  signal is not marked as handled prior to the signal handler being
	  called. This effectively causes Solaris to immediately exceed the
	  threadstack in recursive signal handlers and crash. (closes issue
	  #17000) Reported by: rmcgilvr Patches:
	  20100526__issue17000.diff.txt uploaded by tilghman (license 14)
	  Tested by: rmcgilvr

2010-05-26 20:33 +0000 [r266140]  David Vossel <dvossel@digium.com>

	* channels/chan_dahdi.c: add dahdi_func_write to zap_tech structure
	  This was supposed to be committed with r263292, the back-port of
	  teh DAHDI buffer policy dial string option

2010-05-26 18:21 +0000 [r266004]  Mark Michelson <mmichelson@digium.com>

	* apps/app_queue.c: Make AgentComplete message more consistent. At
	  times, the "Member" field was not specified during the event.
	  It's there now. (closes issue #15638) Reported by: elbriga
	  Patches: patchAppQueueAgentComplete.diff uploaded by elbriga
	  (license 482)

2010-05-26 16:21 +0000 [r265910]  Tilghman Lesher <tlesher@digium.com>

	* res/res_config_pgsql.c: Not finding rows in the DB does not rise
	  to the level of a warning. (closes issue #17062) Reported by:
	  drookie Patches: 20100525__issue17062.diff.txt uploaded by
	  tilghman (license 14)

2010-05-25 17:11 +0000 [r265613]  David Vossel <dvossel@digium.com>

	* channels/chan_dahdi.c: fixes build issue with zaptel (closes
	  issue #17394) Reported by: aragon Patches: half_buffer_fix.diff
	  uploaded by dvossel (license 671) Tested by: aragon

2010-05-25 16:48 +0000 [r265610]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_queue.c: Don't mark the cdr records of unanswered queue
	  calls with "NOANSWER". This restores the behavior prior to
	  r258670. (closes issue #17334) Reported by: jvandal Patches:
	  queue-cdr-fixes1.diff uploaded by mnicholson (license 96) Tested
	  by: aragon, jvandal

2010-05-25 13:33 +0000 [r265570]  Terry Wilson <twilson@digium.com>

	* include/asterisk/options.h, main/asterisk.c, Makefile,
	  doc/manager.txt, main/manager.c: Merged revisions 265320,265467
	  via svnmerge from https://origsvn.digium.com/svn/asterisk/trunk
	  ........ r265320 | twilson | 2010-05-24 14:06:40 -0500 (Mon, 24
	  May 2010) | 14 lines Add the FullyBooted AMI event It is possible
	  to connect to the manager interface before all Asterisk modules
	  are loaded. To ensure that an application does not send AMI
	  actions that might require a module that has not yet loaded, the
	  application can listen for the FullyBooted manager event. It will
	  be sent upon connection if all modules have been loaded, or as
	  soon as loading is complete. The event: Event: FullyBooted
	  Privilege: system,all Status: Fully Booted Review:
	  https://reviewboard.asterisk.org/r/639/ ........ r265467 |
	  twilson | 2010-05-24 17:21:58 -0500 (Mon, 24 May 2010) | 1 line
	  Merge the rest of the FullyBooted patch ........

2010-05-24 19:37 +0000 [r265365]  David Vossel <dvossel@digium.com>

	* main/channel.c: fixes segfault when using generic plc

2010-05-21 20:59 +0000 [r264996-265089]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/file.h, apps/app_queue.c: Don't hang up on a
	  queue caller if the file we attempt to play does not exist. This
	  also fixes a documentation mistake in file.h that made my
	  original attempt to correct this problem not work correctly.
	  (closes issue #17061) Reported by: RoadKill

	* include/asterisk/channel.h: Fix grammatical error in comment.

	* main/channel.c, main/autoservice.c, include/asterisk/channel.h:
	  Allow ast_safe_sleep to defer specific frames until after the
	  sleep has concluded. From reviewboard Background: A Digium
	  customer discovered a somewhat odd bug. The setup is that parties
	  A and B are bridged, and party A places party B on hold. While
	  party B is listening to hold music, he mashes a bunch of DTMF.
	  Party A takes party B off hold while this is happening, but party
	  B continues to hear hold music. I could reproduce this about 1 in
	  5 times. The issue: When DTMF features are enabled and a user
	  presses keys, the channel that the DTMF is streamed to is placed
	  in an ast_safe_sleep for 100 ms, the duration of the emulated
	  tone. If an AST_CONTROL_UNHOLD frame is read from the channel
	  during the sleep, the frame is dropped. Thus the unhold
	  indication is never made to the channel that was originally
	  placed on hold. The fix: Originally, I discussed with Kevin
	  possible ways of fixing the specific problem reported. However,
	  we determined that the same type of problem could happen in other
	  situations where ast_safe_sleep() is used. Using autoservice as a
	  model, I modified ast_safe_sleep_conditional() to defer specific
	  frame types so they can be re-queued once the sleep has finished.
	  I made a common function for determining if a frame should be
	  deferred so that there are not two identical switch blocks to
	  maintain. Review: https://reviewboard.asterisk.org/r/674/

2010-05-20 23:23 +0000 [r264820]  Richard Mudgett <rmudgett@digium.com>

	* main/callerid.c: ast_callerid_parse() had a path that left name
	  uninitialized. Several callers of ast_callerid_parse() do not
	  initialize the name parameter before calling thus there is the
	  potential to use an uninitialized pointer.

2010-05-20 15:59 +0000 [r264541]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/options.h, main/loader.c, main/channel.c,
	  include/asterisk/channel.h: 1.4 version of PLC fix. Analogous to
	  trunk revision 264452, but without the change to chan_sip since
	  it is not necessary in this branch.

2010-05-19 20:01 +0000 [r264334]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_speech_utils.c: Set quieted flag when receiving a dtmf
	  tone during playback in speechbackground. (closes issue #16966)
	  Reported by: asackheim

2010-05-19 17:41 +0000 [r264248]  Tilghman Lesher <tlesher@digium.com>

	* include/asterisk/options.h, configure, configure.ac: Internal
	  timing is now on by default, if you're using DAHDI 2.3 or above.
	  The reason for ensuring DAHDI 2.3 or above is that this version
	  ensures that a timer is always available, whereas in previous
	  versions, it was possible for DAHDI to be loaded, but have no
	  drivers to actually generate timing. If internal_timing was
	  turned on in this circumstance, a complete lack of audio would
	  result. This is the reason why internal_timing was not on by
	  default. However, now that DAHDI ensures the availability of a
	  timer, there is no reason for this setting to be off (and in
	  fact, it solves a great many initial user problems). (closes
	  issue #15932) Reported by: dimas Patches:
	  20100519__issue15932.diff.txt uploaded by tilghman (license 14)
	  Tested by: tilghman

2010-05-19 08:23 +0000 [r264056]  Alec L Davis <sivad.a@paradise.net.nz>

	* configs/indications.conf.sample: fix incorrectly typed
	  indications for [nz] stutter and dialrecall (closes issue #17359)
	  Reported by: alecdavis Patches: bug17359.diff.txt uploaded by
	  alecdavis (license 585)

2010-05-19 06:32 +0000 [r263949]  Tilghman Lesher <tlesher@digium.com>

	* main/dsp.c: Because progress is called multiple times, across
	  several frames, we must persist states when detecting multitone
	  sequences. (closes issue #16749) Reported by: dant Patches:
	  dsp.c-bug16749-1.patch uploaded by dant (license 670) Tested by:
	  dant

2010-05-18 18:54 +0000 [r263769]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_directory.c: Modify directory name reading to be
	  interrupted with operator or pound escape. In the case of
	  accidentally entering the wrong first three letters for the
	  reading, users could be very frustrated if the name listing is
	  very long. This allows interrupting the reading by pressing 0 or
	  #. 0 will attempt to execute a configured operator (o) extension
	  and # will exit and proceed in the dialplan. ABE-2200

2010-05-17 22:00 +0000 [r263637-263639]  Mark Michelson <mmichelson@digium.com>

	* main/devicestate.c: Fix logic error when checking for a devstate
	  provider. When using strsep, if one of the list of specified
	  separators is not found, it is the first parameter to strsep
	  which is now NULL, not the pointer returned by strsep. This issue
	  isn't especially severe in that the worst it is likely to do is
	  waste some cycles when a device with no '/' and no ':' is passed
	  to ast_device_state.

	* main/pbx.c: Remove arbitrary size limitation for hints. (closes
	  issue #17257) Reported by: tim_ringenbach Patches:
	  hints_crash_fix.diff uploaded by tim ringenbach (license 540)

2010-05-17 14:35 +0000 [r263374-263456]  Leif Madsen <lmadsen@digium.com>

	* main/http.c: Manager cookies are not compatible with RFC2109. The
	  Version field in the cookies we're setting contain quotes around
	  the version number which is not compatible with RFC2109 and
	  breaks some implementations. (closes issue #17231) Reported by:
	  ecarruda Patches: manager_rfc2109-trunk-v1.patch uploaded by
	  ecarruda (license 559) manager_rfc2109-1.6.2-v1.patch uploaded by
	  ecarruda (license 559) Tested by: ecarruda, russell

	* sounds/Makefile: Update link to new version of core sounds. The
	  latest version of the core sounds files 1.4.19 now includes the
	  missing queue-minute sound file which is called by app_queue but
	  which has been missing. (closes issue #17123) Reported by:
	  n8ideas

2010-05-17 13:01 +0000 [r263292]  David Vossel <dvossel@digium.com>

	* channels/chan_dahdi.c: backport of DAHDI buffer policy dial
	  string option

2010-05-13 23:08 +0000 [r263112]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c, main/file.c: Fix internal timing not working with
	  Zaptel dahdi_compat.h was not being included in channel.c when
	  used with Zaptel and wasn't in file.c at all. (closes issue
	  #15250) Reported by: mneuhauser Patches: dahdi_compat.patch
	  uploaded by mneuhauser (license 425) Tested by: IgorG

2010-05-12 17:00 +0000 [r262662]  David Vossel <dvossel@digium.com>

	* apps/app_meetme.c: fixes app_meetme dsp error We attempted to
	  detect silence after translating a frame from signed linear. This
	  caused a flooding of errors. To resolve this the code to detect
	  silence was moved before the translation. (closes issue #17133)
	  Reported by: jsdyer

2010-05-11 19:55 +0000 [r262421]  Jason Parker <jparker@digium.com>

	* pbx/Makefile: Use a less silly method for modifying a
	  flex-generated file. The sed syntax that was used wasn't actually
	  valid, causing some versions to choke. This is the method that is
	  used in 1.6.x+ for similar changes. (closes issue #16696)
	  Reported by: bklang Patches: 16696-sedfix.diff uploaded by qwell
	  (license 4) Tested by: qwell

2010-05-11 17:22 +0000 [r262321]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c, Makefile.rules: Fix issue #17302 a slightly
	  different way (mad props to Qwell)

2010-05-10 16:34 +0000 [r262151]  Tilghman Lesher <tlesher@digium.com>

	* Makefile.rules: Allow compilation on Mac OS X 10.4 (Tiger)
	  (closes issue #17297) Reported by: jcovert Patches:
	  20100506__issue17297.diff.txt uploaded by tilghman (license 14)
	  (closes issue #17302) Reported by: jcovert

2010-05-06 20:10 +0000 [r261698-261735]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.c: Only allow the operator key to be accepted
	  after leaving a voicemail. Or rather disallow the operator key
	  from being accepted when not offered, such as after finishing a
	  recording from within the mailbox options menu. ABE-2121 SWP-1267

	* apps/app_voicemail.c: Revert 261698, code in trunk leads me to
	  believe unadvertised options are supported.

	* apps/app_voicemail.c: Remove some hidden broken code in the
	  voicemail mailbox options menu. After finishing a recording from
	  within the mailbox options menu, pressing 0 exhibited strange
	  behavior with operator=yes turned on. Pressing 0 was not even
	  advertised as an option and the options from the vm-saveoper
	  prompt: "Press 1 to accept this recording. Otherwise, please
	  continue to hold" did not function correctly. While this of
	  course could be fixed, it didn't really seem to make sense even
	  if it was working properly. ABE-2121 SWP-1267

2010-05-06 16:56 +0000 [r261608]  Jason Parker <jparker@digium.com>

	* sounds/Makefile: Use the versioned MOH tarballs, now that we have
	  them. This makes for more reproducibility. Prompted by a
	  discussion in #asterisk-dev

2010-06-01  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.32 Released

2010-05-26  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.32-rc2 Released

2010-05-26 10:56 -0500 [r265891]  Matt Nicholson <mnicholson@digium.com>

	* Merged r265610 from 1.4:

	  Don't mark the cdr records of unanswered queue calls with "NOANSWER".
	  This restores the behavior prior to r258670.

	  (closes issue #17334)
	  Reported by: jvandal
	  Patches:
	        queue-cdr-fixes1.diff uploaded by mnicholson (license 96)
	  Tested by: aragon, jvandal

2010-05-06  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.32-rc1 Released

2010-05-05 16:42 +0000 [r261274]  Paul Belanger <paul.belanger@polybeacon.com>

	* channels/chan_sip.c: Registration fix for SIP realtime. Make sure
	  realtime fields are not empty. (closes issue #17266) Reported by:
	  Nick_Lewis Patches: chan_sip.c-realtime.patch uploaded by Nick
	  Lewis (license 657) Tested by: Nick_Lewis, sberney Review:
	  https://reviewboard.asterisk.org/r/643/

2010-05-04 23:47 +0000 [r261093-261094]  Tilghman Lesher <tlesher@digium.com>

	* main/channel.c: Add a tiny corner case to the previous commit

	* main/channel.c: Protect against overflow, when calculating how
	  long to wait for a frame. (closes issue #17128) Reported by:
	  under Patches: d.diff uploaded by under (license 914)

2010-05-04 18:46 +0000 [r260923]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.c: Voicemail transfer to operator should occur
	  immediately, not after main menu. There were two scenarios in the
	  advanced options that while using the operator=yes and review=yes
	  options, the transfer occurred only after exiting the main menu
	  (after sending a reply or leaving a message for an extension).
	  Now after the audio is processed for the reply or message the
	  transfer occurs immediately as expected. ABE-2107 ABE-2108

2010-05-04 17:40 +0000 [r260887]  tringenbach <tringenbach@localhost>:

	* README-SERIOUSLY.bestpractices.txt: Fix FILTER() examples to work
	  in 1.4 Review: https://reviewboard.asterisk.org/r/644/

2010-05-04 15:49 +0000 [r260801]  Jason Parker <jparker@digium.com>

	* build_tools/make_build_h: Fix fallout from removing from
	  configure script. Pointed out by philipp64 on #asterisk-dev

2010-05-03 16:54 +0000 [r260661-260662]  Paul Belanger <paul.belanger@polybeacon.com>

	* Makefile: Should have removed /usr/lib/ part. Thanks Qwell.

	* Makefile: non-root make install PREFIX=/tmp fails. Prepend libdir
	  when executing mkpkgconfig allowing non-root installs to work.
	  (closes issue #17268) Reported by: pabelanger Patches:
	  issue17268.patch uploaded by pabelanger (license 224) Tested by:
	  pabelanger

2010-05-03 14:57 +0000 [r260569]  Leif Madsen <lmadsen@digium.com>

	* doc/HOWTO_collect_debug_information.txt: Minor typo pointed out
	  by pabelanger on IRC.

2010-04-30 22:22 +0000 [r260434]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Ensure channel state is not incorrectly
	  set in the case of a very early answer. The needringing bit was
	  being read in dahdi_read after answering thereby setting the
	  state to ringing from up. This clears needringing upon answering
	  so that is no longer possible. (closes issue #17067) Reported by:
	  tzafrir Patches: needringing.diff uploaded by tzafrir (license
	  46)

2010-04-30 20:08 +0000 [r260345]  Mark Michelson <mmichelson@digium.com>

	* res/res_musiconhold.c: Fix potential crash from race condition
	  due to accessing channel data without the channel locked. In
	  res_musiconhold.c, there are several places where a channel's
	  stream's existence is checked prior to calling ast_closestream on
	  it. The issue here is that in several cases, the channel was not
	  locked while checking the stream. The result was that if two
	  threads checked the state of the channel's stream at
	  approximately the same time, then there could be a situation
	  where both threads attempt to call ast_closestream on the
	  channel's stream. The result here is that the refcount for the
	  stream would go below 0, resulting in a crash. I have added
	  proper channel locking to res_musiconhold.c to ensure that we do
	  not try to check chan->stream without the channel locked. A
	  Digium customer has been using this patch for several weeks and
	  has not had any crashes since applying the patch. ABE-2147

2010-04-29 22:11 +0000 [r260195]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: DTMF CallerID detection problems. The code
	  handling DTMF CallerID drops digits on long CallerID numbers and
	  may timeout waiting for the first ring with shorter numbers. The
	  DTMF emulation mode was not turned off when processing DTMF
	  CallerID. When the emulation code gets behind in processing the
	  DTMF digits it can skip a digit. For shorter numbers, the timeout
	  may have been too short. I increased it from 2 seconds to 4
	  seconds. Four seconds is a typical time between rings for many
	  countries. (closes issue #16460) Reported by: sum Patches:
	  issue16460.patch uploaded by rmudgett (license 664)
	  issue16460_v1.6.2.patch uploaded by rmudgett (license 664) Tested
	  by: sum, rmudgett Review: https://reviewboard.asterisk.org/r/634/
	  JIRA SWP-562 JIRA AST-334 JIRA SWP-901

2010-04-29 15:31 +0000 [r259858-260049]  David Vossel <dvossel@digium.com>

	* include/asterisk/audiohook.h, main/audiohook.c: Fixes crash in
	  audiohook_write_list The middle_frame in the audiohook_write_list
	  function was being freed if a audiohook manipulator returned a
	  failure. This is incorrect logic. This patch resolves this and
	  adds detailed descriptions of how this function should work and
	  why manipulator failures must be ignored. (closes issue #17052)
	  Reported by: dvossel Tested by: dvossel (closes issue #16196)
	  Reported by: atis Review: https://reviewboard.asterisk.org/r/623/

	* main/channel.c, channels/chan_local.c: resolves deadlocks in
	  chan_local Issue_1. In the local_hangup() 3 locks must be held at
	  the same time... pvt, pvt->chan, and pvt->owner. Proper deadlock
	  avoidance is done when the channel to hangup is the outbound
	  chan_local channel, but when it is not the outbound channel we
	  have an issue... We attempt to do deadlock avoidance only on the
	  tech pvt, when both the tech pvt and the pvt->owner are locked
	  coming into that loop. By never giving up the pvt->owner channel
	  deadlock avoidance is not entirely possible. This patch resolves
	  that by doing deadlock avoidance on both the pvt->owner and the
	  pvt when trying to get the pvt->chan lock. Issue_2. ast_prod() is
	  used in ast_activate_generator() to queue a frame on the channel
	  and make the channel's read function get called. This function is
	  used in ast_activate_generator() while the channel is locked,
	  which mean's the channel will have a lock both from the generator
	  code and the frame_queue code by the time it gets to
	  chan_local.c's local_queue_frame code... local_queue_frame
	  contains some of the same crazy deadlock avoidance that
	  local_hangup requires, and this recursive lock prevents that
	  deadlock avoidance from happening correctly. This patch removes
	  ast_prod() from the channel lock so only one lock is held during
	  the local_queue_frame function. (closes issue #17185) Reported
	  by: schmoozecom Patches: issue_17185_v1.diff uploaded by dvossel
	  (license 671) issue_17185_v2.diff uploaded by dvossel (license
	  671) Tested by: schmoozecom, GameGamer43 Review:
	  https://reviewboard.asterisk.org/r/631/

2010-04-28 21:07 +0000 [r259852]  Leif Madsen <lmadsen@digium.com>

	* config.guess: Update config.guess. Updating config.guess because
	  after installing Ubuntu Server 9.10 and running all the update
	  scripts, running ./configure would not continue because it was
	  unable to determine what kind of system I had. After updating
	  config.guess things started working again.

2010-04-28 20:30 +0000 [r259748-259847]  Jason Parker <jparker@digium.com>

	* configure, configure.ac: Add AC_CONFIG_AUX_DIR to configure
	  script, so systems without install can use install-sh from our
	  source dir.

	* makeopts.in: Missed this when removing $ID

	* Makefile, configure, configure.ac: Remove usage of `id` since it
	  isn't useful and was causing breakge. Solaris `id` doesn't
	  support the -u argument. Instead of figuring out how to fix this
	  to work on Solaris, I decided to check why it was necessary and
	  where else it was used. It was only used in one place, and it
	  hasn't been needed for a very long time (I question whether it
	  was ever needed).

2010-04-28 17:13 +0000 [r259664]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.c: Do not play goodbye prompt after timeout of
	  message review. ABE-2124

2010-04-27 21:53 +0000 [r259531]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: DAHDI "WARNING" message is confusing and
	  vague "WARNING[28406]: chan_dahdi.c:6873 ss_thread: CallerID feed
	  failed: Success" Changed the warning to "Failed to decode
	  CallerID on channel 'name'". The message before it is likely more
	  specific about why the CallerID decode failed. SWP-501 AST-283

2010-04-27 21:48 +0000 [r259526]  Leif Madsen <lmadsen@digium.com>

	* sounds/Makefile: Update sounds files. * Add additional sounds
	  prompts for say_enumeration * Update the English conference
	  sounds prompts so they are better quality and all sound more
	  consistent * Clean up the core-sounds-XX.txt and
	  extra-sounds-XX.txt files to include all present sound files Both
	  core (en, fr, es) and extra (en, fr) sounds files have been
	  updated. (closes issue #16200) Reported by: murf (closes issue
	  #17137) Reported by: lmadsen

2010-04-27 21:15 +0000 [r259352-259441]  Jason Parker <jparker@digium.com>

	* main/editline/configure, main/editline/configure.in: Add gar to
	  the check for AR for those silly OSes (Solaris) that don't have
	  ar.

	* configure, configure.ac: Support the silly OSes that don't have
	  ar and strip. Since AC_PATH_TOOL is equiv to AC_CHECK_TOOL when
	  path isn't specified, and AC_PATH_TOOLS doesn't exist, we'll just
	  switch to AC_CHECK_TOOLS.

2010-04-27 18:14 +0000 [r259270]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, configs/chan_dahdi.conf.sample:
	  hidecalleridname parameter in chan_dahdi.conf Issue #7321
	  implements a new chan_dahdi configuration option. However, a
	  change mentioned in the issue was never implemented. This is the
	  change that will allow the feature to work. I added a note to
	  chan_dahdi.conf.sample about the feature. (closes issue #17143)
	  Reported by: djensen99 Patches: diff.txt uploaded by djensen99
	  (license NA) (One line change) Tested by: djensen99

2010-04-26 21:44 +0000 [r259018-259104]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Let compilation succeed warning-free when
	  DONT_OPTIMIZE is turned off.

	* main/channel.c: Prevent Newchannel manager events for dummy
	  channels. No Newchannel manager event will be fired for channels
	  that are allocated to not match a registered technology type.
	  Thus bogus channels allocated solely for variable substitution or
	  CDR operations do not result in a Newchannel event. (closes issue
	  #16957) Reported by: atis Review:
	  https://reviewboard.asterisk.org/r/601

2010-04-25 18:09 +0000 [r258775]  Tilghman Lesher <tlesher@digium.com>

	* res/res_monitor.c: When StopMonitor is called, ensure that it
	  will not be restarted by a channel event. (closes issue #16590)
	  Reported by: kkm Patches: resmonitor-16590-trunk.239289.diff
	  uploaded by kkm (license 888)

2010-04-22 21:49 +0000 [r258670]  Matthew Nicholson <mnicholson@digium.com>

	* main/cdr.c, main/channel.c, res/res_features.c: Fix broken CDR
	  behavior. This change allows a CDR record previously marked with
	  disposition ANSWERED to be set as BUSY or NO ANSWER. Additionally
	  this change partially reverts r235635 and does not set the
	  AST_CDR_FLAG_ORIGINATED flag on CDRs generated from ast_call().
	  To preserve proper CDR behavior, the AST_CDR_FLAG_DIALED flag is
	  now cleared from all brige CDRs in ast_bridge_call(). (closes
	  issue #16797) Reported by: VarnishedOtter Tested by: mnicholson

2010-04-21 21:45 +0000 [r258432]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.c: Fix looping forever when no input received
	  in certain voicemail menu scenarios. Specifically, prompting for
	  an extension (when leaving or forwarding a message) or when
	  prompting for a digit (when saving a message or changing
	  folders). ABE-2122 SWP-1268

2010-04-20 16:16 +0000 [r257856-258029]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.c: Play correct prompt when voicemail store
	  failure occurs after attempted forward. If a user's mailbox was
	  full and a message was attempted to be forwarded to said box,
	  warnings on the console would indicate failure. However, the
	  played prompt was that of success (vm-msgsaved). Now storage
	  failure is taken into account and the correct prompt
	  (vm-mailboxfull) is played when appropriate. ABE-2123 SWP-1262

	* apps/app_voicemail.c: make app_voicemail compile with
	  IMAP_STORAGE

2010-04-16 21:15 +0000 [r257686]  Dwayne M. Hubbard <dwayne.hubbard@gmail.com>

	* apps/app_mixmonitor.c: Make the mixmonitor thread process audio
	  frames faster Mantis issue 17078 reports MixMonitor recordings
	  have shorter durations than the call duration. This was because
	  the mixmonitor thread was not processing frames from the
	  audiohook fast enough. The mixmonitor thread would slowly fall
	  behind the most recent audio frame and when the channel hangs up,
	  the mixmonitor thread would exit without processing the same
	  number of frames as the channel; leaving the mixmonitor recording
	  shorter than actual call duration. This revision fixes this issue
	  by moving the ast_audiohook_trigger_wait() and the subsequent
	  audiohook.status check into the block where the
	  ast_audiohook_read_frame() function returns NULL. (closes issue
	  #17078) Reported by: geoff2010 Patches: dw-M17078.patch uploaded
	  by dhubbard (license 733) Tested by: dhubbard, geoff2010 Review:
	  https://reviewboard.asterisk.org/r/611/

2010-04-15 21:23 +0000 [r257467-257544]  Tilghman Lesher <tlesher@digium.com>

	* include/asterisk/app.h, main/app.c: Allow application options
	  with arguments to contain parentheses, through a variety of
	  escaping techniques. Fixes SWP-1194 (ABE-2143). Review:
	  https://reviewboard.asterisk.org/r/604/

	* channels/chan_sip.c: Don't recreate peer, when responding to a
	  repeated deregistration attempt. When a reply to a deregistration
	  is lost in transmit, the client retries the deregistration.
	  Previously, this would cause a realtime/autocreate peer to be
	  loaded back into memory, after it had already been correctly
	  purged. Instead, we just want to resend the reply without loading
	  the peer. (closes issue #16908) Reported by: kkm Patches:
	  20100412__issue16908.diff.txt uploaded by tilghman (license 14)
	  Tested by: kkm

2010-04-15 19:40 +0000 [r257342-257426]  Leif Madsen <lmadsen@digium.com>

	* doc/backtrace.txt: Update backtrace.txt documentation. Update the
	  backtrace.txt documentation so it conforms to the same layout as
	  other documents we've been working on recently. Additionally, add
	  a bunch of new information about gathering backtraces for crashes
	  and deadlocks, along with ways of verifying your file before
	  uploading it. Create a couple of one line commands for people to
	  generate the files we need. (closes issue #17190) Reported by:
	  lmadsen Patches: backtrace.txt.patch-2 uploaded by lmadsen
	  (license 10) Tested by: lmadsen, pabelanger

	* doc/backtrace.txt: Update address of the bug tracker.

2010-04-14 23:08 +0000 [r257266]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: When forwarding a message, ensure that
	  prepending works correctly. This is a regression in 1.4, only.
	  (closes issue #17103) Reported by: mglazer Patches:
	  20100408__issue17103.diff.txt uploaded by tilghman (license 14)
	  Tested by: tilghman

2010-04-13 16:46 +0000 [r257070]  Matthew Nicholson <mnicholson@digium.com>

	* main/manager.c, configs/manager.conf.sample: Add an option to
	  restore past broken behavor of the Events manager action Before
	  r238915, certain values for the EventMask parameter of the Events
	  action would result in no response being returned. This patch
	  adds an option to restore that broken behavior. Also while fixing
	  this bug I discovered that passing an empty EventMasks parameter
	  would also result in no response being returned, this has been
	  fixed as well while being preserved when the broken behavior is
	  requested. (closes issue #17023) Reported by: nblasgen Review:
	  https://reviewboard.asterisk.org/r/602/

2010-04-12 17:29 +0000 [r256900]  Leif Madsen <lmadsen@digium.com>

	* doc/HOWTO_collect_debug_information.txt (added): Add How-To
	  document on collecting debugging info for issues.asterisk.org
	  Paul Belanger has been helping a lot with bug tracking recently
	  and created this document that we can now point to when
	  additional debugging information is required. This document will
	  help those filing issues to know how to get the information
	  required when filing their issues. This will make things easier
	  on the developers. Initial text and changes by pabelanger. Tweaks
	  and editing by myself. (closes issue #17159) Reported by:
	  pabelanger Patches: HOWTO_collect_debug_information.txt.patch
	  uploaded by lmadsen (license 10) Tested by: tzafrir, pabelanger,
	  lmadsen

2010-04-06 00:10 +0000 [r256225]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: DAHDI/PRI call to pri_channel_bridge() not
	  protected by PRI lock. SWP-1231 ABE-2163

2010-05-03  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.31 Released

2010-04-29  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.31-rc2 Released

2010-04-29 10:31 +0000 [r260049]  David Vossel <dvossel@digium.com>

	* include/asterisk/audiohook.h, main/audiohook.c: Fixes crash in
	  audiohook_write_list.  (closes issue 0017052) Reported by: dvossel
	  Tested by: dvossel. (closes issue 0016196) Reported by: atis.
	  Review: https://reviewboard.asterisk.org/r/623/

2010-04-28 10:31 +0000 [r259858]  David Vossel <dvossel@digium.com>

	* channels/chan_local.c, main/channel.c: Resolves deadlocks in
	  chan_local.  (closes issue 0017185) Reported by: schmoozecom
	  Patches: issue_17185_v1.diff uploaded by dvossel (license 671)
	  issue_17185_v2.diff uploaded by dvossel (license 671) Tested
	  by: schmoozecom, GameGamer43
	  Review: https://reviewboard.asterisk.org/r/631/

2010-04-05  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.31-rc1 Released

2010-04-02 23:45 +0000 [r256009-256014]  Russell Bryant <russell@digium.com>

	* channels/chan_local.c: Resolve a deadlock that occurs due to a
	  pointless call to ast_bridged_channel() (closes issue #16840)
	  Reported by: bzing2 Patches: patch.txt uploaded by bzing2
	  (license 902) issue_16840.rev1.diff uploaded by russell (license
	  2) Tested by: bzing2, russell

	* main/channel.c: Remove extremely verbose debug message.

2010-03-31 19:09 +0000 [r255591]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Ensure line terminators in email are
	  consistent. Fixes an issue with certain Mail Transport Agents,
	  where attachments are not interpreted correctly. (closes issue
	  #16557) Reported by: jcovert Patches:
	  20100308__issue16557__1.4.diff.txt uploaded by tilghman (license
	  14) 20100308__issue16557__1.6.0.diff.txt uploaded by tilghman
	  (license 14) 20100308__issue16557__trunk.diff.txt uploaded by
	  tilghman (license 14) Tested by: ebroad, zktech Reviewboard:
	  https://reviewboard.asterisk.org/r/544/

2010-03-31 17:42 +0000 [r255503]  Leif Madsen <lmadsen@digium.com>

	* apps/app_dial.c, configs/sip.conf.sample: Add documentation
	  clarifying when 't' and 'T' can be used. (closes issue #17021)
	  Reported by: kovzol Tested by: lmadsen, kovzol, davidw, ebroad

2010-03-30 20:56 +0000 [r255322-255409]  Russell Bryant <russell@digium.com>

	* channels/chan_h323.c: Don't kill Asterisk if the H323 listener
	  does not start.

	* pbx/pbx_dundi.c: Don't make Asterisk not start if pbx_dundi fails
	  to initialize.

2010-03-25 20:41 +0000 [r254714-254800]  Jason Parker <jparker@digium.com>

	* utils/Makefile: Don't remove local copies of utils in uninstall.

	* main/astobj2.c, include/asterisk/astobj2.h: Fix DEBUG_THREADS
	  issue with out-of-tree modules. Take 2, without ABI breakage this
	  time. Review: https://reviewboard.asterisk.org/r/588/

2010-03-25 18:51 +0000 [r254639]  Russell Bryant <russell@digium.com>

	* Makefile, /: Update Asterisk 1.4 to use menuselect trunk. Review:
	  https://reviewboard.asterisk.org/r/590/

2010-03-25 17:33 +0000 [r254452-254552]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/acl.h: Add doxygen for acl.h Review:
	  https://reviewboard.asterisk.org/r/528

	* main/rtp.c: Several fixes regarding RFC2833 DTMF detection. Here
	  is a copy and paste of the details from my request on reviewboard
	  that dealt with these changes: Fix 1. The first change in place
	  is to fix Mantis issue 15811, which deals with a situation where
	  Asterisk will incorrectly interpret out of order RFC2833 frames
	  as duplicate DTMF digits. For instance, we would receive a
	  sequence like: seqno 1: DTMF 1 seqno 2: DTMF 1 seqno 3: DTMF 1
	  seqno 4: DTMF 1 seqno 6: DTMF 1 (end) seqno 5: DTMF 1 seqno 7:
	  DTMF 1 (end) seqno 8: DTMF 1 (end) Prior to this patch when we
	  received the frame with seqno 5, we would interpret this as a new
	  DTMF 1. With this patch, we will check the seqno of the incoming
	  digit and not process the frame if the seqno is lower than the
	  last recorded seqno. Note that we do not record the seqno of the
	  dropped DTMF frame for future processing. While the above
	  situation is what was designed to be fixed, the patch is written
	  in such a way that the following would also be fixed too: seqno
	  9: DTMF 1 seqno 10: DTMF 1 (end) seqno 11: DTMF 1 (end) seqno 13:
	  DTMF 2 seqno 12: DTMF 1 (end) seqno 14: DTMF 2 seqno 15: DTMF 2
	  (end) seqno 16: DTMF 2 (end) seqno 17: DTMF 2 (end) In this
	  second situation, the beginning of the DTMF 2 arrives before the
	  final end frame of the DTMF 1. With the patch, seqno 12 is no
	  processed and thus we properly interpret the DTMF. Fix 2. The
	  second change in place is to fix an issue like the following:
	  seqno 1: DTMF 1 seqno 2: DTMF 1 seqno 3: DTMF 1 (end) *packet
	  lost* seqno 4: DTMF 1 (end) *packet lost* seqno 5: DTMF 1 (end)
	  *packet lost* seqno 6: DTMF 2 When we receive seqno 6, we had
	  code in place that was supposed to properly end the previously
	  unended DTMF 1. The problem was that the code was essentially a
	  no-op. The code would set up an end frame for the DTMF 1 but
	  would immediately overwrite the frame with the begin for DTMF 2.
	  I changed process_dtmf_rfc2833() so that instead of returning a
	  single frame, it is given as an output parameter a list of
	  frames. Each frame that needs to be returned is appended to this
	  list. Fix 3. The final change is a minor one where an
	  AST_CONTROL_SRCCHANGE frame could get lost. If we process a cisco
	  DTMF or an RFC 3389 frame and no frame was returned, then we
	  would return &ast_null_frame. The problem is that earlier in the
	  function, we may have generated an AST_CONTROL_SRCCHANGE frame
	  and put it in the list of frames we wish to return. This frame
	  would be lost in such a case. The patch fixes this problem
	  Review: https://reviewboard.asterisk.org/r/558

2010-03-25 15:57 +0000 [r254451]  Terry Wilson <twilson@digium.com>

	* main/file.c: Handle new SRCCHANGE control message here too

2010-03-24 00:37 +0000 [r254235]  Jeff Peeler <jpeeler@digium.com>

	* res/res_monitor.c: Ensure that monitor recordings are written to
	  the correct location (again) This is an extension to 248860. As
	  such the dialplan test has been extended: ; non absolute path,
	  not combined exten => 5040, 1, monitor(wav,tmp/jeff/monitor_test)
	  exten => 5040, n, dial(sip/5001) ; absolute path, not combined
	  exten => 5041, 1, monitor(wav,/tmp/jeff/monitor_test2) exten =>
	  5041, n, dial(sip/5001) ; no path, not combined exten => 5042, 1,
	  monitor(wav,monitor_test3) exten => 5042, n, dial(sip/5001) ;
	  combined: changemonitor from non absolute to no path (leaves
	  tmp/jeff) exten => 5043, 1, monitor(wav,tmp/jeff/monitor_test4,m)
	  exten => 5043, n, changemonitor(monitor_test5) exten => 5043, n,
	  dial(sip/5001) ; combined: changemonitor from no path to non
	  absolute path exten => 5044, 1, monitor(wav,monitor_test6,m)
	  exten => 5044, n, changemonitor(tmp/jeff/monitor_test7) ; this
	  wasn't possible before exten => 5044, n, dial(sip/5001) ; non
	  absolute path, combined exten => 5045, 1,
	  monitor(wav,tmp/jeff/monitor_test8,m) exten => 5045, n,
	  dial(sip/5001) ; absolute path, combined exten => 5046, 1,
	  monitor(wav,/tmp/jeff/monitor_test9,m) exten => 5046, n,
	  dial(sip/5001) ; no path, combined exten => 5047, 1,
	  monitor(wav,monitor_test10,m) exten => 5047, n, dial(sip/5001) ;
	  combined: changemonitor from non absolute to absolute (leaves
	  tmp/jeff) exten => 5048, 1,
	  monitor(wav,tmp/jeff/monitor_test11,m) exten => 5048, n,
	  changemonitor(/tmp/jeff/monitor_test12) exten => 5048, n,
	  dial(sip/5001) ; combined: changemonitor from absolute to non
	  absolute (leaves /tmp/jeff) exten => 5049, 1,
	  monitor(wav,/tmp/jeff/monitor_test13,m) exten => 5049, n,
	  changemonitor(tmp/jeff/monitor_test14) exten => 5049, n,
	  dial(sip/5001) ; combined: changemonitor from no path to absolute
	  exten => 5050, 1, monitor(wav,monitor_test15,m) exten => 5050, n,
	  changemonitor(/tmp/jeff/monitor_test16) exten => 5050, n,
	  dial(sip/5001) ; combined: changemonitor from absolute to no path
	  (leaves /tmp/jeff) exten => 5051, 1,
	  monitor(wav,/tmp/jeff/monitor_test17,m) exten => 5051, n,
	  changemonitor(monitor_test18) exten => 5051, n, dial(sip/5001) ;
	  not combined: changemonitor from non absolute to no path (leaves
	  tmp/jeff) exten => 5052, 1, monitor(wav,tmp/jeff/monitor_test19)
	  exten => 5052, n, changemonitor(monitor_test20) exten => 5052, n,
	  dial(sip/5001) ; not combined: changemonitor from no path to non
	  absolute exten => 5053, 1, monitor(wav,monitor_test21) exten =>
	  5053, n, changemonitor(tmp/jeff/monitor_test22) exten => 5053, n,
	  dial(sip/5001) ; not combined: changemonitor from non absolute to
	  absolute (leaves tmp/jeff) exten => 5054, 1,
	  monitor(wav,tmp/jeff/monitor_test23) exten => 5054, n,
	  changemonitor(/tmp/jeff/monitor_test24) exten => 5054, n,
	  dial(sip/5001) ; not combined: changemonitor from absolute to non
	  absolute (leaves /tmp/jeff) exten => 5055, 1,
	  monitor(wav,/tmp/jeff/monitor_test24) exten => 5055, n,
	  changemonitor(tmp/jeff/monitor_test25) exten => 5055, n,
	  dial(sip/5001) ; not combined: changemonitor from no path to
	  absolute exten => 5056, 1, monitor(wav,monitor_test26) exten =>
	  5056, n, changemonitor(/tmp/jeff/monitor_test27) exten => 5056,
	  n, dial(sip/5001) ; not combined: changemonitor from absolute to
	  no path (leaves /tmp/jeff) exten => 5057, 1,
	  monitor(wav,/tmp/jeff/monitor_test28) exten => 5057, n,
	  changemonitor(monitor_test29) exten => 5057, n, dial(sip/5001)

2010-03-23 22:45 +0000 [r254046-254161]  Jason Parker <jparker@digium.com>

	* main/astobj2.c, main/lock.c (removed), main/channel.c,
	  main/Makefile, include/asterisk/astobj2.h, UPGRADE.txt,
	  include/asterisk/lock.h: Revert revisions 254046 and 254098.

	* UPGRADE.txt: Add note about the out-of-tree module ABI changes.

	* main/astobj2.c, main/lock.c (added), main/channel.c,
	  main/Makefile, include/asterisk/astobj2.h,
	  include/asterisk/lock.h: Allow out-of-tree modules to load,
	  regardless of DEBUG_THREADS/DEBUG_CHANNEL_LOCKS differences. This
	  can be guaranteed by forcing the ABI to no longer change when
	  these compiler flags are set. An unfortunate side-effect to this
	  is that there is an ABI change here. However, there is some
	  mitigation. Existing modules *will* fail to load since they would
	  require functions that no longer exist. Review:
	  https://reviewboard.asterisk.org/r/508/

2010-03-22 19:50 +0000 [r253799]  Matthew Nicholson <mnicholson@digium.com>

	* res/res_features.c: Unconditionally copy the caller's account
	  code to the called party. (related to issue #16331)

2010-03-21 14:26 +0000 [r253631-253670]  Russell Bryant <russell@digium.com>

	* main/Makefile: Fix final link on FreeBSD by adding the
	  PTHREAD_CFLAGS.

	* main/sched.c, Makefile, apps/app_dial.c, channels/chan_dahdi.c,
	  main/manager.c, res/res_features.c, main/http.c, main/utils.c,
	  pbx/pbx_dundi.c, apps/app_followme.c: Resolve a number of FreeBSD
	  build issues.

2010-03-18 17:57 +0000 [r253252-253349]  Leif Madsen <lmadsen@digium.com>

	* apps/app_userevent.c: Typo found while fixing issue #16961.

	* doc/localchannel.txt: Synchronize text in localchannels.txt and
	  localchannels.tex. (issue #16963)

	* doc/localchannel.txt: Update new Local channel documentation. The
	  original reporter, Kobaz, of an issue with a Local channel that
	  inspired the Local channel documentation provided some tweaks to
	  the documentation after testing what I had written. Hopefully
	  anything that was vague or unclear has been cleaned up by these
	  changes. (closes issue #16963) Reported by: kobaz Patches:
	  localchannel-2.txt uploaded by kobaz (license 834) Tested by:
	  kobaz, lmadsen

2010-03-17 16:25 +0000 [r253158]  Terry Wilson <twilson@digium.com>

	* main/rtp.c, channels/chan_skinny.c, channels/chan_h323.c,
	  channels/chan_mgcp.c, channels/chan_sip.c,
	  include/asterisk/rtp.h: Revert API change in release branches
	  This re-renames ast_rtp_update_source to ast_rtp_new_source

2010-03-17 00:26 +0000 [r253018]  Leif Madsen <lmadsen@digium.com>

	* configs/say.conf.sample: Add french snipset to say.conf. Add the
	  french snipset to say.conf. (Closes issue #15799)

2010-03-16 20:52 +0000 [r252766-252928]  Russell Bryant <russell@digium.com>

	* Makefile.rules: Backport chan_sip build fix for Mac OSX 10.6 from
	  trunk.

	* codecs/gsm/Makefile: Use uname -s, as done in trunk.

	* codecs/gsm/Makefile: Apply codec_gsm Mac OS X 10.6 build fix that
	  is in trunk and 1.6.X.

	* utils/Makefile: Don't treat warnings as errors for muted. muted
	  supports OS X, but uses functions marked as deprecated in 10.6.
	  However, the functions are still supported, so just ignore the
	  warnings for now and allow the build to proceed.

2010-03-16 18:46 +0000 [r252761]  Leif Madsen <lmadsen@digium.com>

	* configs/extensions.ael.sample: Additional extensions.ael global
	  variable fixes. Fixing up a couple more overlapping global
	  variable namespaces shared with extensions.conf.sample. Also
	  noticed a few of the lines that were commented out didn't have
	  the closing semi-colon so I added that as well. (issue #17035)

2010-03-15 21:43 +0000 [r252617]  Tilghman Lesher <tlesher@digium.com>

	* contrib/init.d/org.asterisk.asterisk.plist: Uh, yeah. Umask. I'm
	  stupid.

2010-03-15 20:48 +0000 [r252531-252533]  Leif Madsen <lmadsen@digium.com>

	* configs/extensions.ael.sample: Update extensions.ael file to not
	  overlap extensions.conf. Updated the extensions.ael file so the
	  global variables don't overlap those that we have in
	  extensions.conf (sample files). This way unexpected things won't
	  happed hopefully if both pbx_ael and res_config are loaded.
	  (closes issue #17035) Reported by: pprindeville

	* configure, configs/extensions.ael.sample: Revert last commit that
	  had bad changed to configure.

	* configure, configs/extensions.ael.sample: Update extensions.ael
	  file to not overlap extensions.conf. Updated the extensions.ael
	  file so the global variables don't overlap those that we have in
	  extensions.conf (sample files). This way unexpected things won't
	  happed hopefully if both pbx_ael and res_config are loaded.
	  (closes issue #17035) Reported by: pprindeville

2010-03-15 01:39 +0000 [r252361-252366]  Tilghman Lesher <tlesher@digium.com>

	* Makefile: Typo

	* main/asterisk.c, Makefile,
	  contrib/init.d/org.asterisk.asterisk.plist (added): Launch
	  Asterisk on Mac OS X with launchd. Reviewboard:
	  https://reviewboard.asterisk.org/r/551/

2010-03-13 00:30 +0000 [r252175]  Terry Wilson <twilson@digium.com>

	* main/rtp.c, channels/chan_mgcp.c, main/channel.c,
	  channels/chan_sip.c, channels/chan_skinny.c,
	  include/asterisk/rtp.h, channels/chan_h323.c,
	  configs/sip.conf.sample, include/asterisk/frame.h: Merged
	  revisions 252089 via svnmerge from
	  https://origsvn.digium.com/svn/asterisk/trunk ........ r252089 |
	  twilson | 2010-03-12 16:04:51 -0600 (Fri, 12 Mar 2010) | 20 lines
	  Only change the RTP ssrc when we see that it has changed This
	  change basically reverts the change reviewed in
	  https://reviewboard.asterisk.org/r/374/ and instead limits the
	  updating of the RTP synchronization source to only those times
	  when we detect that the other side of the conversation has
	  changed the ssrc. The problem is that SRCUPDATE control frames
	  are sent many times where we don't want a new ssrc, including
	  whenever Asterisk has to send DTMF in a normal bridge. This is
	  also not the first time that this mistake has been made. The
	  initial implementation of the ast_rtp_new_source function also
	  changed the ssrc--and then it was removed because of this same
	  issue. Then, we put it back in again to fix a different issue.
	  This patch attempts to only change the ssrc when we see that the
	  other side of the conversation has changed the ssrc. It also
	  renames some functions to make their purpose more clear. Review:
	  https://reviewboard.asterisk.org/r/540/ ........

2010-03-12 19:58 +0000 [r251986-251997]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Forward declaring dahdi_pri was already
	  done.

	* channels/chan_dahdi.c: Make chan_dahdi wakeup_sub() prototype not
	  conditional.

2010-03-11  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.30 released

2010-03-04  Leif Madsen <lmadsen@digium.com>

	* Asterisk 1.4.30-rc3 released

2010-03-03 21:28 +0000 [r250613]  Leif Madsen <lmadsen@digium.com>

	* doc/localchannel.txt: Update existing Local channel
	  documentation. A complete re-write of the Local channel
	  documentation has been performed, with the existing information
	  from localchannel.txt and localchannel.tex merged in. (issue
	  #16637) Reported by: kobaz Patches: localchannel.tex uploaded by
	  lmadsen (license 10) localchannel.txt uploaded by lmadsen
	  (license 10) Tested by: lmadsen, jsmith, mmichelson

2010-03-03 19:04 +0000 [r250480]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Make sure to clear red alarm after
	  polarity reversal. From the issue: The automatic overnight line
	  tests (or manual ones) used on UK (BT) lines causes a red alarm
	  on a dahdi / TDM400P connected channel. This is because the line
	  uses voltage tests (battery loss) and polarity reversal. The
	  polarity reversal causes chan_dahdi to initiate v23 CallerID
	  processing but during this the event DAHDI_EVENT_NOALARM is
	  ignored so that the alarm is never cleared. (closes issue #14163)
	  Reported by: jedi98 Patches: chan_dahdi-1.4-inalarm.diff uploaded
	  by jedi98 (license 653) Tested by: mattbrown, Chainsaw,
	  mikeeccleston

2010-03-03 18:02 +0000 [r250394]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: fixes problem with duplicate TXREQ packets
	  When Asterisk receives an IAX2 TXREQ packet, try_transfer() will
	  call store_by_transfercallno() to link the chan_iax2_pvt struct
	  into iax_transfercallno_pvts. If a duplicate TXREQ packet is
	  received for the same call, the pvt struct will be linked into
	  iax_transfercallno_pvts multiple times. This patch fixes this.
	  Thanks rain for debugging this and providing a patch! (closes
	  issue #16904) Reported by: rain Patches:
	  iax2-double-txreq-fix.diff uploaded by rain (license 327) Tested
	  by: rain, dvossel

2010-03-02 21:08 +0000 [r250041-250050]  Leif Madsen <lmadsen@digium.com>

	* doc/imapstorage.txt: Update IMAP documentation. Update the IMAP
	  documentation to make it clear that storing voicemails in the
	  same folder as a large number of emails could potentially cause
	  significant slow downs when writing or retrieving voicemails.
	  (closes issue #16704) Reported by: TimeHider Tested by: lmadsen,
	  TimeHider

	* configs/cdr.conf.sample: Update documentation to clarify purpose
	  of unanswered option. (closes issue #16267) Reported by: elsto
	  Patches: cdr.conf.sample.patch.txt uploaded by lmadsen (license
	  10) Tested by: davidw, elsto

	* doc/configuration.txt: Update documentation to not imply we
	  support overriding options. (issue #16855) Reported by: davidw

2010-03-02 19:36 +0000 [r249845-249946]  Alec L Davis <sivad.a@paradise.net.nz>

	* apps/app_echo.c: revert ability to exit echo app caused a
	  regression, as only supported VOICE, not VIDEO etc. Left in small
	  formatting change. (issue #16880)

	* apps/app_echo.c: fixes ability to exit echo app when called from
	  a ISDN channel, null frames prevent '#' exit. Now only echo back
	  VOICE and DTMF frames (issue #16880) Reported by: alecdavis
	  Patches: based on echo_exit_1-6-1.diff.txt uploaded by alecdavis
	  (license 585) Tested by: alecdavis

2010-03-01 19:35 +0000 [r249671]  Sean Bright <sean@malleable.com>

	* apps/app_voicemail.c: Fix crash in app_voicemail related to
	  message counting. We were passing a 'struct inprocess **' and
	  treating it like a 'struct inprocess *' causing a segfault.
	  (closes issue #16921) Reported by: whardier Patches:
	  20100301_issue16921.patch uploaded by seanbright (license 71)
	  Tested by: whardier

2010-03-01 17:02 +0000 [r249536]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_local.c: Modify queued frames from local channels
	  to not set the other side to up In this case, attended transfers
	  were broken due to ast_feature_request_and_dial detecting the
	  channel being set to up before the answer frame could be read and
	  therefore failing to mark the channel as ready. This fix is a
	  regression fix for 244785, which should continue to work properly
	  as well. (closes issue #16816) Reported by: jamhed Tested by:
	  jamhed, corruptor

2010-02-27 23:51 +0000 [r249365]  Alec L Davis <sivad.a@paradise.net.nz>

	* channels/chan_dahdi.c: overlap receiving: automatically send CALL
	  PROCEEDING when dialplan starts Following Q.931 5.2.4 When the
	  user has determined that sufficient call information has been
	  received the user shall stop T302 and send CALL PROCEEDING to the
	  network. Previously timeouts were possible if the dialplan took a
	  long time to issue any response back to the network. Verified
	  that our local TELCO also does the same. (issue #16789) Reported
	  by: alecdavis Patches: based on overlap_receiving_trunk.diff.txt
	  uploaded by alecdavis (license 585) Tested by: alecdavis (closes
	  issue #16789)

2010-02-27 14:07 +0000 [r249234]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_iax2.c: add a reference to the now-published IAX2
	  RFC

2010-02-26 17:04 +0000 [r249100]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: For T.38 reINVITEs treat a 606 the same as a
	  488. (closes issue #16792) Reported by: vrban Patches:
	  t38_606.patch uploaded by vrban (license 756)

2010-02-25 21:22 +0000 [r248860]  Jeff Peeler <jpeeler@digium.com>

	* res/res_monitor.c: Ensure that monitor recordings are written to
	  the correct location (again) This is an extension to 248757. As
	  such the dialplan test has been extended: exten => 5040, 1,
	  monitor(wav,tmp/jeff/monitor_test,b) exten => 5040, n,
	  dial(sip/5001) exten => 5041, 1,
	  monitor(wav,/tmp/jeff/monitor_test2,b) exten => 5041, n,
	  dial(sip/5001) exten => 5042, 1, monitor(wav,monitor_test3,b)
	  exten => 5042, n, dial(sip/5001) exten => 5043, 1,
	  monitor(wav,tmp/jeff/monitor_test3,m) exten => 5043, n,
	  changemonitor(monitor_test4) exten => 5043, n, dial(sip/5001)
	  exten => 5044, 1, monitor(wav,monitor_test4,m) exten => 5044, n,
	  changemonitor(tmp/jeff/monitor_test5) ; this looks to fail by
	  design and emits a warning exten => 5044, n, dial(sip/5001)

2010-02-25 21:21 +0000 [r248859]  Tilghman Lesher <tlesher@digium.com>

	* main/asterisk.c: Some platforms clear /var/run at boot, which
	  makes connecting a remote console... difficult. Previously, we
	  only created the default /var/run/asterisk directory at install
	  time. While we could create it in the init script, that would not
	  work for those who start asterisk manually from the command line.
	  So the safest thing to do is to create it as part of the Asterisk
	  boot process. This also changes the ownership of the directory,
	  because the pid and ctl files are created after we setuid/setgid.
	  (closes issue #16802) Reported by: Brian Patches:
	  20100224__issue16802.diff.txt uploaded by tilghman (license 14)
	  Tested by: tzafrir

2010-02-25 18:06 +0000 [r248668-248757]  Jeff Peeler <jpeeler@digium.com>

	* res/res_monitor.c: Ensure that monitor recordings are written to
	  the correct location. Recordings should be placed in the monitor
	  directory when a non-absolute path is used. Exact dialplan used
	  for testing: exten => 5040, 1,
	  monitor(wav,tmp/jeff/monitor_test,b) exten => 5040, n,
	  dial(sip/5001) exten => 5041, 1,
	  monitor(wav,/tmp/jeff/monitor_test2,b) exten => 5041, n,
	  dial(sip/5001) exten => 5042, 1, monitor(wav,monitor_test3,b)
	  exten => 5042, n, dial(sip/5001) ABE-2101

	* apps/app_voicemail.c: Make deletion of temporary greetings work
	  properly with IMAP_STORAGE This same patch was merged in 220833,
	  but was skipped in this branch erroneously. (closes issue #16170)
	  Reported by: francesco_r

2010-02-24 21:02 +0000 [r248582]  Tilghman Lesher <tlesher@digium.com>

	* main/logger.c: Remove color code sequences from verbose messages
	  that go to logfiles. (closes issue #16786) Reported by: dodo
	  Patches: logger2.patch uploaded by dodo (license 989) Tested by:
	  tilghman

2010-02-23 16:26 +0000 [r248396]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: fixes invite with replaces deadlock (closes
	  issue #16862) Reported by: pwalker Patches: replaces_deadlock_1.4
	  uploaded by dvossel (license 671) Tested by: pwalker, dvossel

2010-02-22 13:52 +0000 [r248268]  Olle Johansson <oej@edvina.net>

	* apps/app_meetme.c: Don't log to debug unless debug is turned on

2010-02-20 22:25 +0000 [r248106]  Olle Johansson <oej@edvina.net>

	* main/rtp.c: Make sure we support RTCP compound messages with zero
	  reports

2010-02-19 19:11 +0000 [r248012]  Tilghman Lesher <tlesher@digium.com>

	* main/loader.c, /: Backport crash fix from trunk to 1.4, whereby
	  'core show gracefully' could crash Asterisk. (closes issue
	  #16470) Reported by: kjotte

2010-02-19 17:18 +0000 [r247910]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c: Merged revision 247904 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.2-...
	  .......... r247904 | rmudgett | 2010-02-19 10:49:44 -0600 (Fri,
	  19 Feb 2010) | 49 lines Make chan_misdn DTMF processing
	  consistent with other channel technologies. The processing of
	  DTMF tones on the receiving side of an ISDN channel is
	  inconsistent with the way it is handled in other channels,
	  especially DAHDI analog. This causes DTMF tones sent from an ISDN
	  phone to be doubled at the connected party. We are using the
	  following 2 options of misdn.conf 1) astdtmf=yes 2) senddtmf=yes
	  Option one is necessary because the asterisk DSP DTMF detection
	  is better than mISDN's internal DSP. Not as many false positives.
	  Option two is necessary to transmit DTMF tones end to end when
	  mISDN channels are connected to SIP channels with out of band
	  DTMF for example. The symptom is that DTMF tones sent by an ISDN
	  phone are doubled on the way through asterisk when two mISDN
	  channels are connected with a Local channel in between or if it
	  is bridged to an analog channel. The doubling of DTMF tones is
	  because DTMF is passed inband to asterisk by the mISDN channel
	  and passed out of band once again after the release of the DTMF
	  tone. Passing it inband is wrong. Neither an analog channel nor
	  SIP channel passes DTMF inband if configured to inband DTMF.
	  Analog and SIP channels filter out the DTMF tones because they
	  use the voice frames returned by ast_dsp_process. But chan_misdn
	  passes the unfiltered input voice frames instead. To overcome one
	  aspect of the problem, the doubling of DTMF tones when two mISDN
	  channels are directly bridged, someone made an 'optimization',
	  where in that case the DTMF tone passed out-of-band to the peer
	  channel is not translated to an inband tone at the transmit side.
	  This optimization is bad because it does not work in general. For
	  example, analog channels or mISDN channels when bridged through
	  an intermediary local channel will generate DTMF tones from
	  out-of-band information. Also, of course, it must not be done
	  when there is no inband DTMF available. This patch fixes the
	  issue. Now chan_misdn will filter the received inband DTMF signal
	  the same as other channel types. Another change included: No need
	  to build an extra translation path because ast_process_dsp does
	  it if required. Patches: misdn-dtmf.patch JIRA ABE-2080

2010-02-18 19:38 +0000 [r247651]  Matthew Nicholson <mnicholson@digium.com>

	* res/res_features.c: Copy the calling party's account code to the
	  called party if they don't already have one. (closes issue
	  #16331) Reported by: bluefox Tested by: mnicholson

2010-02-18 16:53 +0000 [r247502-247508]  Leif Madsen <lmadsen@digium.com>

	* README-SERIOUSLY.bestpractices.txt: Add additional link to best
	  practices document per jsmith.

	* README-SERIOUSLY.bestpractices.txt (added): Add best practices
	  documentation. (issue #16808) Reported by: lmadsen (issue #16810)
	  Reported by: Nick_Lewis Tested by: lmadsen Review:
	  https://reviewboard.asterisk.org/r/507/

2010-02-18 04:19 +0000 [r247422]  Russell Bryant <russell@digium.com>

	* Makefile, sounds/Makefile: Tweak argument handling for wget in
	  the sounds Makefile. 1) Fix the check to see if we are using wget
	  to not be full of fail. The configure script populates this
	  variable with the absolute path to wget if it is found, so it
	  didn't work. 2) Allow some extra arguments to be passed in for
	  wget. This is just a simple change to allow our Bamboo build
	  script to tell wget to be quiet and not fill up our logs with
	  download status output.

2010-02-17 16:24 +0000 [r247168]  Mark Michelson <mmichelson@digium.com>

	* apps/app_queue.c: Make sure that when autofill is disabled that
	  callers not in the front of the queue cannot place calls. (closes
	  issue #16834) Reported by: kebl0155 Patches:
	  app_queue_no_autofill.v1.patch uploaded by kebl0155 (license 356)

2010-02-15 23:42 +0000 [r246709]  Tilghman Lesher <tlesher@digium.com>

	* Makefile: Make the menuselect instructions correct by allowing
	  'make menuselect' to actually solve dependency problems.
	  (Previously, it would fail out again with the same message about
	  running 'make menuselect', which was NOT at all helpful.)

2010-02-12 23:30 +0000 [r246545]  David Vossel <dvossel@digium.com>

	* main/channel.c: lock channel during datastore removal On channel
	  destruction the channel's datastores are removed and destroyed.
	  Since there are public API calls to find and remove datastores on
	  a channel, a lock should be held whenever datastores are removed
	  and destroyed. This resolves a crash caused by a race condition
	  in app_chanspy.c. (closes issue #16678) Reported by:
	  tim_ringenbach Patches: datastore_destroy_race.diff uploaded by
	  tim ringenbach (license 540) Tested by: dvossel

2010-02-12 18:52 +0000 [r246460]  Jason Parker <jparker@digium.com>

	* main/channel.c: Fix some silly formatting, and remove unnecessary
	  option_debug checks

2010-02-10 17:44 +0000 [r246115]  David Vossel <dvossel@digium.com>

	* apps/app_queue.c: fixes random deadlock in app_queue with
	  use_weight during reload (closes issue #16677) Reported by:
	  tim_ringenbach Patches: app_queue_use_weight_deadlock.diff
	  uploaded by tim ringenbach (license 540)

2010-02-10 13:37 +0000 [r245944]  Tilghman Lesher <tlesher@digium.com>

	* configs/extensions.conf.sample: Include examples of FILTER usage
	  in extension patterns where a "." may be a risk.

2010-02-10 08:24 +0000 [r245909]  Olle Johansson <oej@edvina.net>

	* res/res_smdi.c: Make sure that res_smdi loads regardless of
	  configuration, since chan_dahdi depends on res_smdi

2010-02-09 22:55 +0000 [r245792]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: Fixes iaxs and iaxsl size off by one issue.
	  2^15 = 32768 which is the maximum allowed iax2 callnumber.
	  Creating the iaxs and iaxsl array of size 32768 means the maximum
	  callnumber is actually out of bounds. This causes a nasty crash.
	  (closes issue #15997) Reported by: exarv Patches: iax_fix.diff
	  uploaded by dvossel (license 671)

2010-02-08 20:39 +0000 [r245496]  Jason Parker <jparker@digium.com>

	* main/ast_expr2.fl, main/ast_expr2f.c: Remove reference of
	  documentation in source directory. People don't always build
	  Asterisk from source (distro packages, anybody?).

2010-02-08 11:57 +0000 [r245422]  Olle Johansson <oej@edvina.net>

	* res/res_features.c: Res_features depends on res_adsi in 1.4

2010-02-05 18:32 +0000 [r245044]  Kevin P. Fleming <kpfleming@digium.com>

	* contrib/firmware (removed), LICENSE: Remove contrib/firmware
	  directory as it is empty Remove explicit license for IAXy
	  firmware as it is no longer included in the tree

2010-02-05 17:03 +0000 [r244926]  Sean Bright <sean@malleable.com>

	* main/asterisk.c: Update main copyright date.

2010-02-04 23:20 +0000 [r244785]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_local.c: Change channel state on local channels for
	  busy,answer,ring. Previously local channels channel state never
	  changed. This became problematic when the state of the other side
	  of the local channel was lost, for example during a masquerade.
	  Changing the state of the local channel allows for the scenario
	  to be detected when the channel state is set to ringing, but the
	  peer isn't ringing. The specific problem scenario is described in
	  164201. Although this was noted on one of the issues, here is the
	  tested dialplan verified to work: exten =>
	  9700,1,Dial(Local/*9700@default&Local/#9700@default) exten =>
	  *9700,1,Set(GLOBAL(TESTCHAN)=${CHANNEL:0:${MATH(${LEN(${CHANNEL})}-1):0:2}}1)
	  exten => *9700,n,wait(3) ;3 works, 1 did not exten =>
	  *9700,n,Dial(SIP/5001) exten => #9700,1,Wait(1) ;1 works, 3 did
	  not exten =>
	  #9700,n,ChannelRedirect(${TESTCHAN},parkedcalls,701,1) (closes
	  issue #14992) Reported by: davidw

2010-02-01 23:13 +0000 [r244070-244242]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Backup and restore original textfile, for
	  prosthesis (gerund of prepend). Also, fix menuselect such that
	  changing voicemail build options correctly causes rebuild.
	  (closes issue #16415) Reported by: tomo1657 Patches:
	  prepention.patch uploaded by tomo1657 (license 484) (with
	  modifications by me to backport to 1.4)

	* res/res_features.c: When a transferer hangs up during an attended
	  transfer BEFORE the transfer is answered, don't stop playing MOH.
	  (closes issue #16513) Reported by: litnimax Patches:
	  atxfer_moh_16513.patch uploaded by gknispel proformatique
	  (license 261) Tested by: litnimax

	* main/channel.c, channels/chan_local.c: Revert previous chan_local
	  fix (r236981) and fix instead by destroying expired frames in the
	  queue. (closes issue #16525) Reported by: kobaz Patches:
	  20100126__issue16525.diff.txt uploaded by tilghman (license 14)
	  20100129__issue16525__1.6.0.diff.txt uploaded by tilghman
	  (license 14) Tested by: kobaz, atis (closes issue #16581)
	  Reported by: ZX81 (closes issue #16681) Reported by: alexr1

2010-01-28 18:48 +0000 [r243862-243863]  Leif Madsen <lmadsen@digium.com>

	* BUGS: Oops, correct wrong link (https vs. http) in previous
	  commit.

	* BUGS: Update location of bug tracker in documentation.

2010-01-28 15:03 +0000 [r243779]  Russell Bryant <russell@digium.com>

	* channels/chan_sip.c: Fix a bogus third argument to
	  ast_copy_string().

2010-01-27 20:35 +0000 [r243570-243691]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_queue.c: Revert 243570, I should have looked at this
	  closer. Will reopen the issue, but am leaving the review closed
	  as the change was pointless. (issue #16488)

	* apps/app_queue.c: Extend announcement URL used with Queue from 80
	  chars to PATH_MAX. (closes issue #16488) Reported by: syspert
	  Patches: soundfilelen.pacth-2 uploaded by syspert (license 938)
	  Review: https://reviewboard.asterisk.org/r/475/

2010-01-27 18:06 +0000 [r243486]  Mark Michelson <mmichelson@digium.com>

	* main/pbx.c: Use a safe list traversal while checking for
	  duplicate vars in pbx_builtin_setvar_helper.

2010-01-26 23:55 +0000 [r243390]  David Vossel <dvossel@digium.com>

	* res/res_features.c: fixes bug with channel receiving wrong
	  privileges after call parking (closes issue #16429) Reported by:
	  Yasuhiro Konishi Patches: features.c.diff uploaded by Yasuhiro
	  Konishi (license 947) Tested by: dvossel

2010-01-26 18:19 +0000 [r243258]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c: Remove unnecessary code in ast_read as issue
	  16058 has been fully solved now.

2010-01-25 21:50 +0000 [r242852-242969]  Tilghman Lesher <tlesher@digium.com>

	* main/Makefile, pbx/Makefile: Err, and use the new menuselect
	  define, too.

	* build_tools/cflags.xml, build_tools/menuselect-deps.in,
	  configure, configure.ac: Only rebuild parsers by an option in
	  menuselect

	* configure, main/Makefile, configure.ac, pbx/Makefile: Restore
	  FreeBSD to able-to-compile-ish-mode

2010-01-25 20:08 +0000 [r242850-242851]  Olle Johansson <oej@edvina.net>

	* main/manager.c: Remove debugging that indeed should have been
	  gone before commit. Sorry.

	* main/manager.c: Report error when writing to functions returns
	  error in AMI setvar action

2010-01-25 05:42 +0000 [r242520-242728]  Tilghman Lesher <tlesher@digium.com>

	* main/Makefile, pbx/Makefile: Buildbot pointed out an error
	  (thanks, buildbot!)

	* main/Makefile, pbx/Makefile: Oops, should have used CMD_PREFIX,
	  not ECHO_PREFIX, for the commands.

	* main/Makefile: Make the build of the Asterisk expression parser
	  match that of the AEL parser.

	* configure, include/asterisk/autoconfig.h.in, configure.ac,
	  pbx/ael/ael_lex.c, pbx/Makefile, makeopts.in: Only rebuild bison
	  and flex source files on demand, if bison and flex are detected
	  by the configure script. Changed after discussion on the -dev
	  list about possible unnecessary build failures, due to
	  checkouts/untars causing these special source files to possibly
	  be newer than their resulting C files. This should additionally
	  ensure that nobody need learn about extra Makefile arguments to
	  ensure the proper files get rebuilt when changes are made to
	  these special source files.

2010-01-22 21:44 +0000 [r242423]  Tilghman Lesher <tlesher@digium.com>

	* pbx/Makefile: Rebuild from flex, bison sources when necessary.
	  (issue #14629) Reported by: Marquis Patches:
	  20100121__issue14629.diff.txt uploaded by tilghman (license 14)

2010-01-22 09:19 +0000 [r242226]  Olle Johansson <oej@edvina.net>

	* channels/chan_sip.c: Initialize notify_types to NULL

2010-01-22 01:48 +0000 [r242142]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/cdr.c: Add Dialed Number Identifier (DNID) field to cdr.
	  Branch support, retains ABI, if backend CDR collector is adaptive
	  then database requires 'dnid' field to be added, otherwise no
	  functional changes. Reported by: alecdavis Tested by: alecdavis
	  Patch cdr_dnid.diff2.txt uploaded by alecdavis (license 585)
	  Review: https://reviewboard.asterisk.org/r/455/

2010-01-21 15:25 +0000 [r241932]  Sean Bright <sean@malleable.com>

	* configure, configure.ac: Fix configure check for
	  PTHREAD_ONCE_INIT when manually adding -Wall to CFLAGS. (closes
	  issue #16666) Reported by: romain_proformatique

2010-01-21 05:53 +0000 [r241765]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_math.c: Guard against division by zero.

2010-01-20 20:00 +0000 [r241626]  David Vossel <dvossel@digium.com>

	* Makefile: fixes parsing error in Makefile. Some echo lines were
	  missing "; . Thanks to jparker for pointing out the problem.

2010-01-20 14:12 +0000 [r241543-241544]  Sean Bright <sean@malleable.com>

	* pbx/pbx_spool.c: Modify fix for issue 16554 to be more inline
	  with what is already in trunk. I should have taken a closer look
	  at trunk/1.6.x, as this bug has already been fixed in a much more
	  simple manner, by just settings o->vars to NULL after the
	  ast_pbx_outgoing_* calls. (issue #16554) Reported by: mav3rick

	* pbx/pbx_spool.c: Fix a memory leak in pbx_spool when using SetVar
	  in a call file. In pbx_spool, when we are freeing our 'outgoing'
	  struct, we weren't deallocating the ast_variable list we had
	  built from SetVars in a call file. Adding a call to
	  ast_variables_destroy in our deallocation routine works, but only
	  if the variables have not already been passed into
	  ast_pbx_outgoing_app() or _exten(), both of which take care of
	  destroying the variable list for us. (closes issue #16554)
	  Reported by: mav3rick Patches: issue16554_20100119.patch uploaded
	  by seanbright (license 71) Tested by: mav3rick

2010-01-20 09:38 +0000 [r241458]  Alec L Davis <sivad.a@paradise.net.nz>

	* main/pbx.c: Update CDR variables as pbx starts Allows CDR
	  variables added in cdr.c:set_one_cid to become visable during the
	  call, by executing ast_cdr_update() early in __ast_pbx_run. Based
	  on cdr_update.diff3.txt (issue #16638) Reported by: alecdavis
	  Patches: cdr_update.diff3.txt uploaded by alecdavis (license 585)
	  Tested by: alecdavis

2010-01-19 17:41 +0000 [r241228]  Jason Parker <jparker@digium.com>

	* Makefile: Allow parallel make (-j) to work properly. 1.4 changes
	  are quite different from the others. (issue #16489) Reported by:
	  Chainsaw Tested by: qwell

2010-01-19 17:22 +0000 [r241227]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_agent.c: Fix deadlock in agent_read by removing
	  call to agent_logoff. One must always lock the agents list lock
	  before the agent private. agent_read locks the private
	  immediately, so locking the agents list lock is not an option
	  (which is what agent_logoff requires). Because agent_read already
	  has access to the agent private all that is necessary is to do
	  the required hanging up that agent_logoff performed. (closes
	  issue #16321) Reported by: valon24 Patches: bug16321.patch
	  uploaded by jpeeler (license 325)

2010-01-18 19:54 +0000 [r241015]  Sean Bright <sean@malleable.com>

	* main/config.c: Plug a memory leak when reading configs with their
	  comments. While reading through configuration files with the
	  intent of returning their full contents (comments specifically)
	  we allocated some memory and then forgot to free it. This doesn't
	  fix 16554 but clears up a leak I had in the lab. (issue #16554)
	  Reported by: mav3rick Patches: issue16554_20100118.patch uploaded
	  by seanbright (license 71) Tested by: seanbright

2010-01-18 16:51 +0000 [r240891]  David Vossel <dvossel@digium.com>

	* Makefile: updated transmit_silence option documentation in
	  asterisk.conf This patch updates the transmit_silence option to
	  better document why the option exists, and what it affects.
	  Thanks to russell for providing the verbage for this update.

2010-01-18 13:27 +0000 [r240768]  Olle Johansson <oej@edvina.net>

	* utils/Makefile: Fix muted compilation in 1.4 only

2010-01-15 23:06 +0000 [r240547]  Russell Bryant <russell@digium.com>

	* Makefile: Fix a spelling error in the asterisk.conf sample.

2010-01-15 20:52 +0000 [r240414]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Disallow leaving more than maxmsg
	  voicemails. This is a possibility because our previous method
	  assumed that no messages are left in parallel, which is not a
	  safe assumption. Due to the vmu structure duplication, it was
	  necessary to track in-process messages via a separate structure.
	  If at some point, we switch vmu to an ao2-reference-counted
	  structure, which would eliminate the prior noted duplication of
	  structures, then we could incorporate this new in-process
	  structure directly into vmu. (closes issue #16271) Reported by:
	  sohosys Patches: 20100108__issue16271.diff.txt uploaded by
	  tilghman (license 14) 20100108__issue16271__trunk.diff.txt
	  uploaded by tilghman (license 14)
	  20100108__issue16271__1.6.0.diff.txt uploaded by tilghman
	  (license 14) Tested by: jsutton

2010-01-14  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.29

2010-01-08  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.29-rc1

2010-01-07 20:14 +0000 [r238409-238411]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: fixes crash in "scheduled_destroy" in
	  chan_iax A signed short was used to represent a callnumber. This
	  is makes it possible to attempt to access the iaxs array with a
	  negative index. (closes issue #16565) Reported by: jensvb

	* channels/chan_sip.c: Change in sip show channels display format
	  allowing more digits for CID (closes issue 0016459) Reported by:
	  Rzadzins Patches: chan_sip_longer_cid.patch uploaded by Rzadzins
	  (license 953)

2010-01-06 21:41 +0000 [r238230]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_cdr.c: Revise documentation on disposition values to
	  the actual values used. (closes issue #16289) Reported by:
	  wdoekes

2010-01-06 15:18 +0000 [r237697-238009]  Russell Bryant <russell@digium.com>

	* apps/app_mp3.c: Resolve a crash due to an ast_frame not being
	  fully initialized. (closes issue #16531) Reported by: john8675309
	  (closes SWP-615)

	* main/utils.c: Change a NOTICE log message to DEBUG where it
	  belongs. (closes issue #16479) Reported by: alexrecarey (closes
	  SWP-577)

2010-01-04 21:45 +0000 [r237318-237573]  Tilghman Lesher <tlesher@digium.com>

	* main/say.c: Bounds checking for input string (closes issue
	  #16407) Reported by: qwell Patches: 20100104__issue16407.diff.txt
	  uploaded by tilghman (license 14)

	* main/pbx.c: Regression in issue #15421 - Pattern matching (closes
	  issue #16482) Reported by: wdoekes Patches:
	  astsvn-16482-betterfix.diff uploaded by wdoekes (license 717)
	  20091223__issue16482.diff.txt uploaded by tilghman (license 14)
	  Tested by: wdoekes, tilghman

	* main/pbx.c, res/res_agi.c, include/asterisk/channel.h: Add a flag
	  to disable the Background behavior, for AGI users. This is in a
	  section of code that relates to two other issues, namely issue
	  #14011 and issue #14940), one of which was the behavior of
	  Background when called with a context argument that matched the
	  current context. This fix broke FreePBX, however, in a post-Dial
	  situation. Needless to say, this is an extremely difficult
	  collision of several different issues. While the use of an
	  exception flag is ugly, fixing all of the issues linked is rather
	  difficult (although if someone would like to propose a better
	  solution, we're happy to entertain that suggestion). (closes
	  issue #16434) Reported by: rickead2000 Patches:
	  20091217__issue16434.diff.txt uploaded by tilghman (license 14)
	  20091222__issue16434__1.6.1.diff.txt uploaded by tilghman
	  (license 14) Tested by: rickead2000

	* channels/chan_local.c: It's also possible for the Local channel
	  to directly execute an Application. Reviewboard:
	  https://reviewboard.asterisk.org/r/452/

2010-01-02 09:52 +0000 [r237135]  Olle Johansson <oej@edvina.net>

	* channels/chan_sip.c: Release memory of the contact acl before
	  unloading module

2009-12-30 21:57 +0000 [r236981]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_local.c: Don't queue frames to channels that have
	  no means to process them. (closes issue #15609) Reported by:
	  aragon Patches:
	  20091230__issue16521__1.4__chan_local_only.diff.txt uploaded by
	  tilghman (license 14) Tested by: aragon Review:
	  https://reviewboard.asterisk.org/r/452/

2009-12-30 20:25 +0000 [r236890]  Jeff Peeler <jpeeler@digium.com>

	* utils/astman.c: Remove conflicting function definitions
	  (asterisk.h) so LOW_MEMORY compiles.

2009-12-28 15:12 +0000 [r236509-236585]  Sean Bright <sean@malleable.com>

	* include/asterisk/threadstorage.h, configure,
	  include/asterisk/autoconfig.h.in, configure.ac: Try a test
	  compile to see if PTHREAD_ONCE_INIT requires extra braces. There
	  was conditional code (based on build platform) to optioinally
	  wrap PTHREAD_ONCE_INIT in braces that was removed since it is
	  fixed in newer versions of Solaris/OpenSolaris, but I am still
	  running into it on Solaris 10 x86 so add a configure-time check
	  for it.

	* apps/app_meetme.c: Avoid a crash with large numbers of MeetMe
	  conferences. Similar to changes made to Queue(), when we have
	  large numbers of conferences in meetme.conf (1000s) and we use
	  alloca()/strdupa(), we can blow out the stack and crash, so
	  instead just use a single fixed buffer. (closes issue #16509)
	  Reported by: Kashif Raza Patches: 20091223_16509.patch uploaded
	  by seanbright (license 71) Tested by: seanbright

2009-12-27 18:19 +0000 [r236433]  Tilghman Lesher <tlesher@digium.com>

	* contrib/init.d/rc.debian.asterisk: Turn on colors in the daemon,
	  since there's many requests for it on Ubuntu.

2009-12-26 15:26 +0000 [r236357]  Kevin P. Fleming <kpfleming@digium.com>

	* sounds/Makefile: update to latest releases with zero uid/gid

2009-12-23 15:21 +0000 [r236261]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Properly set T.38 attributes and don't
	  return before T.38 ports are configured when T.38 is found but no
	  audio stream is found. (closes issue #16318) Reported by:
	  bird_of_Luck Patches: t38-sdp-parsing-fix3.diff uploaded by
	  mnicholson (license 96), written by vrban and mnicholson Tested
	  by: vrban, mihaill

2009-12-23 02:55 +0000 [r236184]  Tilghman Lesher <tlesher@digium.com>

	* res/res_agi.c: If EXEC only gets a single argument, don't crash
	  when the second is used. (closes issue #16504) Reported by:
	  bklang

2009-12-22 16:58 +0000 [r236062]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: fixes issue with p->method incorrectly set
	  to ACK It is possible for a second ACK to come in for a
	  retransmitted message. If an ack does not match an unacked
	  message in our queue, restore the previous p->method as this ACK
	  is completely ignored. (closes issue #16295) Reported by:
	  omolenkamp Patches: issue16295_v2.diff uploaded by dvossel
	  (license 671)

2009-12-21 19:43 +0000 [r235940]  Jeff Peeler <jpeeler@digium.com>

	* res/res_monitor.c: Change Monitor to not assume file to write to
	  does not contain pathing. 227944 changed the fname_base argument
	  to always append the configured monitor path. This change was
	  necessary to properly compare files for uniqueness. If a full
	  path is given though, nothing needs to be appended and that is
	  handled correctly now. (closes issue #16377) (closes issue
	  #16376) Reported by: bcnit Patches:
	  res_monitor.c-issue16376-1.patch uploaded by dant (license 670)

2009-12-21 16:45 +0000 [r235821]  Tilghman Lesher <tlesher@digium.com>

	* res/res_features.c: Send parking lot announcement to the channel
	  which parked the call, not the park-ee. (closes issue #16234)
	  Reported by: yeshuawatso Patches: 20091210__issue16234.diff.txt
	  uploaded by tilghman (license 14)
	  20091221__issue16234__1.4.diff.txt uploaded by tilghman (license
	  14) Tested by: yeshuawatso

2009-12-18 22:39 +0000 [r235652]  Tilghman Lesher <tlesher@digium.com>

	* configure, configure.ac: Revise verbiage, per #asterisk-dev
	  discussion

2009-12-18 22:29 +0000 [r235635]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c, include/asterisk/cdr.h: Correct CDR dispositions
	  for BUSY/FAILED This patch is simple in that it reorders the
	  disposition defines so that the fix for issue 12946 works
	  properly (the default CDR disposition was changed to
	  AST_CDR_NOANSWER). Also, the AST_CDR_FLAG_ORIGINATED flag was set
	  in ast_call to ensure all CDR records are written. The side
	  effects of CDR changes are scary, so I'm documenting the test
	  cases performed to attempt to catch any regressions. The
	  following tests were all performed using 1.4 rev 195881 vs head
	  (235571) + patch: A calls B C calls B (busy) Hangup C Hangup A
	  (Both SIP and features) A calls B A blind transfers to C Hangup C
	  (Both SIP and features) A calls B A attended transfers to C
	  Hangup C A calls B A attended transfers to C (SIP) C blind
	  transfers to A (features) Hangup A All of the test scenario CDRs
	  matched. The following tests were performed just with the patch
	  to ensure proper operation (with unanswered=yes): exten
	  =>s,1,Answer exten =>s,n,ResetCDR(w) exten =>s,n,ResetCDR(w)
	  exten =>s,1,ResetCDR(w) exten =>s,n,ResetCDR(w) (closes issue
	  #16180) Reported by: aatef Patches: bug16180.patch uploaded by
	  jpeeler (license 325)

2009-12-18 21:18 +0000 [r235572]  Tilghman Lesher <tlesher@digium.com>

	* configure, configure.ac: Point to the typical missing package,
	  not the cryptic "termcap support".

2009-12-17  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.28

2009-12-09  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.28-rc1

2009-12-09 19:58 +0000 [r233782-233879]  Russell Bryant <russell@digium.com>

	* main/loader.c: Fix breakage of the "module load <module>" CLI
	  command.

	* main/loader.c, formats/format_ilbc.c, formats/format_vox.c,
	  include/asterisk/module.h, formats/format_pcm.c,
	  formats/format_h263.c, formats/format_g723.c,
	  formats/format_h264.c, formats/format_jpeg.c,
	  formats/format_g726.c, formats/format_gsm.c,
	  formats/format_g729.c, formats/format_sln.c,
	  formats/format_wav.c, formats/format_ogg_vorbis.c,
	  formats/format_wav_gsm.c: Set a module load priority for format
	  modules. A recent change to app_voicemail made it such that the
	  module now assumes that all format modules are available while
	  processing voicemail configuration. However, when autoloading
	  modules, it was possible that app_voicemail was loaded before the
	  format modules. Since format modules don't depend on anything,
	  set a module load priority on them to ensure that they get loaded
	  first when autoloading. This version of the patch is specific to
	  Asterisk 1.4 and 1.6.0. These versions did not already support
	  module load priority in the module API. This adds a trivial
	  version of this which is just a module flag to include it in a
	  pass before loading "everything". Thanks to mmichelson for the
	  review! (closes issue #16412) Reported by: jiddings Tested by:
	  russell Review: https://reviewboard.asterisk.org/r/445/

2009-12-08 00:02 +0000 [r233618]  Atis Lezdins <atis@iq-labs.net>

	* contrib/valgrind.supp: Merged revisions 233577 via svnmerge from
	  https://origsvn.digium.com/svn/asterisk/trunk ........ r233577 |
	  atis | 2009-12-08 01:10:13 +0200 (Tue, 08 Dec 2009) | 8 lines Fix
	  compatibility with valgrind 3.3 and older. (noticed in issue
	  #16388) Reported by: parisioa Patches: valgrind.supp uloaded by
	  atis (license 242) Tested by: atis, parisioa ........

2009-12-07 23:24 +0000 [r233471-233609]  David Vossel <dvossel@digium.com>

	* main/utils.c: hex escape control and non 7-bit clean characters
	  in uri_encode In ast_uri_encode, non 7-bit clean characters were
	  being hex escaped correctly, but control characters were not.
	  (issue #16299)

	* channels/chan_sip.c: fixes missing Contact header angle brackets
	  (closes issue #16298) Reported by: mgernoth Patches:
	  reg_parse_issue_1.4.diff uploaded by dvossel (license 671) Tested
	  by: dvossel

2009-12-07 16:11 +0000 [r233392]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Allow SDP packets with only video session
	  information. (closes issue #16387) Reported by: zalex1953 Tested
	  by: mnicholson, zalex1953

2009-12-04 21:54 +0000 [r233116-233279]  David Vossel <dvossel@digium.com>

	* configs/iax.conf.sample: clarify requirecalltoken option in
	  iax.sample.conf (closes issue #16223) Reported by: bklang
	  Patches: clarify-iax-requirecalltoken.patch uploaded by bklang
	  (license 919)

	* apps/app_voicemail.c: document and rename strip_control() in
	  app_voicemail (closes issue #16291) Reported by: wdoekes

2009-12-04 17:12 +0000 [r233092]  Russell Bryant <russell@digium.com>

	* main/channel.c: Only do frame payload check for HOLD frames. This
	  code was added for helping to debug the source of invalid HOLD
	  frames. However, a side effect of this is that it will
	  incorrectly report errors for frames that have an integer
	  payload. Make the check for this block specific to the HOLD frame
	  case.

2009-12-04 16:59 +0000 [r233014-233091]  Matthias Nick <mnick@digium.com>

	* pbx/pbx_config.c: Parse global variables or expressions in hint
	  extensions Parse global variables or expressions in hint
	  extensions. Like: exten => 400,hint,DAHDI/i2/${GLOBAL(var)}
	  (closes issue #16166) Reported by: rmudgett Tested by: mnick,
	  rmudgett

	* main/dsp.c: Warning message gets displayed only once Added
	  additional field 'int display_inband_dtmf_warning', which when
	  set to '1' displays the warning ('Inband DTMF is not supported on
	  codec %s. Use RFC2833'), and when set to '0' doesn't display the
	  warning. Otherwise you would get hundreds of warnings every
	  second. (closes issue #15769) Reported by: falves11 Patches:
	  patch_15769_14.txt uploaded by mnick (license 874) Tested by:
	  mnick, falves11

2009-12-03 20:10 +0000 [r232820]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Deprecate "cz" in favor of "cs". Also,
	  change the use of language codes so that language registers as a
	  prefix, rather than an exact match. (closes issue #16272)
	  Reported by: patrol-cz Patches: 20091203__issue16272.diff.txt
	  uploaded by tilghman (license 14)

2009-12-02 21:57 +0000 [r232581]  Jeff Peeler <jpeeler@digium.com>

	* main/manager.c: Send ack (response/message) after receiving
	  manager action userevent (closes issue #16264) Reported by: dimas
	  Patches: event-ack.patch uploaded by dimas (license 88)

2009-12-02 19:03 +0000 [r232444]  David Vossel <dvossel@digium.com>

	* apps/app_queue.c: fixes app_queue ao2 error (closes issue #16369)
	  Reported by: vrban Patches: queue_issue_1.4.diff uploaded by
	  dvossel (license 671) Tested by: dvossel

2009-12-02 17:04 +0000 [r232355]  Joshua Colp <jcolp@digium.com>

	* apps/app_amd.c: Fix a bug where if you hung up very quickly after
	  calling AMD it would overwrite the AMDSTATUS of HANGUP with
	  TOOLONG. (closes issue #16239) Reported by: CGMChris

2009-12-02 16:59 +0000 [r232268-232350]  David Vossel <dvossel@digium.com>

	* main/acl.c: ast_outaddrfor doesn't do htons() on port, looks odd
	  in strace. (closes issue #16290) Reported by: wdoekes

	* funcs/func_groupcount.c: fixes segfault in func_groupcount closes
	  issue #16337) Reported by: Parantido Patches: issue_16337.diff
	  uploaded by dvossel (license 671) Tested by: Parantido, dvossel

2009-12-02 04:05 +0000 [r232165]  Terry Wilson <twilson@digium.com>

	* main/channel.c: Fix compiling without devmode (closes issue
	  #16367) Reported by: falves11

2009-12-02 00:42 +0000 [r232090]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Do not modify the gain settings on data
	  calls. (The digital flag actually represents a data call.)
	  (closes issue #15972) Reported by: udosw Patches:
	  transcap_digital_fix.diff.txt uploaded by alecdavis (license 585)
	  Tested by: alecdavis

2009-12-01 23:25 +0000 [r232007]  Russell Bryant <russell@digium.com>

	* main/file.c: Fix a warning pointed out by buildbot.

2009-12-01 21:52 +0000 [r231911-231926]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c: log channel name in dev mode as well

	* main/channel.c: Fix crash with invalid frame data The crash was
	  happening as a result of a frame containing an invalid data
	  pointer, but was set with data length of zero. The few times the
	  issue was reproduced it _seemed_ that the frame was queued
	  properly, that is the data pointer was set to NULL. I never could
	  reproduce the crash so as a last resort the crash has been fixed,
	  but a check in __ast_read has been added to give as much
	  information about the source of problematic frames in the future.
	  (closes issue #16058) Reported by: atis

2009-12-01 21:14 +0000 [r231853]  David Vossel <dvossel@digium.com>

	* main/pbx.c: WaitExten m option with no parameters generates frame
	  with zero datalen but non-null data ptr

2009-12-01 15:34 +0000 [r231614-231740]  Matthew Nicholson <mnicholson@digium.com>

	* main/file.c: Ignore unknown formats in ast_format_str_reduce()
	  and return an error if no know formats are found.

	* apps/app_voicemail.c, include/asterisk/file.h, main/file.c,
	  main/app.c: Remove duplicate entries from voicemail format lists.
	  This prevents app_voicemail from entering an infinite loop when
	  the same format is specified twice in the format list. (closes
	  issue #15625) Reported by: Shagg63 Tested by: mnicholson Review:
	  https://reviewboard.asterisk.org/r/429/

2009-11-30 17:14 +0000 [r231437-231441]  David Vossel <dvossel@digium.com>

	* main/rtp.c: fixes crash caused by RTP comfort noise payload
	  greater than 24 bytes AST-2009-010 (closes issue #16242) Reported
	  by: amorsen Patches: issue16242.diff uploaded by oej (license
	  306) Tested by: amorsen, oej, dvossel

	* apps/app_queue.c: app_queue crashes randomly, often during
	  call-transfers In app_queue, it is possible for a call_queue to
	  be destroyed while another object still holds a pointer to it.
	  This patch converts call_queue objects to ao2 objects allowing
	  them to be ref counted. This makes it safe for the queue_ent
	  object in queue_exec() to reference it's parent call_queue even
	  after it has left the queue. (closes issue #15686) Reported by:
	  Hatrix Patches: v2_queue_ao2.diff uploaded by dvossel (license
	  671) Tested by: dvossel, aragon Review:
	  https://reviewboard.asterisk.org/r/427/

2009-11-25 22:31 +0000 [r231298]  Tilghman Lesher <tlesher@digium.com>

	* main/channel.c: After a frame duplication failure, unlock the
	  channel before returning.

2009-11-25 21:38 +0000 [r231233-231235]  David Vossel <dvossel@digium.com>

	* apps/app_dial.c: fixes solaris segfault on dial with verbosity >=
	  3 (closes issue #16193) Reported by: asgaroth Patches:
	  bug_16193_1.4.21.2_vers.diff uploaded by snuffy (license 35)
	  Tested by: asgaroth, snuffy

	* channels/chan_sip.c: fixes conditional jump or move depending on
	  uninitialised STACK value (closes issue #16261) Reported by:
	  edguy3 Patches: edguy16261.patch uploaded by edguy3 (license 917)

2009-11-23 15:31 +0000 [r230772-230875]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_sip.c: When 'sip set debug' is enabled, and the
	  last line of an incoming SIP message is not properly newline
	  terminated, ensure that that line is included in the debug
	  output. (part of issue #16268)

	* main/editline/makelist.in, channels/chan_sip.c,
	  channels/ring_tone.h, channels/busy_tone.h: Correct fix for issue
	  #16268... the reporter's original patch was very close to
	  correct.

	* channels/chan_sip.c: Ensure that SDP parsing does not ignore the
	  last line of the SDP. (closes issue #16268) Reported by: sgimeno

2009-11-20 20:53 +0000 [r230627]  Matthew Nicholson <mnicholson@digium.com>

	* res/res_features.c: Copy the peer CDR's userfield to the bridge
	  CDR if it exists. This is necessary for the recordagentcalls
	  option in chan_agent to store the recorded file name in the
	  bridge CDR. (closes issue #14590) Reported by: msetim Patches:
	  queue_agent_userfield.patch uploaded by Laureano (license 265)
	  Tested by: Laureano, mnicholson

2009-11-19 21:22 +0000 [r230508]  David Vossel <dvossel@digium.com>

	* apps/app_mixmonitor.c: fixes MixMonitor thread not exiting when
	  StopMixMonitor is used (closes issue #16152) Reported by: AlexMS
	  Patches: stopmixmonitor_1.4.diff uploaded by dvossel (license
	  671) Tested by: dvossel, AlexMS Review:
	  https://reviewboard.asterisk.org/r/424/

2009-11-19 16:09 +0000 [r230469]  Michiel van Baak <michiel@vanbaak.info>

	* main/asterisk.c: Update copyright year in visible output. (cli)
	  Spotted by Stuart Henderson

2009-11-30  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27.1

	* AST-2009-010

	* SDP parser regression fix (issue #16268)

2009-11-18  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27

2009-11-13  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27-rc5

2009-11-12 16:41 +0000 [r229669]  David Vossel <dvossel@digium.com>

	* funcs/func_audiohookinherit.c: fixes merging error, datastore was
	  being freed in the wrong function. (closes issue #16219) Reported
	  by: aragon

2009-11-11 19:46 +0000 [r229498]  David Brooks <dbrooks@digium.com>

	* main/pbx.c: Solaris doesn't like NULL going to ast_log Solaris
	  will crash if NULL is passed to ast_log. This simple patch simply
	  uses S_OR to get around this. (closes issue #15392) Reported by:
	  yrashk

2009-11-10 22:09 +0000 [r229360]  Tilghman Lesher <tlesher@digium.com>

	* main/pbx.c: If two pattern classes start with the same digit and
	  have the same number of characters, they will compare equal. The
	  example given in the issue report is that of [234] and [246],
	  which have these characteristics, yet they are clearly not
	  equivalent. The code still uses these two characteristics, yet
	  when the two scores compare equal, an additional check will be
	  done to compare all characters within the class to verify
	  equality. (closes issue #15421) Reported by: jsmith Patches:
	  20091109__issue15421__2.diff.txt uploaded by tilghman (license
	  14) Tested by: jsmith, thedavidfactor

2009-11-10 21:45 +0000 [r229355]  David Ruggles <thedavidfactor@gmail.com>

	* doc/externalivr.txt: Fix ExternalIVR Documentation Remove
	  documentation for event that doesn't function (closes issue
	  #16220) Reported by: thedavidfactor Patches:
	  externalivr.txt.20091110.1622.patch uploaded by thedavidfactor
	  (license 903)

2009-11-10 20:03 +0000 [r229281]  Joshua Colp <jcolp@digium.com>

	* codecs/codec_g726.c: Remove broken support for direct transcoding
	  between G.726 RFC3551 and G.726 AAL2. On some systems the
	  translation core would actually consider g726aal2 -> g726 ->
	  signed linear to be a quicker path then g726aal2 -> signed linear
	  which exposed this problem. (closes issue #15504) Reported by:
	  globalnetinc

2009-11-10 17:23 +0000 [r229191]  David Ruggles <thedavidfactor@gmail.com>

	* doc/externalivr.txt: Document ExternalIVR event tag collision
	  ExternalIVR uses the D tag for two different event types. This
	  documents that behavior and how to differentiate between the two
	  cases. Also includes a minor spelling fix and clarification
	  (closes issue #16211) Reported by: thedavidfactor Patches:
	  externalivr.txt.20091109.1507.patch uploaded by thedavidfactor
	  (license 903)

2009-11-10 17:15 +0000 [r229167]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: don't crash on log message in solaris
	  AST-2009-006 (closes issue #16206) Reported by: bklang Tested by:
	  bklang

2009-11-10 15:22 +0000 [r229091]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Reverted revision 202022. (closes issue
	  #16175) Reported by: paul-tg

2009-11-09  Leif Madsen <lmadsen@digium.com>

	* Release Astersik 1.4.27-rc4

2009-11-09 15:37 +0000 [r228896]  Leif Madsen <lmadsen@digium.com>

	* main/channel.c: Update WARNING message. Update a WARNING message
	  to give a suggested fix when encountered. (closes issue #16198)
	  Reported by: atis Tested by: atis

2009-11-09 14:16 +0000 [r228827]  Matthew Nicholson <mnicholson@digium.com>

	* include/asterisk/lock.h: Perform limited bounds checking when
	  destroying ast_mutex_t structures to make sure we don't try to
	  use negative indices. (closes issue #15588) Reported by: zerohalo
	  Patches: 20090820__issue15588.diff.txt uploaded by tilghman
	  (license 14) Tested by: zerohalo

2009-11-06 22:33 +0000 [r228692]  David Vossel <dvossel@digium.com>

	* main/channel.c: fixes audiohook write crash occuring in chan_spy
	  whisper mode. After writing to the audiohook list in ast_write(),
	  frames were being freed incorrectly. Under certain conditions
	  this resulted in a double free crash. (closes issue #16133)
	  Reported by: wetwired (closes issue #16045) Reported by:
	  bluecrow76 Patches: issue16045.diff uploaded by dvossel (license
	  671) Tested by: bluecrow76, dvossel, habile

2009-11-06 18:32 +0000 [r228547]  Joshua Colp <jcolp@digium.com>

	* channels/chan_sip.c: Don't overwrite caller ID name on a trunk
	  with the configured fullname when using users.conf (issue
	  ABE-1989)

2009-11-06  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27-rc3

2009-11-06 17:07 +0000 [r228418]  David Vossel <dvossel@digium.com>

	* codecs/codec_ilbc.c: fixes segfault in iLBC For reasons not yet
	  known, it appears possible for an ast_frame to have a datalen
	  greater than zero while the actual data is NULL during Packet
	  Loss Concealment. Most codecs don't support PLC so this doesn't
	  affect them. This patch catches the malformed frame and prevents
	  the crash from occuring. Additional efforts to determine why it
	  is possible for a frame to look like this are still being
	  investigated. (issue #16979)

2009-11-06 16:41 +0000 [r228409]  Joshua Colp <jcolp@digium.com>

	* main/abstract_jb.c: Fix a bug caused by a partially invalid frame
	  (from the jitterbuffer) passing through the Asterisk core.
	  (closes issue #15560) Reported by: jvandal (closes issue #15709)
	  Reported by: covici

2009-11-06 16:26 +0000 [r228378]  Matthew Nicholson <mnicholson@digium.com>

	* funcs/func_base64.c, main/utils.c: Properly handle '=' while
	  decoding base64 messages and null terminate strings returned from
	  BASE64_DECODE. (closes issue #15271) Reported by: chappell
	  Patches: base64_fix.patch uploaded by chappell (license 8) Tested
	  by: kobaz

2009-11-06 15:41 +0000 [r228272-228338]  David Vossel <dvossel@digium.com>

	* main/astfd.c: fixes crash in astfd.c (closes issue #15981)
	  Reported by: slavon

	* funcs/func_audiohookinherit.c: fixes memory leak in
	  func_audiohookinherit.c (closes issue 0015394) Reported by:
	  boroda Patches: bug15394_memoryleak_diff2.txt uploaded by dbrooks
	  (license 790) Tested by: dbrooks, boroda

2009-11-05 19:14 +0000 [r228079]  Jason Parker <jparker@digium.com>

	* channels/chan_vpb.cc: Fix crash on VPB exception when no hardware
	  is present. (closes issue #14970) Reported by: tzafrir Patches:
	  vpb_exception.diff uploaded by tzafrir (license 46) Tested by:
	  markwaters

2009-11-05 18:59 +0000 [r228078]  David Brooks <dbrooks@digium.com>

	* channels/chan_misdn.c: chan_misdn Asterisk 1.4.27-rc2 crash Crash
	  related to chan_misdn connection. Patch submitted by
	  gknispel_proformatique, tested by francesco_r. "I have many crash
	  since i have upgraded to Asterisk 1.4.27-rc2. Attached a full
	  bt." This patch zeros out an ast_frame. (closes issue #16041)
	  Reported by: francesco_r

2009-11-04 23:47 +0000 [r227944]  Jeff Peeler <jpeeler@digium.com>

	* res/res_monitor.c: Fix incorrect filename comparsion after
	  monitor file change The logic to detect if a requested file is
	  indeed a different file from the current file was incorrect. The
	  main issue being confusion of the use of filename_base which was
	  previously set without pathing information and then compared to
	  another full path. Robust file comparison logic has been added to
	  properly check if two files are the same even if symlinks are
	  used. (closes issue #15313) Reported by: caspy Patches:
	  20091103__issue15313__1.4.diff.txt uploaded by jpeeler (license
	  325) but mostly tilghman's work

2009-11-04 20:52 +0000 [r227758-227827]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_dial.c: This patch modifies the Dial application to
	  monitor the calling channel for hangups while playing back
	  announcements. (closes issue #16005) Reported by: falves11
	  Patches: dial-announce-hangup-fix1.diff uploaded by mnicholson
	  (license 96) Tested by: mnicholson, falves11 Review:
	  https://reviewboard.asterisk.org/r/407/

	* channels/chan_sip.c: Modify the SDP parsing code to parse session
	  and media level items separately. With the new code, media level
	  proprieties should no longer be confused with session level
	  proprieties. This change also reorganizes some of the SDP parsing
	  code which should make it easier to manage in the future. (closes
	  issue #14994) Reported by: frawd Tested by: frawd, mnicholson,
	  file Review: https://reviewboard.asterisk.org/r/385/

2009-11-04 19:25 +0000 [r227700-227735]  Joshua Colp <jcolp@digium.com>

	* static-http/prototype.js: Fix a security issue where it may be
	  possible for someone to execute a cross-site AJAX request
	  exploit. (AST-2009-009)

	* channels/chan_sip.c: Fix a security issue where sending a
	  REGISTER with a differing username in the From URI and
	  Authorization header would reveal whether it was valid or not.
	  (AST-2009-008)

2009-11-03 17:55 +0000 [r227275]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Make sure the outgoing flag is cleared if
	  a new channel fails to get created for outgoing calls. This is
	  the relevant portion of asterisk/trunk -r226648

2009-11-03 15:36 +0000 [r227166]  Joshua Colp <jcolp@digium.com>

	* channels/chan_sip.c: Fix a bug where an RPID header could be
	  generated with a blank username in the URI. (closes issue #15909)
	  Reported by: kobaz

2009-11-03 10:48 +0000 [r227088-227090]  Olle Johansson <oej@edvina.net>

	* channels/chan_sip.c: Fixing bug before someone reports it...

	* channels/chan_sip.c: Adding IP address in Contact ACL log message
	  and removing redundant message (based on kpfleming's feedback)

	* channels/chan_sip.c: Use proper response code when violating
	  Contact ACL's. Review: https://reviewboard.asterisk.org/r/415/
	  Thanks kpfleming for a quick review. (EDVX-003)

2009-11-02 20:52 +0000 [r226972]  David Brooks <dbrooks@digium.com>

	* channels/chan_sip.c: SIP channel name uniqueness SIP channel
	  names were supposed to be unique by way of a name suffix derived
	  from the pointer to the channel's private data. Uniqueness was
	  preserved on 32-bit systems, but not on 64-bit systems. This
	  patch, as suggested by kpfleming, replaces this suffix with a
	  simple incremented unsigned int. (closes issue #15152) Reported
	  by: palbrecht Review: https://reviewboard.asterisk.org/r/420/

2009-11-02 18:08 +0000 [r226889]  Joshua Colp <jcolp@digium.com>

	* apps/app_dial.c: Fix a bug where the recorded privacy
	  introduction file would not get removed if the caller hung up
	  while the called party had not yet answered. This was fixed by
	  introducing an argument to the 'n' option which, when enabled,
	  removes the introduction file under all scenarios. This was done
	  to preserve the behavior that has existed for quite some time.
	  (closes issue #14674) Reported by: ulogic Patches: bug14674.patch
	  uploaded by jpeeler (license 325)

2009-11-02 17:14 +0000 [r226811]  Tilghman Lesher <tlesher@digium.com>

	* contrib/init.d/rc.redhat.asterisk: Don't allow two separate
	  instances of safe_asterisk when restarting from the init script.
	  (closes issue #14562) Reported by: davidw Patches: Initially
	  20091022__issue14562.diff.txt uploaded by tilghman (license 14)
	  Modified to 20091030__Issue14562_diff.txt uploaded by davidw
	  (license 780) Tested by: davidw

2009-11-02 15:31 +0000 [r226688-226736]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: fixes crash on iterator_destroy on
	  uninitialized iterator (closes issue #16162) Reported by: krn

	* channels/chan_iax2.c: changes calltoken debug messages from
	  LOG_NOTICE to LOG_DEBUG like they are supposed to be (closes
	  issue #16144) Reported by: aragon

2009-10-29 18:11 +0000 [r226531]  Joshua Colp <jcolp@digium.com>

	* channels/chan_local.c, doc/localchannel.txt: Add an option to
	  enabling passing music on hold start and stop requests through
	  instead of acting on them in chan_local. (closes issue #14709)
	  Reported by: dimas

2009-10-28 20:06 +0000 [r226377-226382]  Leif Madsen <lmadsen@digium.com>

	* configs/sip.conf.sample: Update documentation in sip.conf.sample.
	  Update the documentation in sip.conf.sample in order to make it
	  more clear that directmedia/canreinvite do not cause Asterisk to
	  ignore reINVITEs. It is only used to stop Asterisk from
	  generating a reINVITE, but does not stop it from accepting them
	  if necessary. (closes issue #15644) Reported by: lmadsen

	* doc/channelvariables.txt: Update CALLINGSUBADDR channel variable
	  documentation. (closes issue #15734) Reported by: alecdavis
	  Patches: channelvariables.tex.diff.txt uploaded by alecdavis
	  (license 585) Tested by: alecdavis

2009-10-28 18:02 +0000 [r226138-226304]  Tilghman Lesher <tlesher@digium.com>

	* include/asterisk/linkedlists.h: Fix documentation (pointed out by
	  TheDavidFactor on #-dev)

	* main/manager.c: Manager output is not always NULL-terminated, so
	  force a NULL at the end of the filestream. (closes issue #15495)
	  Reported by: pdf Patches: 20090916__issue15495.diff.txt uploaded
	  by tilghman (license 14) Tested by: pdf

2009-10-26 22:13 +0000 [r225957]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* configure, include/asterisk/autoconfig.h.in, configure.ac: detect
	  ARM Linux EABI OSARCH as linux-gnu instead of linux-gnueabi * Set
	  OSARCH to linux-gnu even if host_os is linux-gnueabi * When
	  checking if we are Linux, check OSARCH rather than host_os The
	  newer ARM ABI ("EABI") shows the OS name 'linux-gnueabi' rather
	  than 'linux-gnu' . This patch sets OSARCH to be 'linux-gnu' even
	  in such a case. OSARCH is tested for the value of 'linux-gnu' in
	  one or two places in the tree. This patch also fixes the check
	  libcap to check for $OSARCH rather than $host_os . See also:
	  http://wiki.debian.org/ArmEabiPort

2009-10-23 14:00 +0000 [r225581]  Kevin P. Fleming <kpfleming@digium.com>

	* Makefile: Don't force menuselect.makeopts to be rebuilt on every
	  build. For some reason the menuselect.makeopts file was listed as
	  PHONY in the Makefile, resulting in 'make' needing to rebuild it
	  for every build. This then resulted in the embedded module rules
	  being rebuilt on every build, which can be slow and is
	  unnecessary. This patch fixes the problem by properly allowing
	  'make' to know when the menuselect.makeopts file needs to be
	  rebuilt (defining the proper dependencies).

2009-10-22 21:51 +0000 [r225484]  Leif Madsen <lmadsen@digium.com>

	* doc/valgrind.txt, contrib/valgrind.supp (added): Clean valgrind
	  output by suppressing false errors. Update valgrind.txt
	  documentation and add valgrind.supp file in order to allow those
	  who are creating valgrind output to have less false errors in the
	  logfile. (closes issue #16007) Reported by: atis Patches:
	  valgrind.txt.diff uploaded by atis (license 242) asterisk2.supp
	  uploaded by atis (license 242) Tested by: atis, amorsen

2009-10-21 20:58 +0000 [r225243]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: IAX2: VNAK loop caused by signaling frames
	  with no destination call number It is possible for the PBX thread
	  to queue up signaling frames before a destination call number is
	  received. This can result in signaling frames being sent out with
	  no destination call number. Since recent versions of Asterisk
	  require accurate destination callnumbers for all Full Frames,
	  this can cause a VNAK loop to occur. To resolve this no signaling
	  frames are sent until a destination callnumber is received, and
	  destination call numbers are now only required for iax_pvt
	  matching when the frame is an ACK. Review:
	  https://reviewboard.asterisk.org/r/413/

2009-10-21 16:44 +0000 [r225169-225171]  Russell Bryant <russell@digium.com>

	* main/translate.c: Revert 225169, as this doesn't account for the
	  possibility of a list of frames.

	* main/translate.c: Isolate the frame returned from
	  ast_translate().

2009-10-21 16:02 +0000 [r225103-225105]  Tilghman Lesher <tlesher@digium.com>

	* main/pbx.c, apps/app_meetme.c, include/asterisk/channel.h: Fix
	  documentation for ast_softhangup() and correct the misuse
	  thereof. (closes issue #16103) Reported by: majorbloodnok

	* apps/app_voicemail.c: Suffix is not needed for a match

2009-10-21 14:37 +0000 [r225032]  David Vossel <dvossel@digium.com>

	* configs/iax.conf.sample, channels/chan_sip.c,
	  configs/sip.conf.sample, channels/chan_iax2.c: IAX/SIP
	  shrinkcallerid option The shrinking of caller id removes '(', '
	  ', ')', non-trailing '.', and '-' from the string. This means
	  values such as 555.5555 and test-test result in 555555 and
	  testtest. There are instances, such as Skype integration, where a
	  specific value is passed via caller id that must be preserved
	  unmodified. This patch makes the shrinking of caller id optional
	  in chan_sip and chan_iax in order to support such cases. By
	  default this option is on to preserve previous expected behavior.
	  (closes issue #15940) Reported by: dimas Patches: v2-15940.patch
	  uploaded by dimas (license 88) 15940_shrinkcallerid_trunk.c
	  uploaded by dvossel (license 671) Tested by: dvossel Review:
	  https://reviewboard.asterisk.org/r/408/

2009-10-21 02:59 +0000 [r224931]  Russell Bryant <russell@digium.com>

	* include/asterisk/translate.h, main/dsp.c, main/frame.c,
	  main/translate.c, include/asterisk/dsp.h, codecs/codec_dahdi.c,
	  include/asterisk/frame.h: Isolate frames returned from a DSP
	  instance or codec translator. The reasoning for these changes are
	  the same as what I wrote in the commit message for rev 222878.

2009-10-20 22:07 +0000 [r224855]  Tilghman Lesher <tlesher@digium.com>

	* main/audiohook.c: Pay attention to the return value of the
	  manipulate function. While this looks like an optimization, it
	  prevents a crash from occurring when used with certain audiohook
	  callbacks (diagnosed with SVN trunk, backported to 1.4 to keep
	  the source consistent across versions).

2009-10-20 17:46 +0000 [r224773]  Joshua Colp <jcolp@digium.com>

	* res/res_features.c: Add support for relaying early media in the
	  features attended transfer option. (closes issue #14828) Reported
	  by: licedey

2009-10-19 23:44 +0000 [r224670]  Kevin P. Fleming <kpfleming@digium.com>

	* main/rtp.c: Correct timestamp calculations when RTP sample rates
	  over 8kHz are used. While testing some endpoints that support
	  16kHz and 32kHz sample rates, some log messages were generated
	  due to calc_rxstamp() computing timestamps in a way that produced
	  odd results, so this patch sanitizes the result of the
	  computations.

2009-10-19 19:47 +0000 [r224565]  Joshua Colp <jcolp@digium.com>

	* apps/app_dial.c: Do not attempt early media bridging (ie: direct
	  RTP setup) if options are enabled that should prevent it. (closes
	  issue #14763) Reported by: cupotka

2009-10-17 01:32 +0000 [r224330]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Fix stale caller id data from being
	  reported in AMI NewChannel event The problem here is that
	  chan_dahdi is designed in such a way to set certain values in the
	  dahdi_pvt only once. One of those such values is the configured
	  caller id data in chan_dahdi.conf. For PRI, the configured caller
	  id data could be overwritten during a call. Instead of saving the
	  data and restoring, it was decided that for all non-analog
	  channels it was simply best to not set the configured caller id
	  in the first place and also clear it at the end of the call.
	  (closes issue #15883) Reported by: jsmith

2009-10-16 20:25 +0000 [r224260]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Never released PRI channels when using
	  Busy() or Congestion() dialplan apps. When the Busy() or
	  Congestion() application is used towards ISDN (an ISDN progress
	  is sent), the responding ISDN Disconnect or Release may contain
	  the ISDN cause user busy or one of the congestion causes. In
	  chan_dahdi.c these causes will only set the needbusy or
	  needcongestion flags and not activate the softhangup procedure.
	  Unfortunately only the latter can interrupt the endless wait loop
	  of Busy()/Congestion(). Result: PRI channels staying in state
	  busy for the rest of asterisk life or until the other end times
	  out and forces the call to clear. (in issue 0014292) Reported by:
	  tomaso Patches: disc_rel_userbusy.patch uploaded by tomaso
	  (license 564) (This patch is unrelated to the issue.)

2009-10-13 20:58 +0000 [r223955]  Jean Galarneau <jgalarneau@digium.com>

	* channels/chan_dahdi.c: Fix PRI timer T309 operation

2009-10-12 23:12 +0000 [r223804]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_dial.c: Ensure ringing continues for branched calls
	  after progress is received While waiting for an answer, don't
	  send progress for branched calls for which ringing was sent.
	  (closes issue #15028) Reported by: fnordian

2009-10-12 15:30 +0000 [r223692]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_sip.c: Remove automatic switching from T.38 to
	  voice mode in chan_sip. chan_sip has some code to automatically
	  switch from T.38 mode to voice mode when a voice frame is written
	  to the channel while it is in T.38 mode; this was intended to
	  handle the situation when a FAX transmission has ended and the
	  channel is not yet hung up, but is causing problems at the
	  beginning of FAX sessions as well when there are still voice
	  frames 'in flight' at the time the T.38 negotiation completes.
	  This patch removes the automatic switchover. (issue #16025)
	  Reported by: jamicque

2009-10-11 18:34 +0000 [r223485-223550]  Russell Bryant <russell@digium.com>

	* apps/app_queue.c: Remove a duplicate ao2_iterator_destroy().

	* main/autoservice.c: Remove some unnecessary code.

	* main/autoservice.c: Don't use data outside of its scope. The
	  purpose of this code was to have a hangup frame put on the list
	  of deferred frames. However, the code that read the hangup frame
	  was outside of the scope of where the hangup frame was declared.

2009-10-09 18:20 +0000 [r223225]  Matthew Nicholson <mnicholson@digium.com>

	* main/channel.c: Signal timeouts by returning AST_CONTROL_RINGING
	  when originating calls. (closes issue #15104) Reported by:
	  nblasgen Patches: manager-timeout1.diff uploaded by mnicholson
	  (license 96) Tested by: nblasgen, mnicholson

2009-10-09 18:17 +0000 [r223213]  Mark Michelson <mmichelson@digium.com>

	* apps/app_dial.c: Fix potential memory leak in app_dial.c

2009-10-09 17:52 +0000 [r223142-223205]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: fixes sip registration using authuser in
	  user.conf (closes issue #14954) Reported by: tornblad Tested by:
	  mmichelson, tornblad, dvossel

	* channels/chan_sip.c: 'auth=' did not parse md5 secret correctly
	  (closes issue https://issues.asterisk.org/view.php?id=15949)
	  Reported by: ebroad Patches: authparsefix.patch uploaded by
	  ebroad (license 878) 15949_trunk.diff uploaded by dvossel
	  (license 671) Tested by: ebroad

2009-10-08 19:45 +0000 [r222878]  Russell Bryant <russell@digium.com>

	* include/asterisk/file.h, main/frame.c, main/file.c,
	  include/asterisk/frame.h: Make filestream frame handling safer by
	  isolating frames before returning them. This patch is related to
	  a number of issues on the bug tracker that show crashes related
	  to freeing frames that came from a filestream. A number of fixes
	  have been made over time while trying to figure out these
	  problems, but there re still people seeing the crash. (Note that
	  some of these bug reports include information about other
	  problems. I am specifically addressing the filestream frame crash
	  here.) I'm still not clear on what the exact problem is. However,
	  what is _very_ clear is that we have seen quite a few problems
	  over time related to unexpected behavior when we try to use
	  embedded frames as an optimization. In some cases, this
	  optimization doesn't really provide much due to improvements made
	  in other areas. In this case, the patch modifies filestream
	  handling such that the embedded frame will not be returned.
	  ast_frisolate() is used to ensure that we end up with a
	  completely mallocd frame. In reality, though, we will not
	  actually have to malloc every time. For filestreams, the frame
	  will almost always be allocated and freed in the same thread.
	  That means that the thread local frame cache will be used. So,
	  going this route doesn't hurt. With this patch in place, some
	  people have reported success in not seeing the crash anymore.
	  (SWP-150) (AST-208) (ABE-1834) (issue #15609) Reported by: aragon
	  Patches: filestream_frisolate-1.4.diff2.txt uploaded by russell
	  (license 2) Tested by: aragon, russell (closes issue #15817)
	  Reported by: zerohalo Tested by: zerohalo (closes issue #15845)
	  Reported by: marhbere Review:
	  https://reviewboard.asterisk.org/r/386/

2009-10-08 19:45 +0000 [r222877]  David Vossel <dvossel@digium.com>

	* main/netsock.c, include/asterisk/netsock.h: fixes an
	  ast_netsock_list memory leak. ABE-1998 Review:
	  https://reviewboard.asterisk.org/r/395/

2009-10-08 16:33 +0000 [r222691-222797]  Richard Mudgett <rmudgett@digium.com>

	* channels/misdn_config.c: Fix memory leak if chan_misdn config
	  parameter is repeated. Memory leak when the same config option is
	  set more than once in an misdn.conf section. Why must this be
	  considered? Templates! Defining a template with default port
	  options and later adding to or overriding some of them. Patches:
	  memleak-misdn.patch JIRA ABE-1998

	* channels/chan_misdn.c: chan_misdn.c:process_ast_dsp() memory leak
	  misdn.conf: astdtmf must be set to "yes". With "no", buffer loss
	  does not occur. The translated frame "f2" when passing through
	  ast_dsp_process() is not freed whenever it is not used further in
	  process_ast_dsp(). Then in the end it is never ever freed.
	  Patches: translate.patch JIRA ABE-1993

2009-10-07 17:41 +0000 [r222542]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: crash on transfer handle_invite_replaces()
	  attempts to uplock a pvt's owner channel without first verifing
	  that it exists. (issue #16027)

2009-10-06 23:51 +0000 [r222393-222462]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Add missing unlock(s) in dahdi_read (two
	  cases in trunk) (closes issue #15683) Reported by: alecdavis

	* channels/chan_dahdi.c: Fix potential crash when entire span
	  request is received. The variable index used in this scenario for
	  accessing the dahdi_pvts was wrong and was most likely copied
	  from the several other places it is used correctly. (closes issue
	  #15998) Reported by: tsearle Patches: dahdi_reset_crash.patch
	  uploaded by tsearle (license 373)

2009-10-06  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27-rc2

2009-10-06 01:16 +0000 [r222152]  Kevin P. Fleming <kpfleming@digium.com>

	* main/astobj2.c, include/asterisk/astobj2.h,
	  res/res_musiconhold.c, apps/app_queue.c, channels/chan_iax2.c:
	  Fix ao2_iterator API to hold references to containers being
	  iterated. See Mantis issue for details of what prompted this
	  change. Additional notes: This patch changes the ao2_iterator API
	  in two ways: F_AO2I_DONTLOCK has become an enum instead of a
	  macro, with a name that fits our naming policy; also, it is now
	  necessary to call ao2_iterator_destroy() on any iterator that has
	  been created. Currently this only releases the reference to the
	  container being iterated, but in the future this could also
	  release other resources used by the iterator, if the iterator
	  implementation changes to use additional resources. (closes issue
	  #15987) Reported by: kpfleming Review:
	  https://reviewboard.asterisk.org/r/383/

2009-10-02 17:32 +0000 [r222026]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: Removes unnecessary unlock, clarifies a
	  memcpy.

2009-10-02 16:58 +0000 [r221776-221970]  Tilghman Lesher <tlesher@digium.com>

	* main/astobj2.c: Ensure the result of the hash function is
	  positive. Negative array offsets suck.

	* main/asterisk.c, main/rtp.c, main/say.c: Fix a bunch of
	  off-by-one errors

2009-10-01 23:18 +0000 [r221769]  Richard Mudgett <rmudgett@digium.com>

	* channels/misdn/isdn_lib.c, channels/misdn/isdn_lib_intern.h:
	  Occasionally losing use of B channels in chan_misdn. I have not
	  been able to reproduce the problem of losing channels. However, I
	  have seen in the code a reentrancy problem that might give these
	  symptoms. The reentrancy patch does several things: 1) Guards B
	  channel and B channel structure allocation. 2) Makes the B
	  channel structure find routines more precise in locating records.
	  3) Never leave a B channel allocated if we received cause 44. The
	  last item may cause temporary outgoing call problems, but they
	  should clear when the line becomes idle. (closes issue #15490)
	  Reported by: slutec18 Patches:
	  issue15490_channel_alloc_reentrancy.patch uploaded by rmudgett
	  (license 664) Tested by: rmudgett, slutec18 (closes issue #15458)
	  Reported by: FabienToune Patches:
	  issue15458_channel_alloc_reentrancy.patch uploaded by rmudgett
	  (license 664) Tested by: FabienToune, rmudgett, slutec18

2009-10-01 15:24 +0000 [r221360-221588]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Use unsigned ints for portinuri flags.

	* channels/chan_sip.c: Make portinuri a bitfield.

	* channels/chan_sip.c, configs/sip.conf.sample: Fix SRV lookup and
	  Request-URI generation in chan_sip. This patch adds a new field
	  "portinuri" to the sip dialog struct and the sip peer struct.
	  That field is used during RURI generation to determine if the
	  port should be included in the RURI. It is also used in some
	  places to determine if an SRV lookup should occur. (closes issue
	  #14418) Reported by: klaus3000 Tested by: klaus3000, mnicholson
	  Review: https://reviewboard.asterisk.org/r/369/

2009-09-30 19:02 +0000 [r221303]  Matthias Nick <mnick@digium.com>

	* funcs/func_strings.c: changed the prototype definition of
	  csv_quote

2009-09-30 16:55 +0000 [r221200]  Tilghman Lesher <tlesher@digium.com>

	* main/channel.c: Avoid a potential NULL dereference. (closes issue
	  #15865) Reported by: kobaz Patches: 20090915__issue15865.diff.txt
	  uploaded by tilghman (license 14) Tested by: kobaz

2009-09-30 15:41 +0000 [r221153-221157]  Matthias Nick <mnick@digium.com>

	* configs/cdr_custom.conf.sample, funcs/func_strings.c: added a new
	  dialplan function 'CSV_QUOTE' and changed the
	  cdr_custom.sample.conf (closes issue #15471) Reported by: dkerr
	  Patches: csv_quote_14.txt uploaded by mnick (license ) Tested by:
	  mnick

	* funcs/func_strings.c: check bounds - prevents for buffer overflow

2009-09-30 14:49 +0000 [r221086]  Terry Wilson <twilson@digium.com>

	* main/rtp.c, channels/chan_sip.c, include/asterisk/rtp.h,
	  configs/sip.conf.sample: Change the SSRC by default when our
	  media stream changes Be default, change SSRC when doing an audio
	  stream changes Asterisk doesn't honor marker bit when reinvited
	  to already-bridged RTP streams,resulting in far-end stack
	  discarding packets with "old" timestamps that areactually part of
	  a new stream. This patch sends AST_CONTROL_SRCUPDATE whenever
	  there is a reinvite, unless the 'constantssrc' is set to true in
	  sip.conf. The original issue reported to Digium support detailed
	  the following situation: ITSP <-> Asterisk 1.4.26.2 <-> SIP-based
	  Application Server Call comes in fromITSP, Asterisk dials the app
	  server which sends a re-invite back toAsterisk--not to negotiate
	  to send media directly to the ITSP, but to indicatethat it's
	  changing the stream it's sending to Asterisk. The app
	  servergenerates a new SSRC, sequence numbers, timestamps, and
	  sets the marker bit on the new stream. Asterisk passes through
	  the teimstamp of the new stream, butdoes not reset the SSRC,
	  sequence numbers, or set the marker bit. When the timestamp on
	  the new stream is older than the timestamp on the originalstream,
	  the ITSP (which doesn't know there has been any change) discards
	  the newframes because it thinks they are too old. This patch
	  addresses this by changing the SSRC on a stream update unless
	  constantssrc=true is set in sip.conf. Review:
	  https://reviewboard.asterisk.org/r/374/

2009-09-29 20:14 +0000 [r220907]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_chanspy.c: Avoid a deadlock in chanspy, just in case the
	  spyee is masqueraded and chanspy_ds_chan_fixup() is called with
	  the channel locked. (closes issue #15965) Reported by: atis
	  Patches: chanspy-deadlock-fix1.diff uploaded by mnicholson
	  (license 96) Tested by: atis

2009-09-29 17:59 +0000 [r220873]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_sip.c: Reduce CPU usage related to building a peer
	  merely for devicestates. This fixes a 100% CPU problem in the SIP
	  driver, found by profiling the driver while the problem was
	  occurring. (closes issue #14309) Reported by: pkempgen Patches:
	  20090924__issue14309.diff.txt uploaded by tilghman (license 14)
	  Tested by: pkempgen, vrban

2009-09-28 19:09 +0000 [r220717]  Sean Bright <sean@malleable.com>

	* Makefile.rules: When selecting DONT_OPTIMIZE in menuselect,
	  explicitly pass -O0 to the compiler so we override any default
	  optimization levels for a particular install.

2009-09-24 19:39 +0000 [r220288]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_playback.c, main/pbx.c, apps/app_disa.c: Implicitly
	  sending a progress signal breaks some applications. Call
	  Progress() in your dialplan if you explicitly want progress to be
	  sent. (Reverts change 216430, closes issue #15957) Reported by:
	  Pavel Troller on the Asterisk-Dev mailing list
	  http://lists.digium.com/pipermail/asterisk-dev/2009-September/039897.html

2009-09-24 18:18 +0000 [r220099-220213]  Sean Bright <sean@malleable.com>

	* Makefile: Resolve parallel build warnings. Reported by Klaus
	  Darilion on the asterisk-dev mailing list.

	* Makefile, build_tools/mkpkgconfig: Remove the remaining bashisms
	  in the Makefile/mkpkgconfig

2009-09-24 08:33 +0000 [r220027]  Michiel van Baak <michiel@vanbaak.info>

	* build_tools/mkpkgconfig: mkpkgconfig does not need bash so make
	  it use /bin/sh This fixes building on all systems that don't have
	  bash at /bin/bash Reported by _ys on #asterisk-dev Tested by _ys
	  on #asterisk-dev

2009-09-22 21:37 +0000 [r219816]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: When IMAP variables were changed during a
	  reload, Voicemail did not use the new values. This change
	  introduces a configuration version variable, which ensures that
	  connections with the old values are not reused but are allowed to
	  expire normally. (closes issue #15934) Reported by:
	  viniciusfontes Patches: 20090922__issue15934.diff.txt uploaded by
	  tilghman (license 14) Tested by: viniciusfontes

2009-09-21 16:55 +0000 [r219720]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: Reverting merge 219520. This change was not
	  necessary.

2009-09-20 17:52 +0000 [r219653]  Tilghman Lesher <tlesher@digium.com>

	* main/file.c: Really stop the stream, when ast_closestream() is
	  called. (closes issue #15129) Reported by: bmh Patches:
	  20090918__issue15129.diff.txt uploaded by tilghman (license 14)
	  Review: https://reviewboard.asterisk.org/r/372/

2009-09-19 02:51 +0000 [r219586]  Russell Bryant <russell@digium.com>

	* channels/chan_iax2.c: Make sure the iax_pvt exists before
	  dereferencing it. This fixes the latest crash posted on issue
	  15609. (issue #15609)

2009-09-18 23:19 +0000 [r219450-219519]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: iax2 frame double free The iax frame's
	  retrans sched id was written over right before iax2_frame_free
	  was called. In iax2_frame_free that retrans id is used to delete
	  the sched item. By writing over the retrans field before the
	  sched item could be deleted, it was possible for a retransmit to
	  occur on a freed frame.

	* channels/chan_sip.c: via-header branches not updated correctly on
	  INVITE INVITE requests must always contain a new unique branch
	  id. When a new branch id is created for an INVITE, the dialog's
	  invite_branch variable must be updated so CANCEL requests use the
	  correct branch id. (closes issue #15262) Reported by: maniax
	  Patches: asterisk-1.6.1.0-sip-branch.patch uploaded by tweety
	  (license 608) invite_new_branch_trunk.diff uploaded by dvossel
	  (license 671) Tested by: maniax, dvossel

2009-09-17 22:20 +0000 [r219320]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Send a 100 Trying response when we detect a
	  spiral. This was problematic during spiral tests at SIPit...
	  along with some other things as well.

2009-09-17 21:29 +0000 [r219303]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: INVITE w/Replaces deadlock fix This patch
	  cleans up the locking logic in chan_sip.c's
	  handle_invite_replaces() function as well as making use of
	  ast_do_masquerade() rather than forcing the masquerade on an
	  ast_read(). The code had several redundant unlocks that would
	  result in 'freed more times than we've locked!' errors. I cleaned
	  these up as well as moving all the unlock logic to the end of the
	  function. This patch should also resolve the issue people were
	  having with the replacecall channel never being unlocked with one
	  legged calls. (closes issue #15151) Reported by: irroot Patches:
	  invite_w_replaces_1.4.diff uploaded by dvossel (license 671)
	  Tested by: irroot, dvossel Review:
	  https://reviewboard.asterisk.org/r/371/

2009-09-17  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.27-rc1

2009-09-17 14:58 +0000 [r219136]  Matthew Nicholson <mnicholson@digium.com>

	* main/channel.c, include/asterisk/cdr.h,
	  include/asterisk/channel.h: Prevent a potential race condition
	  and crash when hanging up a channel by removing the channel from
	  the channel list before begining channel tear down. This fix may
	  potentially cause problems with CDR backends that access the
	  channel a CDR is associated with via the channel list. This fix
	  makes the channel unavabile at the time when the CDR backend is
	  invoked. This has been documented in include/asterisk/cdr.h.
	  (closes issue #15316) Reported by: vmarrone Tested by: mnicholson
	  Review: https://reviewboard.asterisk.org/r/362/

2009-09-16 23:21 +0000 [r219023]  Tilghman Lesher <tlesher@digium.com>

	* main/config.c, configs/extensions.conf.sample: Properly deal with
	  quotes in the arguments of '#exec' includes. (closes issue
	  #15583) Reported by: pkempgen Patches:
	  20090726__issue15583.diff.txt uploaded by tilghman (license 14)
	  20090726__issue15583-1.4-4.diff.txt uploaded by pkempgen (license
	  169) Tested by: pkempgen

2009-09-16 18:00 +0000 [r218867]  David Brooks <dbrooks@digium.com>

	* main/pbx.c: Fixes CID pattern matching behavior to mirror that of
	  extension pattern matching. Pattern matching for extensions uses
	  a type of scoring system, giving values for specificity to each
	  character in the pattern. Unfortunately, this is done character
	  by character, in order. This does lead to some less specific
	  patterns being first in line for matching, but it will usually
	  get the job done. This patch merely brings CID matching to the
	  same level as extension matching. This patch does not attempt to
	  tackle the problem shared by extension matching. (closes issue
	  #14708) Reported by: klaus3000

2009-09-16 13:33 +0000 [r218798]  Russell Bryant <russell@digium.com>

	* contrib/firmware/iax/iaxy.bin (removed), UPGRADE.txt: Remove the
	  IAXy firmware from Asterisk. The firmware can now be found on
	  downloads.digium.com, where the rest of our binary downloads
	  live. This was the last part of our Asterisk tarballs that was
	  considered non-free by Debian. :-) (closes issue #15838) Reported
	  by: paravoid

2009-09-15 22:27 +0000 [r218730]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: If the user enters the same password as
	  before, don't signal an error when the change does nothing.
	  (closes issue #15492) Reported by: cbbs70a Patches:
	  20090713__issue15492.diff.txt uploaded by tilghman (license 14)

2009-09-15 16:29 +0000 [r218623]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Fix small memory leak in handle_init_event
	  by always destroying the pthread attr before returning.

2009-09-15 16:03 +0000 [r218578]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Send request contact header field with
	  response to registrer queries instead of the address of record.
	  (closes issue #14438) Reported by: ravindrad Patches:
	  regquerypatch uploaded by ravindrad (license 684) Tested by:
	  ravindrad

2009-09-15 16:01 +0000 [r218577]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_followme.c: Ensure FollowMe sets language in channels it
	  creates. Also, not in the original bug report, but related fields
	  are accountcode and musicclass, and the inheritance of
	  datastores. (closes issue #15372) Reported by: Romik Patches:
	  20090828__issue15372.diff.txt uploaded by tilghman (license 14)
	  Tested by: cervajs

2009-09-15 14:57 +0000 [r218497-218498]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_sip.c: revert accidental commit

	* channels/chan_sip.c, sounds/Makefile: Use proper hostname for
	  downloading sound files.

2009-09-14 21:47 +0000 [r218401]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Fix handling of DAHDI_EVENT_REMOVED event
	  to prevent crash in do_monitor. After talking to rmudgett about
	  some of his recent iflist locking changes, it was determined that
	  the only place that would destroy a channel without being
	  explicitly to do so was in handle_init_event. The loop to walk
	  the interface list has been modified to wait to destroy the
	  channel until the dahdi_pvt of the channel to be destroyed is no
	  longer needed. (closes issue #15378) Reported by: samy

2009-09-14 19:16 +0000 [r218331]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c, sounds/Makefile: Don't say "Please try
	  again" if we don't give the user another chance to try again.
	  (issue #15055, SWP-129) Reported by: jthurman

2009-09-14 14:53 +0000 [r218223]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_directed_pickup.c: Ensure we don't pickup ourselves when
	  doing pickup by exten. (closes issue #15100) Reported by:
	  lmsteffan Patches: (modified) pickup.patch uploaded by lmsteffan
	  (license 779)

2009-09-10 23:52 +0000 [r217917-217989]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_queue.c: Don't ring another channel, if there's not
	  enough time for a queue member to answer. (Fixes AST-228)

	* contrib/scripts/iax-friends.sql, channels/chan_sip.c,
	  channels/chan_iax2.c: Backport realtime fix to 1.4

2009-09-10 21:06 +0000 [r217806]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: IAX2 encryption regression The IAX2 Call
	  Token security patch inadvertently broke the use of encryption
	  due to the reorganization of code in the socket_process()
	  function. When encryption is used, an incoming full frame must
	  first be decrypted before the information elements can be parsed.
	  The security release mistakenly moved IE parsing before
	  decryption in order to process the new Call Token IE. To resolve
	  this, decryption of full frames is once again done before looking
	  into the frame. This involves searching for an existing callno,
	  checking the pvt to see if encryption is turned on, and
	  decrypting the packet before the internal fields of the full
	  frame are accessed. associated with AST-2009-006 (closes issue
	  #15834) Reported by: karesmakro Patches:
	  iax2_encryption_fix_1.4.diff uploaded by dvossel (license 671)
	  Tested by: dvossel, karesmakro Review:
	  https://reviewboard.asterisk.org/r/355/

2009-09-10 19:52 +0000 [r217668-217735]  Olle Johansson <oej@edvina.net>

	* utils/Makefile: Reinstate muted that was removed by mistake.
	  muted doesn't compile any more on os/x, so I have to disable it
	  in order to testcompile other code...

	* utils/Makefile, channels/chan_sip.c: Remove harmful code that
	  causes endless loops. Remove code that causes loops in
	  registrations. We have agreed that the patch that this code was
	  part of was bad. I am ripping out the code that causes the issue.
	  putnopvut needs to check the rest of the patch, if it needs to be
	  changed as well. This solves the issue reported in #15540, but
	  needs more work before we close it (as described above).

2009-09-08 20:01 +0000 [r217156]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_meetme.c: When MOH is playing on the channel,
	  announcements sent through the conference are not heard. (closes
	  issue #14588) Reported by: voipas Patches:
	  20090716__issue14588__2.diff.txt uploaded by tilghman (license
	  14) Tested by: lmadsen, twisted, tilghman

2009-09-04 13:56 +0000 [r216432-216435]  Michiel van Baak <michiel@vanbaak.info>

	* main/utils.c, include/asterisk/lock.h: make asterisk compile
	  under devmode with DEBUG_THREADS enabled on OpenBSD

	* channels/chan_sip.c: make chan_sip compile under devmode again

2009-09-04 13:45 +0000 [r216430]  Olle Johansson <oej@edvina.net>

	* apps/app_playback.c, main/pbx.c, channels/chan_sip.c,
	  apps/app_disa.c, configs/sip.conf.sample: Make apps send PROGRESS
	  control frame for early media and fix too early media issue in
	  SIP The issue at hand is that some legacy (dying) PBX systems
	  send empty media frames on PRI links *before* any call progress.
	  The SIP channel receives these frames and by default signals 183
	  Session progress and starts sending media. This will cause phones
	  to play silence and ignore the later 180 ringing message. A bad
	  user experience. The fix is twofold: - We discovered that
	  asterisk apps that support early media ("noanswer") did not send
	  any PROGRESS frame to indicate early media. Fixed. - We introduce
	  a setting in chan_sip so that users can disable any relay of
	  media frames before the outbound channel actually indicates any
	  sort of call progress. In 1.4, 1.6.0 and 1.6.1, this will be
	  disabled for backward compatibility. In later versions of
	  Asterisk, this will be enabled. We don't assume that it will
	  change your Asterisk phone experience - only for the better. We
	  encourage third-party application developers to make sure that if
	  they have applications that wants to send early media, add a
	  PROGRESS control frame transmission to make sure that all channel
	  drivers actually will start sending early media. This has not
	  been the default in Asterisk previous to this patch, so if you
	  got inspiration from our code, you need to update accordingly.
	  Sorry for the trouble and thanks for your support. This code has
	  been running for a few months in a large scale installation (over
	  250 servers with PRI and/or BRI links to old PBX systems). That's
	  no proof that this is an excellent patch, but, well, it's tested
	  :-)

2009-09-04 13:16 +0000 [r216369]  Michiel van Baak <michiel@vanbaak.info>

	* main/astobj2.c: Make sure 'start' is always initialized. This is
	  the same as rev 216222 in trunk but 1.4 is affected as well

2009-09-04 10:48 +0000 [r216008-216263]  Russell Bryant <russell@digium.com>

	* doc/IAX2-security.txt (added), /: Merged revisions 216262 via
	  svnmerge from
	  https://origsvn.digium.com/svn/asterisk/branches/1.2 ........
	  r216262 | russell | 2009-09-04 05:47:37 -0500 (Fri, 04 Sep 2009)
	  | 2 lines Add a plain text version of the IAX2 security document.
	  ........

	* /, UPGRADE.txt: Merged revisions 216080 via svnmerge from
	  https://origsvn.digium.com/svn/asterisk/branches/1.2 ........
	  r216080 | russell | 2009-09-03 14:35:23 -0500 (Thu, 03 Sep 2009)
	  | 2 lines Add a note about IAX2 to UPGRADE.txt. ........

	* /, doc/IAX2-security.pdf (added): Merged revisions 216005 via
	  svnmerge from
	  https://origsvn.digium.com/svn/asterisk/branches/1.2 ........
	  r216005 | russell | 2009-09-03 13:42:24 -0500 (Thu, 03 Sep 2009)
	  | 2 lines Add IAX2 security document related to AST-2009-006.
	  ........

2009-09-03 18:32 +0000 [r216000]  David Vossel <dvossel@digium.com>

	* channels/iax2-parser.c, main/astobj2.c, configs/iax.conf.sample,
	  include/asterisk/acl.h, channels/iax2-parser.h,
	  include/asterisk/astobj2.h, channels/iax2.h, main/acl.c,
	  channels/chan_iax2.c: Merge code associated with AST-2009-006
	  (closes issue #12912) Reported by: rathaus Tested by: tilghman,
	  russell, dvossel, dbrooks

2009-09-02 21:41 +0000 [r215682]  Terry Wilson <twilson@digium.com>

	* channels/chan_sip.c: Re-send non-100 provisional responses to
	  prevent cancellation From section 13.3.1.1 of RFC 3261: If the
	  UAS desires an extended period of time to answer the INVITE, it
	  will need to ask for an "extension" in order to prevent proxies
	  from canceling the transaction. A proxy has the option of
	  canceling a transaction when there is a gap of 3 minutes between
	  responses in a transaction. To prevent cancellation, the UAS MUST
	  send a non-100 provisional response at every minute, to handle
	  the possibility of lost provisional responses. (closes issue
	  #11157) Reported by: rjain Tested by: twilson Review:
	  https://reviewboard.asterisk.org/r/315/

2009-09-01 23:04 +0000 [r215270]  Dwayne M. Hubbard <dwayne.hubbard@gmail.com>

	* apps/app_softhangup.c: Use strrchr() so SoftHangup will correctly
	  truncate multi-hyphen channel names In general channel names are
	  in the form Foo/Bar-Z, but the channel name could have multiple
	  hyphens and look like Foo/B-a-r-Z. Use strrchr to truncate the
	  channel name at the last hyphen. (closes issue #15810) Reported
	  by: dhubbard Patches: dw-softhangup-1.4.patch uploaded by
	  dhubbard (license 733)

2009-08-31 16:16 +0000 [r214940]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_local.c: Also unlock the "other" channel, when
	  returning, due to glare. (closes issue #15787) Reported by:
	  tim_ringenbach Patches: chan_local.diff uploaded by tim
	  ringenbach (license 540) Tested by: tim_ringenbach

2009-08-28 20:13 +0000 [r214357-214701]  Tilghman Lesher <tlesher@digium.com>

	* main/channel.c: Modify comment to be a bit more accurate. We have
	  kept this comment around long enough, that it's pretty clear that
	  we're keeping the code, because changing the code would require a
	  pretty fundamental architectural shift. We've also taken
	  criticism in some quarters, because it was believed that it was
	  referring to the code being nasty. No, the code isn't nasty, just
	  the operation itself is rather odd. Fixed for eternity (probably
	  not).

	* autoconf/libcurl.m4 (added), configure,
	  include/asterisk/autoconfig.h.in, configure.ac: Use autoconf to
	  detect libcurl, as this enables cross-compilation checks,
	  something we didn't allow before. (closes issue #15714) Reported
	  by: pprindeville Patches: 20090813__issue15714.diff.txt uploaded
	  by tilghman (license 14) Tested by: pprindeville

	* autoconf/ast_ext_lib.m4, configure,
	  include/asterisk/autoconfig.h.in, configure.ac: One more build
	  system change, to make the descriptions look better, if we have
	  better information.

	* autoconf/ast_ext_lib.m4, configure,
	  include/asterisk/autoconfig.h.in: Make autoheader descriptions
	  render correctly in our autoconfig.h file. (Figured out while
	  working with issue #14906)

2009-08-26 16:36 +0000 [r214194]  David Vossel <dvossel@digium.com>

	* main/channel.c: ast_write() ignores ast_audiohook_write() results
	  In ast_write(), if a channel has a list of audiohooks, those
	  lists are written to and the resulting frame is what ast_write()
	  should continue with. The problem was the returned audiohook
	  frame was not being handled at all, and the original frame passed
	  into it did not contain the mixed audio, so essentially audio was
	  being lost. One result of this was chan_spy's whisper mode no
	  longer worked. To complicate the issue, frames passed into
	  ast_write may either be a single frame, or a list of frames. So,
	  as the list of frames is processed in the audiohook_write, the
	  returned frames had to be added to a new list. (closes issue
	  #15660) Reported by: corruptor Tested by: dvossel

2009-08-25 19:28 +0000 [r213899-214069]  Tilghman Lesher <tlesher@digium.com>

	* main/say.c: I should always compile before committing...

	* main/say.c: Fix pronunciation of German dates. (closes issue
	  #15273) Reported by: Benjamin Kluck Patches: say_c.patch uploaded
	  by Benjamin Kluck (license 803)

	* main/pbx.c: Improve error message by informing user exactly which
	  function is missing a parethesis. (closes issue #15242) Reported
	  by: Nick_Lewis Patches: pbx.c-funcparenthesis.patch2 uploaded by
	  dbrooks (license 790) pbx.c-funcparenthesis-1.4.diff uploaded by
	  loloski (license 68)

	* Makefile: Use the default runlevels for Debian derivatives,
	  instead of making up our own. (closes issue #14730) Reported by:
	  pkempgen

2009-08-21 20:23 +0000 [r213631]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_sip.c: Ensure that T.38 INVITEs generated by
	  Asterisk properly result in T.38 being enabled. (closes issue
	  #15373) Reported by: dcolombo Patches: chan_sip.patch uploaded by
	  mbrancaleoni (license 342) Tested by: dcolombo, mbrancaleoni

2009-08-21 16:52 +0000 [r213559]  Tilghman Lesher <tlesher@digium.com>

	* include/asterisk.h: Permit DEBUG_FD_LEAKS to be used with C++
	  source files. (closes issue #15698) Reported by: slavon Patches:
	  20090817__issue15698.diff.txt uploaded by tilghman (license 14)
	  Tested by: slavon, tilghman

2009-08-21 16:03 +0000 [r213493]  Jason Parker <jparker@digium.com>

	* configs/queues.conf.sample: Clarify queues.conf comments to
	  specify that variables should be set in the dialplan. (closes
	  issue #15755) Reported by: trendboy

2009-08-20 20:33 +0000 [r213339]  Matthew Nicholson <mnicholson@digium.com>

	* res/res_features.c: Fix a crash by checking the proper pointer
	  for validity before deferencing it. (closes issue #15751)
	  Reported by: atis Patches: ast_bridge_call_peer_cdr.patch
	  uploaded by atis (license 242)

2009-08-20 19:53 +0000 [r213283]  Jeff Peeler <jpeeler@digium.com>

	* apps/app_voicemail.exports (added): Make all the symbols for the
	  C-client callbacks global

2009-08-19 21:18 +0000 [r213103]  David Vossel <dvossel@digium.com>

	* apps/app_mixmonitor.c: Fixes memory leak caused by incorrectly
	  freeing mixmonitor (closes issue #15699) Reported by: edantie
	  Patches: mixmonitor.patch uploaded by edantie (license 862)

2009-08-18 20:26 +0000 [r212913]  Kevin P. Fleming <kpfleming@digium.com>

	* doc/musiconhold-opsound.txt (added), CREDITS, /, UPGRADE.txt,
	  sounds/sounds.xml, build_tools/prep_tarball,
	  doc/musiconhold-fpm.txt (removed), doc/00README.1st,
	  sounds/Makefile: Convert this branch to Opsound music-on-hold.
	  For more details:
	  http://blogs.digium.com/2009/08/18/asterisk-music-on-hold-changes/

2009-08-18 16:36 +0000 [r212763]  Sean Bright <sean@malleable.com>

	* main/manager.c: Delay the creation of temporary files until we
	  have a valid manager command to handle. Without this patch,
	  asterisk creates a temporary file before determining if the
	  specified command is valid. If invalid, we weren't properly
	  cleaning up the file. (closes issue #15730) Reported by: zmehmood
	  Patches: M15730.diff uploaded by junky (license 177) Tested by:
	  zmehmood

2009-08-18 16:00 +0000 [r212727]  Richard Mudgett <rmudgett@digium.com>

	* channels/misdn/isdn_lib.c: Removed some deadwood and added some
	  doxygen comments.

2009-08-17 16:34 +0000 [r212498]  Jeff Peeler <jpeeler@digium.com>

	* channels/misdn_config.c: Fix segfault when reloading chan_misdn.
	  If more ports were specified than configured in misdn.conf a
	  reload would crash asterisk. The problem was the unconfigured
	  port was using data from the previously configured port. When the
	  data for an unconfigured port was freed a crash would result from
	  the double free. (closes issue #12113) Reported by: agupta
	  Patches: bug12113.patch uploaded by jpeeler (license 325)

2009-08-17 15:36 +0000 [r212430]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Fix uninitialized variable.

2009-08-12 23:04 +0000 [r211953]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_queue.c: This patch adds additional checking when
	  generating queue log TRANSFER events. The additional checks
	  prevent generation of false TRANSFER events in certain
	  situations. (closes issue #14536) Reported by: aragon Patches:
	  queue-log-xfer-fix1.diff uploaded by mnicholson (license 96)
	  Tested by: aragon, mnicholson

2009-08-12 18:46 +0000 [r211807]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Backport fix so that outbound CANCEL
	  requests have same branch as challenged INVITEs. There already
	  was code present to be sure that a CANCEL will contain the same
	  branch-id as the INVITE it is cancelling. However, for INVITES
	  which are challenged downstream, this mechanism did not work
	  properly. Now this is taken care of. This is a backport of a fix
	  already present in all 1.6.X branches and in trunk. It also fixes
	  ABE-1907.

2009-08-10 19:48 +0000 [r211528-211583]  Tilghman Lesher <tlesher@digium.com>

	* doc/CODING-GUIDELINES: Conversion specifiers, not format
	  specifiers

	* main/indications.c, main/cli.c, pbx/pbx_loopback.c,
	  channels/chan_dahdi.c, res/res_smdi.c, pbx/pbx_spool.c,
	  channels/chan_skinny.c, pbx/pbx_ael.c, apps/app_dial.c,
	  main/pbx.c, apps/app_privacy.c, codecs/codec_speex.c,
	  funcs/func_math.c, channels/chan_agent.c, apps/app_morsecode.c,
	  apps/app_disa.c, channels/iax2-provision.c, funcs/func_cut.c,
	  pbx/dundi-parser.c, apps/app_talkdetect.c, channels/chan_misdn.c,
	  apps/app_waitforring.c, funcs/func_channel.c, apps/app_macro.c,
	  pbx/pbx_config.c, apps/app_mixmonitor.c, apps/app_chanspy.c,
	  main/asterisk.c, res/res_odbc.c, apps/app_voicemail.c,
	  doc/CODING-GUIDELINES, utils/muted.c, apps/app_meetme.c,
	  main/utils.c, apps/app_followme.c, utils/frame.c,
	  channels/misdn_config.c, main/cdr.c, main/channel.c,
	  channels/chan_phone.c, main/manager.c, apps/app_osplookup.c,
	  apps/app_setcallerid.c, res/res_agi.c, apps/app_rpt.c,
	  channels/chan_mgcp.c, apps/app_adsiprog.c, main/dnsmgr.c,
	  channels/chan_sip.c, apps/app_waitforsilence.c, agi/eagi-test.c,
	  main/acl.c, apps/app_queue.c, channels/chan_oss.c,
	  agi/eagi-sphinx-test.c, channels/chan_h323.c, pbx/pbx_dundi.c,
	  apps/app_sms.c, apps/app_verbose.c, apps/app_dahdibarge.c,
	  funcs/func_rand.c, apps/app_readfile.c, main/frame.c, /,
	  res/res_features.c, apps/app_record.c, funcs/func_strings.c,
	  apps/app_random.c, apps/app_alarmreceiver.c,
	  channels/chan_iax2.c: AST-2009-005

2009-08-09 15:41 +0000 [r211274]  Tilghman Lesher <tlesher@digium.com>

	* main/astfd.c: Small oops. Clear the flags which have been
	  checked.

2009-08-07 20:11 +0000 [r211112]  Russell Bryant <russell@digium.com>

	* apps/app_chanspy.c: Resolve a deadlock involving app_chanspy and
	  masquerades. (ABE-1936)

2009-08-07 18:16 +0000 [r210913-211038]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_queue.c: QUEUE_MEMBER_LIST _really_ wants the interface
	  name, not the membername. This is a partial revert of revision
	  82590, which was an attempted cleanup, but in reality, it broke
	  QUEUE_MEMBER_LIST, which has always been intended as a method by
	  which component interfaces could be queried from the queue.
	  Membername isn't useful here, because that field cannot be used
	  to obtain further information about the member. See the
	  documentation on QUEUE_MEMBER_LIST, RemoveQueueMember,
	  QUEUE_MEMBER_PENALTY, and the various AMI commands which take a
	  member argument for further justification. (closes issue #15664)
	  Reported by: rain Patches: app_queue-queue_member_list.diff
	  uploaded by rain (license 327)

	* main/channel.c: Because channel information can be accessed
	  outside of the channel thread, we must lock the channel prior to
	  modifying it. (closes issue #15397) Reported by: caspy Patches:
	  20090714__issue15397.diff.txt uploaded by tilghman (license 14)
	  Tested by: caspy

2009-08-05 19:18 +0000 [r210575]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Dialplan starts execution before the
	  channel setup is complete. * Issue 15655: For the case where
	  dialing is complete for an incoming call, dahdi_new() was asked
	  to start the PBX and then the code set more channel variables. If
	  the dialplan hungup before these channel variables got set,
	  asterisk would likely crash. * Fixed potential for overlap
	  incoming call to erroneously set channel variables as global
	  dialplan variables if the ast_channel structure failed to get
	  allocated. * Added missing set of CALLINGSUBADDR in the dialing
	  is complete case. (closes issue #15655) Reported by: alecdavis

2009-08-05 18:46 +0000 [r210563]  Leif Madsen <lmadsen@digium.com>

	* doc/imapstorage.txt: Update imapstorage.txt documentation.
	  Updated the imapstorage.txt documentation to reflect that issues
	  with c-client versions older than 2007 seem to cause crashing
	  issues that are not seen with more recent versions. Documentation
	  has been updated to reflect this. (closes issue #14496) Reported
	  by: vbcrlfuser Patches: __20090727-imap-documentation-patch.txt
	  uploaded by lmadsen (license 10) Tested by: lmadsen, mmichelson,
	  dbrooks

2009-08-04 14:51 +0000 [r210237]  Kevin P. Fleming <kpfleming@digium.com>

	* Makefile: Eliminate spurious compiler warnings from system
	  headers on *BSD platforms. Ensure that system headers located in
	  /usr/local/include are actually treated as system headers by the
	  compiler, and not as local headers which are subject to warnings
	  from the -Wundef compiler option and others. (closes issue
	  #15606) Reported by: mvanbaak

2009-08-03 16:15 +0000 [r210067]  David Brooks <dbrooks@digium.com>

	* channels/chan_dahdi.c: Fixes dialplan wildcard extension taking
	  precedence over call pickup code. Prior to this patch, a wildcard
	  extension in the dialplan (for example, _*.) would take
	  precedence over picking up a call in the channel's pickup group.
	  This patch simply moves the block of code handling pickup group
	  matching to above the extension matching code. (closes issue
	  #14735) Reported by: stevedavies Review:
	  https://reviewboard.asterisk.org/r/319/

2009-08-03 16:11 +0000 [r210064-210066]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_oss.c, apps/app_playback.c, main/asterisk.exports,
	  configure, include/asterisk/autoconfig.h.in,
	  include/asterisk/compat.h, main/strcompat.c, configure.ac,
	  funcs/func_cut.c: Reverting index() fix, applying a different
	  methodology, based upon developer discussions. (related to issue
	  #15639)

	* main/asterisk.exports, include/asterisk/compat.h: Helps if we
	  export the index() function. (Related to issue #15639)

	* configure, include/asterisk/autoconfig.h.in, main/strcompat.c,
	  configure.ac: Apparently, some platforms don't have the index()
	  function. (closes issue #15639) Reported by: nmav

2009-08-01 11:27 +0000 [r209838-209879]  Russell Bryant <russell@digium.com>

	* main/db1-ast/mpool/mpool.c: Resolve a valgrind warning about a
	  read from uninitialized memory. (issue #15396) Reported by:
	  aragon

	* apps/app_milliwatt.c: Modify how Playtones() is used in
	  Milliwatt() to resolve gain issue. When Milliwatt() was changed
	  internally to use Playtones() so that the proper tone was used,
	  it introduced a drop in gain in the output signal. So, use the
	  playtones API directly and specify a volume argument such that
	  the output matches the gain of the original Milliwatt() code.
	  (closes issue #15386) Reported by: rue_mohr Patches:
	  issue_15386.rev2.diff uploaded by russell (license 2) Tested by:
	  rue_mohr

2009-08-01 00:52 +0000 [r209759]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/misdn/isdn_lib.c, utils/frame.c, main/Makefile,
	  channels/misdn/ie.c: Minor changes inspired by testing with
	  latest GCC. The latest GCC (what will become 4.5.x) has a few new
	  warnings, that in these cases found some either downright buggy
	  code, or at least seriously poorly designed code that could be
	  improved.

2009-07-28 00:12 +0000 [r209315]  Tilghman Lesher <tlesher@digium.com>

	* sounds/sounds.xml: Publish French extra sounds

2009-07-27 17:44 +0000 [r209131]  Mark Michelson <mmichelson@digium.com>

	* main/udptl.c, configs/udptl.conf.sample: Allow for UDPTL to use
	  only even-numbered ports if desired. There are some VoIP
	  providers out there that will not accept SDP offers with odd
	  numbered UDPTL ports. While it is my personal opinion that these
	  VoIP providers are misinterpreting RFC 2327, it really is not a
	  big deal to play along with their silly little games. Of course,
	  since restricting UDPTL ports to only even numbers reduces the
	  range of available ports by half, so the option to use only even
	  port numbers is off by default. A user can enable the behavior by
	  setting use_even_ports=yes in udptl.conf. (closes issue #15182)
	  Reported by: CGMChris Patches: 15182.patch uploaded by mmichelson
	  (license 60) Tested by: CGMChris

2009-07-27 09:56 +0000 [r208990]  Michiel van Baak <michiel@vanbaak.info>

	* res/res_crypto.c: backport rev 205532 from trunk: pthread_self
	  returns a pthread_t which is not an unsigned int on all pthread
	  implementations. Casting it to an unsigned int fixes compiler
	  warnings.

2009-07-27 01:18 +0000 [r208923]  Jeff Peeler <jpeeler@digium.com>

	* main/translate.c, channels/chan_iax2.c: Fix logic errors from
	  208746

2009-07-25 06:19 +0000 [r208746]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_skinny.c, main/translate.c, channels/chan_iax2.c:
	  Fix compiling under dev-mode with gcc 4.4.0. Mostly trivial
	  changes, but I did not know of any other way to fix the
	  "dereferencing type-punned pointer will break strict-aliasing
	  rules" error without creating a tmp variable in chan_skinny.

2009-07-24 19:24 +0000 [r208622]  Mark Michelson <mmichelson@digium.com>

	* apps/app_queue.c: Don't impose an arbitrary limit on member lines
	  in queues.conf I know what some of you are thinking: "UGH! Mark,
	  why are you using ast_strdup and ast_free for the string when you
	  can just use ast_strdupa and let the memory free itself?! Have
	  the bats been chewing on your brain again?" Based on past
	  experiences, I don't like using ast_strdupa inside a loop. It's a
	  good way to potentially exhaust stack space. Also, since this
	  only happens when reloading queues, I don't think that heap
	  allocations and frees are going to be a huge problem. (closes
	  issue #15559) Reported by: amorsen

2009-07-24 18:38 +0000 [r208592]  Russell Bryant <russell@digium.com>

	* apps/app_dial.c: Do not log an ERROR if autoservice_stop()
	  returns -1. This does not indicate an error. A return of -1 just
	  means that the channel has been hung up. (reported in
	  #asterisk-dev)

2009-07-24 18:26 +0000 [r208386-208587]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Only send a BYE when hanging up a channel
	  that is up. For cases where Asterisk sends an INVITE and receives
	  a non 2XX final response, Asterisk would follow the INVITE
	  transaction by immediately sending a BYE, which was unnecessary.
	  (closes issue #14575) Reported by: chris-mac

	* channels/chan_sip.c: Fix a problem where a 491 response could be
	  sent out of dialog. This generalizes the fix for issue 13849. The
	  initial fix corrected the problem that Asterisk would reply with
	  a 491 if a reinvite were received from an endpoint and we had not
	  yet received an ACK from that endpoint for the initial INVITE it
	  had sent us. This expansion also allows Asterisk to appropriately
	  handle an INVITE with authorization credentials if Asterisk had
	  not received an ACK from the previous transaction in which
	  Asterisk had responded to an unauthorized INVITE with a 407.
	  (closes issue #14239) Reported by: klaus3000 Patches: 14239.patch
	  uploaded by mmichelson (license 60) Tested by: klaus3000

2009-07-23 19:19 +0000 [r208380]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Only set the priindication setting when
	  not performing a reload (closes issue #14696) Reported by:
	  fdecher

2009-07-23 16:29 +0000 [r208262-208312]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Remove inaccurate XXX comment.

	* channels/chan_sip.c: Properly handle 183 responses which do not
	  contain an SDP. (closes issue #15442) Reported by: ffloimair
	  Patches: 15442.patch uploaded by mmichelson (license 60) Tested
	  by: tkarl, ffloimair

2009-07-22 20:23 +0000 [r207945-208083]  Tilghman Lesher <tlesher@digium.com>

	* main/asterisk.exports, include/asterisk/compat.h: Export symbols
	  for functions included in our compatibility headers. (closes
	  issue #15556) Reported by: smw1218

	* funcs/func_strings.c: Force an error if a blank is passed to
	  QUOTE (because the documentation states the argument is not
	  optional). This change makes URIENCODE and QUOTE behave
	  similarly, since the documentation states that the argument is
	  not optional, for both. (closes issue #15439) Reported by:
	  pkempgen Patches: 20090706__issue15439.diff.txt uploaded by
	  tilghman (license 14)

2009-07-21 20:16 +0000 [r207786-207827]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Wait for wink before dialing when using
	  E&M wink signaling There was already code for other signaling
	  types in dahdi_handle_event to handle dialing if a dial operation
	  dial string was present. Simply add SIG_EMWINK to the list.
	  (closes issue #14434) Reported by: araasch

	* channels/chan_dahdi.c: Revert r207573, this approach could
	  potentially block for an unacceptable amount of time.

2009-07-21 14:26 +0000 [r207714]  Mark Michelson <mmichelson@digium.com>

	* main/manager.c: Document default timeout for AMI originations.
	  AST-224

2009-07-21 13:04 +0000 [r207647]  Kevin P. Fleming <kpfleming@digium.com>

	* codecs/lpc10/Makefile, main/db1-ast/Makefile, Makefile,
	  agi/Makefile, codecs/Makefile, utils/Makefile, main/Makefile,
	  codecs/gsm/Makefile, Makefile.moddir_rules, Makefile.rules,
	  pbx/Makefile, res/Makefile, channels/Makefile: Ensure that
	  user-provided CFLAGS and LDFLAGS are honored. This commit changes
	  the build system so that user-provided flags (in ASTCFLAGS and
	  ASTLDFLAGS) are supplied to the compiler/linker *after* all flags
	  provided by the build system itself, so that the user can
	  effectively override the build system's flags if desired. In
	  addition, ASTCFLAGS and ASTLDFLAGS can now be provided *either*
	  in the environment before running 'make', or as variable
	  assignments on the 'make' command line. As a result, the use of
	  COPTS and LDOPTS is no longer necessary, so they are no longer
	  documented, but are still supported so as not to break existing
	  build systems that supply them when building Asterisk.

2009-07-20 23:23 +0000 [r207573]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Wait for wink before dialing when using
	  E&M wink signaling This patch adds a new dahdi_wait function to
	  specifically wait for the wink event. If the wink is not
	  eventually received the channel is hung up. (closes issue #14434)
	  Reported by: araasch Patches: emwinkmod uploaded by araasch
	  (license 693)

2009-07-20 19:39 +0000 [r207423]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Answer video SDP offers properly when
	  videosupport is not enabled. Copied from Review board: In issue
	  12434, the reporter describes a situation in which audio and
	  video is offered on the call, but because videosupport is
	  disabled in sip.conf, Asterisk gives no response at all to the
	  video offer. According to RFC 3264, all media offers should have
	  a corresponding answer. For offers we do not intend to actually
	  reply to with meaningful values, we should still reply with the
	  port for the media stream set to 0. In this patch, we take note
	  of what types of media have been offered and save the information
	  on the sip_pvt. The SDP in the response will take into account
	  whether media was offered. If we are not otherwise going to
	  answer a media offer, we will insert an appropriate m= line with
	  the port set to 0. It is important to note that this patch is
	  pretty much a bandage being applied to a broken bone. The patch
	  *only* helps for situations where video is offered but
	  videosupport is disabled and when udptl_pt is disabled but T.38
	  is offered. Asterisk is not guaranteed to respond to every media
	  offer. Notable cases are when multiple streams of the same type
	  are offered. The 2 media stream limit is still present with this
	  patch, too. In trunk and the 1.6.X branches, things will be a bit
	  different since Asterisk also supports text in SDPs as well.
	  (closes issue #12434) Reported by: mnnojd Review:
	  https://reviewboard.asterisk.org/r/311 Review:
	  https://reviewboard.asterisk.org/r/313

2009-07-20 16:26 +0000 [r207360]  Russell Bryant <russell@digium.com>

	* main/channel.c: Only do the chan->fdno check in ast_read() in a
	  developer build. I changed this check to only happen in a
	  dev-mode build. I also added a comment explaining what is going
	  on. I also made it so that detection of this situation does not
	  affect ast_read() operation. (closes issue #14723) Reported by:
	  seadweller

2009-07-20  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26

2009-07-13  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc6

2009-07-13 15:12 +0000 [r206126]  Russell Bryant <russell@digium.com>

	* main/pbx.c: Print CID match in "show dialplan". (closes issue
	  #14702) Reported by: klaus3000 Patches:
	  patch_asterisk_1.4.23_CID_matching.txt uploaded by klaus3000
	  (license 65)

2009-07-10 17:39 +0000 [r205877]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Properly ACK 487 responses to canceled
	  INVITEs. From the review board request: The fix from review 298
	  has exposed a new bug in chan_sip. When we hang up an outgoing
	  call, we first will dump all the outstanding packets on the
	  sip_pvt using __sip_pretend_ack. Then, if we can, we send a
	  CANCEL. The problem with this is that since destroyed all the
	  outstanding packets on the dialog, we cannot match the incoming
	  487 response to our INVITE. Because we cannot match the response,
	  we do not send an ACK. To correct this, instead of using
	  __sip_pretend_ack, I have changed the code to loop through the
	  list of packets and call __sip_semi_ack on each one instead. This
	  causes us to stop retransmitting the requests, but we still have
	  them around in case we get responses for them. When discussing
	  this earlier today with Josh Colp, we both agreed that in the
	  majority of cases, this would be enough of a fix. However, we
	  also agreed that we should have a safety net in place in case we
	  never receive a response to our initial INVITE. To handle this, I
	  have modified __sip_autodestruct to behave similar to the way it
	  does in Asterisk 1.4. If there are outstanding packets on the
	  sip_pvt, the needdestroy flag is not set, and the last request on
	  the dialog was either a CANCEL or BYE, then we set the
	  needdestroy flag and reschedule destruction for 10 seconds in the
	  future. If, though, the needdestroy flag is set, then we use
	  __sip_pretend_ack to kill the remaining outstanding packets so
	  that the monitor thread can destroy the sip_pvt. I ran two
	  separate tests. First, I placed a call from my Aastra phone to my
	  Polycom phone. I hung up the Aastra before the Polycom answered.
	  I verified through sip debug output that Asterisk properly ACKed
	  the 487 received from the Polycom. For my second test, I set up a
	  SIPp UAS scenario so that it would send a 200 OK in response to a
	  CANCEL but would not send a 487 for the original INVITE. I
	  verified that after about 40 seconds, Asterisk properly cleans up
	  the outgoing sip_pvt for the call. Review:
	  https://reviewboard.asterisk.org/r/308

2009-07-10 16:23 +0000 [r205804]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: SIP registration auth loop caused by stale
	  nonce If an endpoint sends two registration requests in a very
	  short period of time with the same nonce, both receive 401
	  responses from Asterisk, each with a different nonce (the second
	  401 containing the current nonce and the first one being stale).
	  If the endpoint responds to the first 401, it does not match the
	  current nonce so Asterisk sends a third 401 with a newly
	  generated nonce (which updates the current nonce)... Now if the
	  endpoint responds to the second 401, it does not match the
	  current nonce either and Asterisk sends a fourth 401 with a newly
	  generated nonce... This loop goes on and on. There appears to be
	  a simple fix for this. If the nonce from the request does not
	  match our nonce, but is a good response to a previous nonce,
	  instead of sending a 401 with a newly generated nonce, use the
	  current one instead. This breaks the loop as the nonce is not
	  updated until a response is received. Additional logic has been
	  added to make sure no nonce can be responded to twice though.
	  (closes issue #15102) Reported by: Jamuel Patches:
	  patch-bug_0015102 uploaded by Jamuel (license 809) nonce_sip.diff
	  uploaded by dvossel (license 671) Tested by: Jamuel Review:
	  https://reviewboard.asterisk.org/r/289/

2009-07-10 15:51 +0000 [r205775]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Ensure that outbound NOTIFY requests are
	  properly routed through stateful proxies. With this change, we
	  make note of Record-Route headers present in any SUBSCRIBE
	  request that we receive so that our outbound NOTIFY requests will
	  have the proper Route headers in them. (closes issue #14725)
	  Reported by: ibc

2009-07-09 23:37 +0000 [r205728]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: No audio on calls from Asterisk to various
	  ISDN devices until DTMF sent by caller. Add missing clearing of
	  the dialing flag when the ISDN call is CONNECTED. (i.e. When
	  libpri generates the event PRI_EVENT_ANSWER.) (closes issue
	  #15420) Reported by: scottbmilne Patches:
	  bug15420-1.4.25.1-diff2.txt uploaded by alecdavis (license 585)
	  Tested by: scottbmilne, alecdavis (closes issue #15416) Reported
	  by: avinoash (closes issue #15389) Reported by: alecdavis This
	  patch should also fix the following issue: (issue #15205)
	  Reported by: vinsik

2009-07-09 16:18 +0000 [r205409-205599]  David Vossel <dvossel@digium.com>

	* include/asterisk/time.h: Changing ast_samp2tv to not use floating
	  point.

	* main/rtp.c, channels/chan_iax2.c, include/asterisk/frame.h: Fixes
	  8khz assumptions Many calculations assume 8khz is the codec rate.
	  This is not always the case. This patch only addresses chan_iax.c
	  and res_rtp_asterisk.c, but I am sure there are other areas that
	  make this assumption as well. Review:
	  https://reviewboard.asterisk.org/r/306/

	* include/asterisk/devicestate.h, main/pbx.c, main/devicestate.c,
	  include/asterisk/pbx.h: moving ast_devstate_to_extenstate to
	  pbx.c from devicestate.c ast_devstate_to_extenstate belongs in
	  pbx.c. This change fixes a compile time error with chan_vpb as
	  well.

2009-07-08 19:26 +0000 [r205349]  Mark Michelson <mmichelson@digium.com>

	* apps/app_queue.c: Prevent phantom calls to queue members. If a
	  caller were to hang up while a periodic announcement or position
	  were being said, the return value for those functions would
	  incorrectly indicate that the caller was still in the queue. With
	  these changes, the problem does not occur. (closes issue #14631)
	  Reported by: latinsud Patches: queue_announce_ghost_call2.diff
	  uploaded by latinsud (license 745) (with small modification from
	  me)

2009-07-08 18:19 +0000 [r205288]  Jason Parker <jparker@digium.com>

	* config.guess, config.sub: Update config.guess and config.sub from
	  the savannah.gnu.org git repo.

2009-07-08 16:53 +0000 [r205215]  David Vossel <dvossel@digium.com>

	* include/asterisk/time.h: ast_samp2tv needs floating point for
	  16khz audio In ast_samp2tv(), (1000000 / _rate) = 62.5 when _rate
	  is 16000. The .5 is currently stripped off because we don't
	  calculate using floating points. This causes madness with 16khz
	  audio. (issue ABE-1899) Review:
	  https://reviewboard.asterisk.org/r/305/

2009-07-08 16:26 +0000 [r205188]  Tilghman Lesher <tlesher@digium.com>

	* main/say.c: Add redirection warnings for the invalid language
	  codes previously removed.

2009-07-08 15:54 +0000 [r205149]  Russell Bryant <russell@digium.com>

	* res/res_crypto.c: Make OpenSSL usage thread-safe. OpenSSL is not
	  thread-safe by default. However, making it thread safe is very
	  easy. We just have to provide a couple of callbacks. One callback
	  returns a thread ID. The other handles locking. For more
	  information, start with the "Is OpenSSL thread-safe?" question on
	  the FAQ page of openssl.org.

2009-07-02 21:59 +0000 [r204834]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c: Removed confusing warning message "Got
	  Busy in Connected State" If an incoming mISDN call is answered
	  with the Answer application and a subsequent Dial gets a busy
	  endpoint then it is valid for that already connected channel to
	  get the busy indication. Asterisk will play the busy tones until
	  the dialplan plays something else or hangs up the call. (closes
	  issue #11974) Reported by: fvdb

2009-07-02 18:15 +0000 [r204755]  David Vossel <dvossel@digium.com>

	* include/asterisk/devicestate.h, main/pbx.c, main/devicestate.c,
	  include/asterisk/pbx.h: moving device state functions from pbx.h
	  to devicestate.h to sync with other branches

2009-07-02  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc5

2009-07-02 15:05 +0000 [r204681]  David Vossel <dvossel@digium.com>

	* include/asterisk/devicestate.h, main/pbx.c, main/devicestate.c,
	  include/asterisk/pbx.h: Improved mapping of extension states from
	  combined device states. This fixes a few issues with incorrect
	  extension states and adds a cli command, core show
	  device2extenstate, to display all possible state mappings.
	  (closes issue #15413) Reported by: legart Patches:
	  exten_helper.diff uploaded by dvossel (license 671) Tested by:
	  dvossel, legart, amilcar Review:
	  https://reviewboard.asterisk.org/r/301/

2009-06-30 20:23 +0000 [r204556]  Tilghman Lesher <tlesher@digium.com>

	* main/say.c, UPGRADE.txt: More incorrect language codes, plus
	  ensuring that regionalizations use the specified language, and
	  not English for grammar. (closes issue #15022) Reported by:
	  greenfieldtech Patches: 20090519__issue15022.diff.txt uploaded by
	  tilghman (license 14)

2009-06-30 18:47 +0000 [r204474]  Jason Parker <jparker@digium.com>

	* main/say.c: Fix ast_say_counted_noun to correctly handle Polish.
	  Fix a comment typo in passing.

2009-06-30 18:23 +0000 [r204469]  Tilghman Lesher <tlesher@digium.com>

	* main/say.c, UPGRADE.txt: "tw" is the language specification for
	  Twi (from Ghana) not Taiwanese. (closes issue #15346) Reported
	  by: volivier Patches: 20090617__issue15346__1.4.diff.txt uploaded
	  by tilghman (license 14) 20090617__issue15346__trunk.diff.txt
	  uploaded by tilghman (license 14)
	  20090617__issue15346__1.6.0.diff.txt uploaded by tilghman
	  (license 14) 20090617__issue15346__1.6.1.diff.txt uploaded by
	  tilghman (license 14) 20090617__issue15346__1.6.2.diff.txt
	  uploaded by tilghman (license 14) Tested by: volivier

2009-06-29 22:45 +0000 [r204243-204300]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Add error message so that it is clear why a
	  SIP peer was not processed when a DNS lookup fails on a host or
	  outboundproxy. (closes issue #13432) Reported by: p_lindheimer
	  Patches: outboundproxy.patch uploaded by p (license 558)

	* channels/chan_sip.c: Fix build oops.

	* channels/chan_sip.c: Fix a problem where chan_sip would ignore
	  "old" but valid responses. chan_sip has had a problem for quite a
	  long time that would manifest when Asterisk would send multiple
	  SIP responses on the same dialog before receiving a response. The
	  problem occurred because chan_sip only kept track of the highest
	  outgoing sequence number used on the dialog. If Asterisk sent two
	  requests out, and a response arrived for the first request sent,
	  then Asterisk would ignore the response. The result was that
	  Asterisk would continue retransmitting the requests and ignoring
	  the responses until the maximum number of retransmissions had
	  been reached. The fix here is to rearrange the code a bit so that
	  instead of simply comparing the sequence number of the response
	  to our latest outgoing sequence number, we walk our list of
	  outstanding packets and determine if there is a match. If there
	  is, we continue. If not, then we ignore the response. In doing
	  this, I found a few completely useless variables that I have now
	  removed. (closes issue #11231) Reported by: flefoll Review:
	  https://reviewboard.asterisk.org/r/298

2009-06-29 19:36 +0000 [r204170]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_odbc.c, funcs/func_strings.c: Revision 189537 was
	  supposed to make 1.4 more correct. Instead, it broke func_odbc.
	  Reverting. (closes issue #15317, issue #14614)

2009-06-29 17:04 +0000 [r204067]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: segfault after SPINLOCK schedule delete
	  Using the SPINLOCK schedule delete macro can result in the
	  iax_pvt lock being given up. This makes it possible for the
	  iax_pvt to dissappear when we thought we held the mutex the
	  entire time. To resolve this, the iax_pvt's ref count is
	  incremented. (closes issue #15377) Reported by: aragon Patches:
	  iax_spin_issue_1.4.diff uploaded by dvossel (license 671) Tested
	  by: aragon, dvossel

2009-06-29 15:04 +0000 [r204012]  Mark Michelson <mmichelson@digium.com>

	* apps/app_mixmonitor.c: Place unlock of mutex in an else block so
	  that it does not get unlocked twice. (closes issue #15400)
	  Reported by: aragon

2009-06-27 00:55 +0000 [r203908]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: The ISDN CPE side should not exclusively
	  pick B channels normally. Before this patch, Asterisk
	  unconditionally picked B channels exclusively on the CPE side and
	  normally allowed alternative B channels on the network side. Now
	  Asterisk does the opposite. Reasons for the CPE side to normally
	  not pick B channels exclusively: * For CPE point-to-multipoint
	  mode (i.e. phone side), the CPE side does not have enough
	  information to exclusively pick B channels. (There may be other
	  devices on the line.) * Q.931 gives preference to the network
	  side picking B channels. * Some telcos require the CPE side to
	  not pick B channels exclusively. (closes issue #14383) Reported
	  by: mbrancaleoni

2009-06-26 22:09 +0000 [r203848]  Jeff Peeler <jpeeler@digium.com>

	* channels/chan_dahdi.c: Make sure to recreate the dahdi pseudo
	  channel after dahdi restart (closes issue #14477) Reported by:
	  timking

2009-06-26 21:16 +0000 [r203785]  Russell Bryant <russell@digium.com>

	* main/file.c: Don't fast forward past the end of a message. This
	  is nice change for users of the voicemail application. If someone
	  gets a little carried away with fast forwarding through a
	  message, they can easily get to the end and accidentally exit the
	  voicemail application by hitting the fast forward key during the
	  following prompt. This adds some safety by not allowing a fast
	  forward past the end of a message. (closes issue #14554) Reported
	  by: lacoursj Patches: 21761.patch uploaded by lacoursj (license
	  707) Tested by: lacoursj

2009-06-26 20:03 +0000 [r203719]  David Brooks <dbrooks@digium.com>

	* apps/app_voicemail.c: Fixing voicemail's error in checking max
	  silence vs min message length Max silence was represented in
	  milliseconds, yet vmminsecs (minmessage) was represented as
	  seconds. Also, the inequality was reversed. The warning, if
	  triggered, was "Max silence should be less than minmessage or you
	  may get empty messages", which should have been logged if max
	  silence was greater than minmessage, but the check was for less
	  than. Also, conforming if statement to coding guidelines. closes
	  issue #15331) Reported by: markd Review:
	  https://reviewboard.asterisk.org/r/293/

2009-06-25 21:13 +0000 [r203380]  Terry Wilson <twilson@digium.com>

	* main/cli.c: I didn't see that Mark already fixed the underlying
	  issue! Yay for removing useless code.

2009-06-25 21:02 +0000 [r203375]  Russell Bryant <russell@digium.com>

	* res/res_features.c: Fix a case where CDR answer time could be
	  before the start time involving parking. (closes issue #13794)
	  Reported by: davidw Patches: 13794.patch uploaded by murf
	  (license 17) 13794.patch.160 uploaded by murf (license 17) Tested
	  by: murf, dbrooks

2009-06-25 20:09 +0000 [r203311]  Terry Wilson <twilson@digium.com>

	* main/cli.c: Don't try to free NULL

2009-06-25 18:52 +0000 [r203230]  Mark Michelson <mmichelson@digium.com>

	* main/astmm.c: Prevent false positives when freeing a NULL pointer
	  with MALLOC_DEBUG enabled.

2009-06-25 16:02 +0000 [r203115]  Russell Bryant <russell@digium.com>

	* channels/chan_sip.c: Resolve a crash related to a T.38 reinvite
	  race condition. This change resolves a crash observed locally
	  during some T.38 testing. A call was set up using a call file,
	  and when the T.38 reinvite came in, the channel state was still
	  AST_STATE_DOWN. The reason is explained by a comment in the code
	  that previously lived in the handling of AST_STATE_RINGING. This
	  change modifies the logic to handle the same race condition for
	  any channel state that is not UP. (closes ABE-1895)

2009-06-24 21:01 +0000 [r203036]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c: Improved chan_dahdi.conf pritimer error
	  checking. Valid format is: pritimer=timer_name,timer_value *
	  Fixed segfault if the ',' is missing. * Completely check the
	  range returned by pri_timer2idx() to prevent possible access
	  outside array bounds.

2009-06-24 18:28 +0000 [r202966]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Use the handy UNLINK macro instead of
	  hand-coding the same thing in-line.

2009-06-24  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc4 

2009-06-23 16:28 +0000 [r202671]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: MWI NOTIFY contains a wrong URI if Asterisk
	  listens to non-standard port and transport (closes issue #14659)
	  Reported by: klaus3000 Patches: patch_chan_sip_fixMWIuri_1.4.txt
	  uploaded by klaus3000 (license 65) mwi_port-transport_trunk.diff
	  uploaded by dvossel (license 671) Tested by: dvossel, klaus3000
	  Review: https://reviewboard.asterisk.org/r/288/

2009-06-23 15:22 +0000 [r202572-202601]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Fix more memory leaks that may result if rtp
	  is not successfully allocated.

	* channels/chan_sip.c: Fix potential memory leak in chan_sip when
	  video rtp is not allocated properly.

2009-06-22 20:08 +0000 [r202414-202496]  Russell Bryant <russell@digium.com>

	* main/channel.c: Report CallerID change during a masquerade.
	  Reported by: markster

	* channels/chan_sip.c: Make Polycom subscription type override
	  check more explicit.

2009-06-22 14:44 +0000 [r202336-202342]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Remove an extra debug line left from
	  previous commit.

	* channels/chan_sip.c: Fix a situation in which Asterisk would not
	  stop retransmitting 487s. If a CANCEL were received by Asterisk,
	  we would send a 487 in response to the original INVITE and a 200
	  OK for the CANCEL. If there were a network hiccup which caused
	  the 200 OK and the 487 to be lost, then the UA communicating with
	  Asterisk may try to retransmit its CANCEL. Asterisk's response to
	  this used to be to try sending another 487 to the canceled INVITE
	  and another 200 OK to the CANCEL. The problem here is that the
	  originally-sent 487 was sent "reliably" meaning that it will be
	  retransmitted until it is received properly. So when we receive
	  the second CANCEL it is likely that the first batch of 487s we
	  sent is still going strong and reaches the UA. The result was
	  that the second set of 487s would be retransmitted constantly
	  until the maximum number of retries had been reached. The fix for
	  this is that if we receive a second CANCEL for an INVITE, then we
	  cancel the retransmission of the first set of 487s and start a
	  second set. This causes the dialog to be terminated reasonably.
	  (closes issue #14584) Reported by: klaus3000 Patches:
	  14584_v2.patch uploaded by mmichelson (license 60) Tested by:
	  klaus3000

	* channels/chan_sip.c: Fix a possible infinite loop in SDP parsing
	  during glare situation. There was a while loop in
	  get_ip_and_port_from_sdp which was controlled by a call to
	  get_sdp_iterate. The loop would exit either if what we were
	  searching for was found or if the return was NULL. The problem is
	  that get_sdp_iterate never returns NULL. This means that if what
	  we were searching for was not present, the loop would run
	  infinitely. This modification of the loop fixes the problem.
	  (closes issue #15213) Reported by: schmidts (closes issue #15349)
	  Reported by: samy (closes issue #14464) Reported by: pj (closes
	  issue #15345) Reported by: aragon Patches: sip_inf_loop.patch
	  uploaded by mmichelson (license 60) Tested by: aragon

2009-06-20 17:51 +0000 [r202153]  Sean Bright <sean@malleable.com>

	* channels/chan_sip.c: Since we don't have sip_pvt_lock() in 1.4,
	  we need to use ast_mutex_* directly. (closes issue #15366)
	  Reported by: loloski

2009-06-19 21:21 +0000 [r202022]  Matthew Nicholson <mnicholson@digium.com>

	* channels/chan_sip.c: Added deadlock protection to
	  try_suggested_sip_codec in chan_sip.c. Review:
	  https://reviewboard.asterisk.org/r/287/

2009-06-19 20:22 +0000 [r201993]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: timestamp was being converted to host order
	  as a short rather than a long (closes issue #15361) Reported by:
	  ffloimair Patches: ts_issue.diff uploaded by dvossel (license
	  671)

2009-06-19 00:40 +0000 [r201828]  Tilghman Lesher <tlesher@digium.com>

	* res/res_features.c: If the "h" extension fails, give it another
	  chance in main/pbx.c. If the "h" extension fails, give it another
	  chance in main/pbx.c, when it returns from the bridge code. Fixes
	  an issue where the "h" extension may occasionally not fire, when
	  a Dial is executed from a Macro. Debugged in #asterisk with user
	  tompaw.

2009-06-18  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc3

2009-06-18 15:24 +0000 [r201600]  Russell Bryant <russell@digium.com>

	* res/res_musiconhold.c: Fix memory corruption and leakage related
	  reloads of non files mode MoH classes. For Music on Hold classes
	  that are not files mode, meaning that we are executing an
	  application that will feed us audio data, we use a thread to
	  monitor the external application and read audio from it. This
	  thread also makes use of the MoH class object. In the MoH class
	  destructor, we used pthread_cancel() to ask the thread to exit.
	  Unfortunately, the code did not wait to ensure that the thread
	  actually went away. What needed to be done is a pthread_join() to
	  ensure that the thread fully cleans up before we proceed. By
	  adding this one line, we resolve two significant problems: 1)
	  Since the thread was never joined, it never fully goes away. So,
	  on every reload of non-files mode MoH, an unused thread was
	  sticking around. 2) There was a race condition here where the
	  application monitoring thread could still try to access the MoH
	  class, even though the thread executing the MoH reload has
	  already destroyed it. (issue #15109) Reported by: jvandal (issue
	  #15123) Reported by: axisinternet (issue #15195) Reported by:
	  amorsen (issue AST-208)

2009-06-17 19:59 +0000 [r201450]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Change the datastore traversal in
	  ast_do_masquerade to use a safe list traversal. It is possible
	  for datastore fixup functions to remove the datastore from the
	  list and free it. In particular, the queue_transfer_fixup in
	  app_queue does this. While I don't yet know of this causing any
	  crashes, it certainly could. Found while discussing a separate
	  issue with Brian Degenhardt.

2009-06-17 19:28 +0000 [r201423]  David Vossel <dvossel@digium.com>

	* apps/app_mixmonitor.c: StopMixMonitor race condition (not giving
	  up file immediately) StopMixMonitor only indicates to the
	  MixMonitor thread to stop writing to the file. It does not
	  guarantee that the recording's file handle is available to the
	  dialplan immediately after execution. This results in a race
	  condition. To resolve this, the filestream pointer is placed in a
	  datastore on the channel. When StopMixMonitor is called, the
	  datastore is retrieved from the channel and the filestream is
	  closed immediately before returning to the dialplan.
	  Documentation indicating the use of StopMixMonitor to free files
	  has been updated as well. (closes issue #15259) Reported by:
	  travisghansen Tested by: dvossel Review:
	  https://reviewboard.asterisk.org/r/283/

2009-06-17 18:45 +0000 [r201380]  David Brooks <dbrooks@digium.com>

	* channels/chan_sip.c: Checks for NULL sip_pvt pointer in
	  chan_sip.c->acf_channel_read() Zombie channels could be passed,
	  and chan_sip.c wasn't checking for it. Could crash Asterisk. Now
	  checking for NULL pointer. (closes issue #15330) Reported by:
	  okrief Tested by: dbrooks

2009-06-17 12:03 +0000 [r200991-201261]  Kevin P. Fleming <kpfleming@digium.com>

	* include/asterisk/linkedlists.h: Correct AST_LIST_APPEND_LIST
	  behavior when list to be appended is empty. When the list to be
	  appended is empty, and the list to be appended to is *not*,
	  AST_LIST_APPEND_LIST would actually cause the target list to
	  become broken, and no longer have a pointer to its last entry.
	  This patch fixes the problem. (reported by Stanislaw Pitucha on
	  the asterisk-dev mailing list)

	* apps/app_chanspy.c, apps/app_mixmonitor.c, main/channel.c,
	  build_tools/cflags-devmode.xml, main/autoservice.c, main/frame.c,
	  apps/app_meetme.c, main/slinfactory.c,
	  include/asterisk/linkedlists.h, main/file.c,
	  include/asterisk/channel.h, include/asterisk/frame.h: Improve
	  support for media paths that can generate multiple frames at
	  once. There are various media paths in Asterisk (codec
	  translators and UDPTL, primarily) that can generate more than one
	  frame to be generated when the application calling them expects
	  only a single frame. This patch addresses a number of those
	  cases, at least the primary ones to solve the known problems. In
	  addition it removes the broken TRACE_FRAMES support, fixes a
	  number of bugs in various frame-related API functions, and cleans
	  up various code paths affected by these changes.
	  https://reviewboard.asterisk.org/r/175/

2009-06-16 13:25 +0000 [r200875]  Eliel C. Sardanons <eliels@gmail.com>

	* res/res_smdi.c: Show the interface name on error, if it is not
	  found. If the smdiport specified is not found, show the interface
	  name instead of '(null)'.

2009-06-15 15:21 +0000 [r200513]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Add INFO to our allowed methods so that
	  endpoints know they may send it to us. AST-223

2009-06-12 19:06 +0000 [r200360]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Suppress a warning message and give a better
	  return code when generating inband ringing after a call is
	  answered. (closes issue #15158) Reported by: madkins Patches:
	  15158.patch uploaded by mmichelson (license 60) Tested by:
	  madkins

2009-06-11 22:20 +0000 [r200185]  Sean Bright <sean.bright@gmail.com>

	* Makefile: Backport fix for parallel build warnings from trunk
	  r199781.

2009-06-11 12:12 +0000 [r200037]  Leif Madsen <lmadsen@digium.com>

	* build_tools/make_version_h: Fix path for .flavor and .version.
	  (issue #14737) Reported by: davidw Patches: flavor.patch uploaded
	  by davidw (license 780) Tested by: davidw

2009-06-10 16:08 +0000 [r199856]  Sean Bright <sean.bright@gmail.com>

	* include/asterisk/utils.h: __WORDSIZE is not available on all
	  platforms, so use sizeof(void *) instead.

2009-06-09  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc2

2009-06-08 19:28 +0000 [r199626-199628]  Sean Bright <sean.bright@gmail.com>

	* include/asterisk/utils.h: Fix a typo in the stack size
	  calculation just introduced.

	* include/asterisk/utils.h: Increase the size of our thread stack
	  on 64 bit processors. We were setting the stack size for each
	  thread to 240KB regardless of architecture, which meant that in
	  some scenarios we actually had less available stack space on 64
	  bit processors (pointers use 8 bytes instead of 4). So now we
	  calculate the stack size we reserve based on the platform's
	  __WORDSIZE, which gives us: 32 bit -> 240KB 64 bit -> 496KB 128
	  bit -> 1008KB (that's right, we're ready for 128 bit processors)
	  Patch typed by me but written by several members of
	  #asterisk-dev, including Kevin, Tilghman, and Qwell. (closes
	  issue #14932) Reported by: jpiszcz Patches:
	  06052009_issue14932.patch uploaded by seanbright (license 71)
	  Tested by: seanbright

2009-06-05 21:19 +0000 [r199297]  David Vossel <dvossel@digium.com>

	* main/pbx.c: Fixes issue with hints giving unexpected results.
	  Hints with two or more devices that include ONHOLD gave
	  unexpected results. (closes issue #15057) Reported by:
	  p_lindheimer Patches: onhold_trunk.diff uploaded by dvossel
	  (license 671) pbx.c.1.4.patch uploaded by p (license 558)
	  devicestate.c.trunk.patch uploaded by p (license 671) Tested by:
	  p_lindheimer, dvossel Review:
	  https://reviewboard.asterisk.org/r/254/

2009-06-04 19:00 +0000 [r199138]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: Additional updates to AST-2009-001

2009-06-04 14:14 +0000 [r198957-199022]  Sean Bright <sean.bright@gmail.com>

	* main/asterisk.c, main/loader.c, include/asterisk.h: Safely handle
	  AMI connections/reload requests that occur during startup. During
	  asterisk startup, a lock on the list of modules is obtained by
	  the primary thread while each module is initialized. Issue 13778
	  pointed out a problem with this approach, however. Because the
	  AMI is loaded before other modules, it is possible for a module
	  reload to be issued by a connected client (via Action: Command),
	  causing a deadlock. The resolution for 13778 was to move
	  initialization of the manager to happen after the other modules
	  had already been lodaded. While this fixed this particular issue,
	  it caused a problem for users (like FreePBX) who call AMI scripts
	  via an #exec in a configuration file (See issue 15189). The
	  solution I have come up with is to defer any reload requests that
	  come in until after the server is fully booted. When a call comes
	  in to ast_module_reload (from wherever) before we are fully
	  booted, the request is added to a queue of pending requests. Once
	  we are done booting up, we then execute these deferred requests
	  in turn. Note that I have tried to make this a bit more
	  intelligent in that it will not queue up more than 1 request for
	  the same module to be reloaded, and if a general reload request
	  comes in ('module reload') the queue is flushed and we only issue
	  a single deferred reload for the entire system. As for how this
	  will impact existing installations - Before 13778, a reload
	  issued before module initialization was completed would result in
	  a deadlock. After 13778, you simply couldn't connect to the
	  manager during startup (which causes problems with
	  #exec-that-calls-AMI configuration files). I believe this is a
	  good general purpose solution that won't negatively impact
	  existing installations. (closes issue #15189) (closes issue
	  #13778) Reported by: p_lindheimer Patches:
	  06032009_15189_deferred_reloads.diff uploaded by seanbright
	  (license 71) Tested by: p_lindheimer, seanbright Review:
	  https://reviewboard.asterisk.org/r/272/

	* pbx/pbx_spool.c: Fix a possible crash in pbx_spool. We were
	  trying to reference members of a struct that had previously been
	  freed. This patch makes sure that we free the struct after it has
	  been removed from the spooler queue. (closes issue #15072)
	  Reported by: garlew Patches: spool.diff uploaded by garlew
	  (license 376)

2009-06-03 15:49 +0000 [r198891]  David Vossel <dvossel@digium.com>

	* main/channel.c, res/res_features.c, include/asterisk/channel.h:
	  Generic call forward api, ast_call_forward() The function
	  ast_call_forward() forwards a call to an extension specified in
	  an ast_channel's call_forward string. After an ast_channel is
	  called, if the channel's call_forward string is set this function
	  can be used to forward the call to a new channel and terminate
	  the original one. I have included this api call in both
	  channel.c's ast_request_and_dial() and res_feature.c's
	  feature_request_and_dial(). App_dial and app_queue already
	  contain call forward logic specific for their application and
	  options. (closes issue #13630) Reported by: festr Review:
	  https://reviewboard.asterisk.org/r/271/

2009-06-01 20:07 +0000 [r198665]  Tilghman Lesher <tlesher@digium.com>

	* res/res_musiconhold.c: If using the old deprecated format, a
	  reload would cause the class to disappear. (closes issue #14759)
	  Reported by: lidocaineus Patches: 20090518__issue14759.diff.txt
	  uploaded by tilghman (license 14) Tested by: lmadsen

2009-05-30 19:36 +0000 [r198370]  Sean Bright <sean.bright@gmail.com>

	* res/res_jabber.c: Properly terminate AMI JabberSend response
	  messages. The response message (either Error or Success) needs an
	  extra trailing \r\n after the fields to inform the client that
	  the message is complete. (closes issue #14876) Reported by: srt
	  Patches: 05302009_1.4_res_jabber.c.diff uploaded by seanbright
	  (license 71) asterisk_14876.patch uploaded by srt (license 378)
	  trunk-14876-2.diff uploaded by phsultan (license 73)

2009-05-30 03:42 +0000 [r198311]  Russell Bryant <russell@digium.com>

	* res/res_smdi.c: Fix a crash that occurred when MWI SMDI messages
	  expired. (closes issue #14561) Reported by: cmoss28

2009-05-30 02:46 +0000 [r198251]  Sean Bright <sean.bright@gmail.com>

	* apps/app_dial.c: Treat an empty FORWARD_CONTEXT the same way we
	  treat a missing one. (closes issue #15056) Reported by:
	  p_lindheimer Patches: 05292009_bug15056.diff uploaded by
	  seanbright (license 71) Tested by: p_lindheimer

2009-05-29 18:53 +0000 [r198068]  Matthew Nicholson <mnicholson@digium.com>

	* main/cdr.c, main/channel.c, res/res_features.c,
	  include/asterisk/cdr.h: Use AST_CDR_NOANSWER instead of
	  AST_CDR_NULL as the default CDR disposition. This change also
	  involves the addition of an AST_CDR_FLAG_ORIGINATED flag that is
	  used on originated channels to distinguish: them from dialed
	  channels. (closes issue #12946) Reported by: meral Patches:
	  null-cdr2.diff uploaded by mnicholson (license 96) Tested by:
	  mnicholson, dbrooks (closes issue #15122) Reported by: sum Tested
	  by: sum

2009-05-29 18:14 +0000 [r197998]  Sean Bright <sean.bright@gmail.com>

	* Makefile: Fix 'make config' target for Slackware. There was a
	  missing semi-colon after the echo statement in the Makefile that
	  was causing problems for some users. Fix suggested by reporter.
	  (closes issue #15225) Reported by: pdavis

2009-05-28 23:57 +0000 [r197895]  Leif Madsen <lmadsen@digium.com>

	* apps/app_mixmonitor.c: Update MixMonitor documentation. Updated
	  the MixMonitor documentation for the 'b' option so that it is
	  more obvious that you must not optimize awat the Local channel
	  when using this option. (issue #14829)

2009-05-28  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.26-rc1

2009-05-28 15:51 +0000 [r197620]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: 'iax show peer blah' now outputs whether or
	  not peer 'blah' is in trunk mode or not.

2009-05-28 15:27 +0000 [r197588]  Mark Michelson <mmichelson@digium.com>

	* main/rtp.c, channels/chan_sip.c, include/asterisk/rtp.h: Allow
	  for media to arrive from an alternate source when responding to a
	  reinvite with 491. When we receive a SIP reinvite, it is possible
	  that we may not be able to process the reinvite immediately since
	  we have also sent a reinvite out ourselves. The problem is that
	  whoever sent us the reinvite may have also sent a reinvite out to
	  another party, and that reinvite may have succeeded. As a result,
	  even though we are not going to accept the reinvite we just
	  received, it is important for us to not have problems if we
	  suddenly start receiving RTP from a new source. The fix for this
	  is to grab the media source information from the SDP of the
	  reinvite that we receive. This information is passed to the RTP
	  layer so that it will know about the alternate source for media.
	  Review: https://reviewboard.asterisk.org/r/252

2009-05-28 15:21 +0000 [r197562]  Eliel C. Sardanons <eliels@gmail.com>

	* channels/chan_sip.c: Use the address we already know when
	  reloading a peer with nat=yes. If we already have an address for
	  a peer, and we are reloading the sip configuration, try to use
	  that address to contact the peer, instead of getting it from the
	  Contact. (closes issue #15194) Reported by: ibc Patches:
	  sip.patch uploaded by eliel (license 64) Tested by: manwe

2009-05-28 14:49 +0000 [r197537]  Mark Michelson <mmichelson@digium.com>

	* apps/app_chanspy.c, include/asterisk/audiohook.h,
	  main/audiohook.c: Add flags to chanspy audiohook so that audio
	  stays in sync. There are two flags being added to the chanspy
	  audiohook here. One is the pre-existing
	  AST_AUDIOHOOK_TRIGGER_SYNC flag. With this set, we ensure that
	  the read and write slinfactories on the audiohook do not skew
	  beyond a certain tolerance. In addition, there is a new audiohook
	  flag added here, AST_AUDIOHOOK_SMALL_QUEUE. With this flag set,
	  we do not allow for a slinfactory to build up a substantial
	  amount of audio before flushing it. For this particular issue,
	  this means that the person spying on the call will hear the
	  conversations in real time with very little delay in the audio.
	  (closes issue #13745) Reported by: geoffs Patches: 13745.patch
	  uploaded by mmichelson (license 60) Tested by: snblitz

2009-05-28 13:44 +0000 [r197466]  Joshua Colp <jcolp@digium.com>

	* channels/chan_sip.c: Fix a bug where the flag indicating the
	  presence of rport would get overwritten by the nat setting. The
	  presence of rport is now stored as a separate flag. Once the
	  dialog is setup and authenticated (or it passes through
	  unauthenticated) the proper nat flag is set. (closes issue
	  #13823) Reported by: dimas

2009-05-27 20:12 +0000 [r197264]  Sean Bright <sean.bright@gmail.com>

	* Makefile: Use bash explicitly when calling
	  build_tools/mkpkgconfig from the Makefile. Since we use bashisms
	  in build_tools/mkpkgconfig, we should call on bash explicitly
	  when running from the Makefile, otherwise we get errors during a
	  'make install.' (closes issue #15209) Reported by: seandarcy

2009-05-27 20:07 +0000 [r197259]  Olle Johansson <oej@edvina.net>

	* doc/asterisk-conf.txt: Typo fix

2009-05-27 19:09 +0000 [r197194]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_cut.c: Use a different determinator on whether to
	  print the delimiter, since leading fields may be blank. (closes
	  issue #15208) Reported by: ramonpeek Patch by me, though inspired
	  in part by a patch from ramonpeek

2009-05-27 16:49 +0000 [r197124]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c, include/asterisk/channel.h: Fix broken attended
	  transfers The bridge was terminating immediately after the
	  attended transfer was completed. The problem was because upon
	  reentering ast_channel_bridge nexteventts was checked to see if
	  it was set and if so could possibly return AST_BRIDGE_COMPLETE.
	  (closes issue #15183) Reported by: andrebarbosa Tested by:
	  andrebarbosa, tootai, loloski

2009-05-27 13:54 +0000 [r197024]  Sean Bright <sean.bright@gmail.com>

	* apps/app_queue.c: Fix handling of the 'state_interface' option of
	  the 'queue add member' CLI command. This change relates to
	  r184980, which was a backport of the state interface changes to
	  app_queue from trunk. trunk and all of the 1.6.x branches are not
	  affected. 'queue add member' allows for specifying an interface
	  to use for device state when adding a queue member via CLI, but
	  the validation code was not properly updated to reflect this
	  optional argument. (closes issue #15198) Reported by: loloski
	  Patches: 05272009_app_queue.diff uploaded by seanbright (license
	  71) Tested by: loloski

2009-05-26 18:14 +0000 [r196826]  Russell Bryant <russell@digium.com>

	* res/res_convert.c: Resolve a file handle leak. The frames here
	  should have always been freed. However, out of luck, there was
	  never any memory leaked. However, after file streams became
	  reference counted, this code would leak the file stream for the
	  file being read. (closes issue #15181) Reported by: jkroon

2009-05-26 13:06 +0000 [r196657]  Joshua Colp <jcolp@digium.com>

	* contrib/scripts/safe_asterisk: Remove some bash specific stuff
	  from safe_asterisk. (closes issue #10812) Reported by: paravoid
	  Patches: safe_asterisk_bashism.diff uploaded by tzafrir (license
	  46)

2009-05-22 13:54 +0000 [r196116]  Joshua Colp <jcolp@digium.com>

	* channels/chan_misdn.c: Fix a bug where using immediate with mISDN
	  caused a cause code of 16 to get sent back instead of 1 if the
	  's' extension did not exist. (closes issue #12286) Reported by:
	  lmamane

2009-05-21 19:04 +0000 [r195991]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: Sign problem calculating timestamp for iax
	  frame leads to no audio on the receiving peer. There are rare
	  cases in which a frame's delivery timestamp is slightly less than
	  the iax2_pvt's offset. This causes the pvt's timestamp to be a
	  small negative number, but since the timestamp value is unsigned
	  it looks like a huge positive number. This patch checks for this
	  negative case and sets the ms to zero. A similar check is already
	  done right below this one in the 'else' statement. (closes issue
	  #15032) Reported by: guillecabeza Patches:
	  chan_iax2.c.patch_timestamp uploaded by guillecabeza (license
	  380) Tested by: guillecabeza (closes issue #14216) Reported by:
	  Andrey Sofronov

2009-05-21 15:25 +0000 [r195881]  Matthew Nicholson <mnicholson@digium.com>

	* main/cdr.c, res/res_features.c, include/asterisk/cdr.h: This
	  commit prevents cdr records with AST_CDR_FLAG_ANSLOCKED and
	  AST_CDR_FLAG_LOCKED from being updated in certain cases. This is
	  accomplished by adding two functions to update the answer time
	  and disposition of calls that checks for the proper lock flags.
	  These functions are used in the ast_bridge_call() function so
	  that ForkCDR(A) calls are respected. This patch also modifies the
	  way ast_bridge_call() chooses the cdr record to base the
	  bridged_cdr on. Previously the first unlocked cdr record would be
	  chosen, now instead the first cdr record is chosen and forked cdr
	  records are moved to the bridge_cdr. This allows the original cdr
	  record and any forked cdr records to be properly updated with
	  answer and end times. (closes issue #13797) Reported by: sh0t
	  Tested by: sh0t (closes issue #14744) Reported by: deepesh

2009-05-21  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.25

2009-05-13  Leif Madsen <lmadsen@digium.com>

	* Release Asterisk 1.4.25-rc1

2009-05-13 13:38 +0000 [r194208]  Joshua Colp <jcolp@digium.com>

	* main/rtp.c: Fix RFC2833 issues with DTMF getting duplicated and
	  with duration wrapping over. (closes issue #14815) Reported by:
	  geoff2010 Patches: v1-14815.patch uploaded by dimas (license 88)
	  Tested by: geoff2010, file, dimas, ZX81, moliveras (closes issue
	  #14460) Reported by: moliveras Tested by: moliveras

2009-05-13 00:52 +0000 [r194137]  Tilghman Lesher <tlesher@digium.com>

	* main/pbx.c: Fix logic for how to proceed with a single digit
	  extension. (closes issue #15091) Reported by: andrew Patches:
	  20090512__issue15091.diff.txt uploaded by tilghman (license 14)
	  Tested by: andrew

2009-05-12 22:15 +0000 [r194028]  Matthew Nicholson <mnicholson@digium.com>

	* apps/app_queue.c: This change modifies app_queue to properly
	  generate CDR records in failure situations. This involves setting
	  a proper cdr disposition coresponding to the given failure
	  condition and ensuring the proper information is stored in the
	  cdr record. (closes issue #13691) Reported by: dferrer Tested by:
	  mnicholson (closes issue #13637) Reported by: atis Tested by:
	  atis

2009-05-12 20:39 +0000 [r193955]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Avoid initializing routines if the
	  authentication fails. Fixes a crash (RR) issue. (closes issue
	  #14508) Reported by: tiziano Patches:
	  20090221_2_wrongmailbox.diff.txt uploaded by tiziano (license
	  377)

2009-05-12 18:18 +0000 [r193880]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Set the invitestate to INV_CANCELLED only if
	  we are actually sending a SIP CANCEL. The problem was that the
	  hangup code was setting the invitestate too early. The result of
	  this was that we would always send a CANCEL request, even if it
	  was not an appropriate time to do so (e.g. we have not yet
	  received a provisional response for our INVITE). Note that this
	  same fix had been applied to trunk and the 1.6.X branches
	  starting with revision 155467. This is why you will see this
	  revision being blocked from those places. AST-216

2009-05-11 22:48 +0000 [r193755]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Move 300 bytes around on the stack, to make
	  more room for an extension buffer. This allows more concurrent
	  extensions to be copied for a single voicemail, without creating
	  a possibility of upsetting existing users, where a dialplan could
	  run out of stack space where it had run fine before.
	  Alternatively, we could have allocated off the heap, but that is
	  a larger change and would have increased the chance for
	  instability introduced by this change. This is really solved
	  starting in 1.6.0.11, as the use of an ast_str buffer allows an
	  unlimited number of extensions (up to available memory). We
	  additionally create a new warning message when the buffer length
	  is exceeded, permitting administrators to see an issue after the
	  fact, whereas previously the list was silently truncated. (closes
	  issue #14739) Reported by: p_lindheimer Patches:
	  20090417__bug14739.diff.txt uploaded by tilghman (license 14)
	  Tested by: p_lindheimer

2009-05-11 19:09 +0000 [r193613]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c: Sent wrong message to clear a call we
	  started if the other end has not responed yet. In the state
	  MISDN_CALLING (i.e. SETUP was sent but no answer has arrived
	  yet), it is not allowed to clear the call with RELEASE_COMPLETE.
	  It must be cleared with DISCONNECT. A RELEASE_COMPLETE is only
	  allowed as an answer to a SETUP. (See Q.931 ch. 5.3.2, 5.3.2.a,
	  5.3.2.b) Patches: chan-misdn-ccstate7.patch uploaded by customer.
	  JIRA ABE-1862

2009-05-11 17:35 +0000 [r193544]  Leif Madsen <lmadsen@digium.com>

	* funcs/func_channel.c: Document CHANNEL(transfercapability) in CLI
	  documentation. (issue #15073) Reported by: pkempgen Patches:
	  20090511__issue15073.diff.txt uploaded by tilghman (license 14)

2009-05-08 21:01 +0000 [r193391]  Matthew Nicholson <mnicholson@digium.com>

	* main/channel.c: Set the proper disposition on originated calls.
	  (closes issue #14167) Reported by: jpt Patches:
	  call-file-missing-cdr2.diff uploaded by mnicholson (license 96)
	  Tested by: dlotina, rmartinez, mnicholson

2009-05-08 14:51 +0000 [r193262]  David Vossel <dvossel@digium.com>

	* channels/misdn_config.c: "misdn show config" segfaults asterisk,
	  if no MSN lists (closes issue #14976) Reported by: alecdavis
	  Patches: misdn_config.diff.txt uploaded by alecdavis (license
	  585) Tested by: alecdavis, FabienToune

2009-05-08 14:03 +0000 [r193193]  Kevin P. Fleming <kpfleming@digium.com>

	* configs/logger.conf.sample, main/logger.c: Make absolute paths
	  for logger channels work properly (Note: This is not a new
	  feature, it was previously undocumented and broken.) The Asterisk
	  logger has a feature to support absolute pathnames for logger
	  channels, but the code implementing the feature was broken. This
	  has been fixed, and the absolute path feature is now documented
	  in the sample logger.conf.

2009-05-07 23:41 +0000 [r193119]  Tilghman Lesher <tlesher@digium.com>

	* main/pbx.c: Fix Background within a Macro for FreePBX. If the
	  single digit DTMF is an extension in the specified context, then
	  go there and signal no DTMF. Otherwise, we should exit with that
	  DTMF. If we're in Macro, we'll exit and seek that DTMF as the
	  beginning of an extension in the Macro's calling context. If
	  we're not in Macro, then we'll simply seek that extension in the
	  calling context. Previously, someone complained about the
	  behavior as it related to the interior of a Gosub routine, and
	  the fix (#14011) inadvertently broke FreePBX (#14940). This
	  change should fix both of these situations, but with the possible
	  incompatibility that if a single digit extension does not exist
	  (but a longer extension COULD have matched), it would have
	  previously gone immediately to the "i" extension, but will now
	  need to wait for a timeout. (closes issue #14940) Reported by:
	  p_lindheimer Patches: 20090420__bug14940.diff.txt uploaded by
	  tilghman (license 14) Tested by: p_lindheimer

2009-05-07 22:17 +0000 [r193050]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c: Give a more helpful message when an
	  incoming call's dialed extension does not match. Added the dialed
	  extension and context to the chan_misdn messages warning that the
	  dialed number cannot be matched in the dialplan.

2009-05-07 16:29 +0000 [r192932]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_sip.c: Eliminate repetition of fullcontact during
	  reconstruction. If the fullcontact field appears in both the
	  sippeers and the sipregs table, then during reconstruction of the
	  field, it will otherwise be doubled. (closes issue #14754)
	  Reported by: Alexei Gradinari Patches:
	  20090506__bug14754.diff.txt uploaded by tilghman (license 14)
	  Tested by: lmadsen

2009-05-06 22:15 +0000 [r192858]  Jeff Peeler <jpeeler@digium.com>

	* res/res_features.c: Make ParkedCall application stop execution of
	  the dialplan after hang up Just changed park_exec to always
	  return non-zero. I really wasn't entirely sure at first if this
	  was a bug. Decided it was since it would be surprising when not
	  using ParkedCall in the dialplan to hang up and have dialplan
	  execution continue. (closes issue #14555) Reported by:
	  francesco_r

2009-05-06 13:30 +0000 [r192633]  Joshua Colp <jcolp@digium.com>

	* channels/chan_sip.c: Update some old logic to stop both begin and
	  end DTMF frames from reaching the core if rfc2833 is not enabled.
	  (closes issue #15036) Reported by: dimas Patches: v1-15036.patch
	  uploaded by dimas (license 88)

2009-05-05 19:56 +0000 [r192524]  Sean Bright <sean.bright@gmail.com>

	* static-http/astman.js: Fix Javascript error when using astman.js
	  in Internet Explorer. Internet Explorer (tested with 7.0) does
	  not like trailing commas on constructs like object initializers,
	  so get rid of them to avoid some errors. (closes issue #15026)
	  Reported by: rajnishgiri Patches: bug15026.patch uploaded by
	  seanbright (license 71) Tested by: seanbright

2009-05-05 18:22 +0000 [r192429-192454]  Joshua Colp <jcolp@digium.com>

	* res/res_features.c: Fix an incorrect assumption that certain
	  values on the channel will always exist when they may not. The
	  CDR code involved with bridges wrongly assumed that the currently
	  executing application and data values will always exist. It is
	  possible for this to be false when call forwarding is involved.
	  (closes issue #14984) Reported by: gincantalupo

	* apps/app_followme.c: Fix a bug where the followme application
	  would continue trying numbers after the caller hung up. (closes
	  issue #13624) Reported by: sgenyuk

2009-05-04 22:37 +0000 [r192213]  David Vossel <dvossel@digium.com>

	* channels/chan_iax2.c: global mohinterpret setting is ignored
	  mohinterpret and mohsuggest global variables were not copied over
	  during build_users and build_peers. (closes issue #14728)
	  Reported by: dimas Patches: v1-14728.patch uploaded by dimas
	  (license 88) Tested by: dimas, dvossel

2009-05-02 18:48 +0000 [r191628-191778]  Mark Michelson <mmichelson@digium.com>

	* apps/app_voicemail.c: Fix a bug which resulted from the Hebrew
	  voicemail commit. This fixes a case where a certain message could
	  get played twice. (closes issue #13155) Reported by:
	  greenfieldtech Patches: app_voicemail.c.multi-lang-patch uploaded
	  by greenfieldtech (license 369) Tested by: greenfieldtech

	* apps/app_chanspy.c: Kevin has informed me that thi sort of thing
	  is not necessary.

	* apps/app_chanspy.c: Move static buffers to outside for loops in
	  app_chanspy. Similar to seanbright's commit 191422, this moves
	  some static buffers to be defined outside of for loops since it
	  is undefined if memory will be re-used or if the stack will grow
	  with each iteration of the loop.

2009-05-01 20:00 +0000 [r191559]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_sip.c: SIP Response 410 maps to cause code 22 (or
	  23), not 1. (closes issue #14993) Reported by: BigJimmy Patches:
	  causepatch uploaded by BigJimmy (license 371)

2009-05-01 17:40 +0000 [r191488]  Jeff Peeler <jpeeler@digium.com>

	* main/channel.c: Fix DTMF not being sent to other side after a
	  partial feature match This fixes a regression from commit 176701.
	  The issue was that ast_generic_bridge never exited after the
	  feature digit timeout had elapsed, which prevented the queued
	  DTMF from being sent to the other side. This issue was reported
	  to me directly.

2009-05-01 15:42 +0000 [r191422]  Sean Bright <sean.bright@gmail.com>

	* apps/app_queue.c: Move the defintion of the a couple arrays out
	  of loops. According to Kevin, it is unspecified as to whether a
	  variable defined inside a block is allocated once by the compiler
	  or for each pass through the block (loops being the only
	  interesting case), so just define these before we get into our
	  loop to be sure.

2009-04-29 23:10 +0000 [r191220]  Tilghman Lesher <tlesher@digium.com>

	* channels/h323/ast_h323.cxx, channels/chan_h323.c: Allow H.323 to
	  compile with FDLEAK checking enabled.

2009-04-29 18:07 +0000 [r191096]  David Brooks <dbrooks@digium.com>

	* pbx/pbx_config.c: Patch to fix tab-completion crash on "remove
	  extension" This patch simply removes some old code back before
	  Asterisk used editline. This fixes the crash that occurred when
	  tab-completing "remove extension". (closes issue #14689) Reported
	  by: isaacgal

2009-04-29 15:23 +0000 [r191041]  Sean Bright <sean.bright@gmail.com>

	* apps/app_queue.c: Fix a crash in app_queue with very long member
	  lists. A user reported via #asterisk that with very long lists of
	  members, a crash occurs in ast_strdupa, so just use a single
	  buffer and ast_copy_string instead of stack allocating copys of
	  each interface name.

2009-04-27 19:29 +0000 [r190721]  Kevin P. Fleming <kpfleming@digium.com>

	* configure, include/asterisk/autoconfig.h.in: Fix 'inconsistent
	  line endings' when autoconf 2.63 is used Attempt to make
	  configure script regeneration 'safe' using autoconf 2.63, which
	  embeds a bare CR into the script, thus making Subversion complain
	  about inconsistent line endings This commit changes the MIME type
	  of the configure script to be 'binary' thus making Subversion no
	  longer inspect line endings, and as a bonus 'svn diff' will no
	  longer try to generate diff output for it, which is not generally
	  useful anyway.

2009-04-27 19:03 +0000 [r190661-190662]  Russell Bryant <russell@digium.com>

	* res/res_smdi.c: Fix a typo from 190661.

	* res/res_smdi.c: Resolve a crash in res_smdi when used with
	  chan_dahdi. When chan_dahdi goes to get an SMDI message, it
	  provides no search criteria. It just grabs the next message that
	  arrives. This code was written with the SMDI dialplan functions
	  in mind, since that is now the preferred method of using SMDI.
	  However, this broke support of it being used from chan_dahdi.
	  (closes AST-212)

2009-04-23 21:07 +0000 [r190356]  Russell Bryant <russell@digium.com>

	* channels/chan_sip.c: Remove a bogus ast_channel_unlock().

2009-04-23 19:13 +0000 [r190286]  Joshua Colp <jcolp@digium.com>

	* channels/chan_local.c: Fix a bug in chan_local glare hangup
	  detection. If both sides of a Local channel were hung up at
	  around the same time it was possible for one thread to destroy
	  the local private structure and have the other thread immediately
	  try to remove the already freed structure from the local channel
	  list.

2009-04-23 10:07 +0000 [r190187]  Olle Johansson <oej@edvina.net>

	* include/asterisk/lock.h: unistd.h is required for usleep() on
	  Darwin. It will not hurt to include it always on other platforms
	  either.

2009-04-22 21:35 +0000 [r190092]  Tilghman Lesher <tlesher@digium.com>

	* configure, include/asterisk/autoconfig.h.in, configure.ac,
	  include/asterisk/lock.h: Detect availability of
	  pthread_rwlock_timedwrlock() before using it. (closes issue
	  #14930) Reported by: tilghman Patches:
	  20090420__bug14930.diff.txt uploaded by tilghman (license 14)
	  Tested by: mvanbaak, tilghman

2009-04-22 19:20 +0000 [r189991]  Jeff Peeler <jpeeler@digium.com>

	* channels/h323/ast_h323.cxx, channels/chan_h323.c,
	  channels/h323/chan_h323.h: Make chan_h323 respect packetization
	  settings Previously, packetization settings were ignored and now
	  they are not. A new config option 'autoframing' has been added to
	  mirror the way chan_sip handles it. Turning on the autoframing
	  option (available both as a global option or per peer) overrides
	  the local settings with the remote packetization settings.
	  Testing was performed with varying packetization levels with the
	  following codecs: ulaw, alaw, gsm, and g729. (closes issue
	  #12415) Reported by: pj Patches:
	  2009012200_h323packetization.diff.txt uploaded by mvanbaak
	  (license 7), modified by me

2009-04-22 14:29 +0000 [r189849]  Michiel van Baak <michiel@vanbaak.info>

	* contrib/scripts/get_ilbc_source.sh: replace sed with tr to remove
	  \r from downloaded file On some systems, sed does not recognize
	  \r in the pattern the way it was used here. Use tr instead
	  because this works the same across systems. (closes issue #14936)
	  Reported by: leobrown Patches: 2009042201_14936.diff.txt uploaded
	  by mvanbaak (license 7) Tested by: leobrown, mvanbaak

2009-04-21 15:52 +0000 [r189601-189664]  Doug Bailey <dbailey@digium.com>

	* utils/muted.c: Remove daemon call on systems that do not support
	  forking.

	* main/config.c, configure, include/asterisk/autoconfig.h.in,
	  include/asterisk/compat.h, configure.ac: Add check in configure
	  script to check for GLOB_NOMAGIC and GLOB_BRACE in glob.h This
	  allows config.c to compile when linked against uclibc that does
	  not support these parameters

2009-04-20 22:02 +0000 [r189537]  Tilghman Lesher <tlesher@digium.com>

	* funcs/func_odbc.c, funcs/func_strings.c: Add a workaround for
	  func_odbc/ARRAY() for problems that occur with certain special
	  characters. In certain cases, due to the way Set() works in 1.4,
	  values may not get set properly. This is a workaround for 1.4
	  only that corrects for these issues, without making func_odbc
	  more difficult to use properly. (closes issue #14614) Reported
	  by: wdoekes Patches: 20090309__bug14614__2.diff.txt uploaded by
	  tilghman (license 14)
	  double_set_unescape_workaround_for_func_odbc.osso-and-tilghman-1.diff
	  uploaded by wdoekes (license 717) Tested by: wdoekes, tilghman

2009-04-20 21:10 +0000 [r189463-189465]  Terry Wilson <twilson@digium.com>

	* apps/app_dial.c: Update CDR appropriately when
	  AST_CAUSE_NO_ANSWER is set

	* apps/app_dial.c: Don't treat a NOANSWER like a CHANUNAVAIL

2009-04-20 20:58 +0000 [r189462]  Sean Bright <sean.bright@gmail.com>

	* pbx/ael/ael.tab.c, pbx/ael/ael.y: Properly handle @s within hints
	  in AEL. AEL was not handling the case of a device hint containing
	  an @ symbol, which caused parking hints (e.g.
	  hint(park:exten@context)) to error out the parser. This patch
	  makes AEL treat the @ the same way it treats colon and ampersand
	  now, meaning the characters are included in verbatim. (closes
	  issue #14941) Reported by: bpgoldsb Patches: bug14941.patch
	  uploaded by seanbright (license 71) Tested by: bpgoldsb

2009-04-20 19:10 +0000 [r189391]  Doug Bailey <dbailey@digium.com>

	* main/manager.c, main/db1-ast/recno/rec_open.c,
	  channels/chan_iax2.c: Clean up problem with manager
	  implementation of mmap where it was not testing against
	  MAP_FAILED response. Got rid of shadowed variable used in
	  processign the mmap results. Change test of mmap results to
	  compare against MAP_FAILED

2009-04-20 14:04 +0000 [r189277]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Move the check for chan->fdno == -1 to after the
	  zombie/hangup check. Many users were finding that their hung up
	  channels were staying up and causing 100% CPU usage. (issue
	  #14723) Reported by: seadweller Patches: 14723_1-4-tip.patch
	  uploaded by mmichelson (license 60) Tested by: falves11, bamby

2009-04-18 01:27 +0000 [r189203]  David Vossel <dvossel@digium.com>

	* channels/chan_agent.c: Fixed autologoff in agents.conf not
	  working when agent logs in via AgentLogin app An agent logs in by
	  calling an extension that calls the AgentLogin app. In
	  agents.conf ackcall=always is set, so when they get a call they
	  have the choice to either acknowledge it or ignore it.
	  autologoff=10 is set as well, so if the agent ignores the call
	  over 10sec one may assume that the agent should be logged out
	  (and in this case hungup on as well), but this was not happening.
	  (closes issue #14091) Reported by: evandro Patches:
	  autologoff.diff uploaded by dvossel (license 671) Review:
	  http://reviewboard.digium.com/r/225/

2009-04-17 21:27 +0000 [r189134]  Richard Mudgett <rmudgett@digium.com>

	* channels/misdn/isdn_lib.c: Modifed/added some debug messages.
	  JIRA ABE-1835

2009-04-17 15:43 +0000 [r189009]  Matthew Nicholson <mnicholson@digium.com>

	* main/pbx.c: Make Busy() application set the CDR disposition to
	  BUSY. (closes issue #14306) Reported by: cristiandimache

2009-04-17 14:41 +0000 [r188937-188946]  Joshua Colp <jcolp@digium.com>

	* channels/chan_sip.c: Fix a bug where a value used to create the
	  channel name was bogus. This commit fixes the scenario where an
	  incoming call is authenticated using a peer entry. Previously the
	  channel name was created using either the username setting from
	  the sip.conf entry or the IP address that the call came from. Now
	  the channel name will be created using the peer name itself. This
	  commit will not change the way the channel name is generated for
	  users or friends. (closes issue #14256) Reported by: Nick_Lewis
	  Patches: chan_sip.c-chname.patch uploaded by Nick (license 657)
	  Tested by: Nick_Lewis, file

	* channels/chan_dahdi.c: Fix a situation where the DAHDI channel
	  private structure lock was not unlocked when it should have been.
	  (issue AST-210)

2009-04-16 21:41 +0000 [r188835]  Tilghman Lesher <tlesher@digium.com>

	* channels/chan_sip.c: Only update realtime, if global option
	  rtupdate != false (closes issue #14885) Reported by: deepesh
	  Patches: 20090413__bug14885.diff.txt uploaded by tilghman
	  (license 14) Tested by: deepesh

2009-04-16 21:37 +0000 [r188833]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c: Only disable mISDN DSP if Asterisk DSP is
	  enabled. Leave jitter setting alone. JIRA ABE-1835

2009-04-16 21:02 +0000 [r188773]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Umask should not be exported into global
	  namespace. (closes issue #14912) Reported by: jcapp

2009-04-15 22:08 +0000 [r188646]  David Vossel <dvossel@digium.com>

	* channels/chan_dahdi.c: National prefix inserted even when caller
	  ID not available When the caller ID is restricted, the expected
	  behavior is for the caller id to be blank. In chan_dahdi, the
	  national prefix is placed onto the callers number even if its
	  restricted (empty) causing the caller id to be the national
	  prefix rather than blank. (closes issue #13207) Reported by:
	  shawkris Patches: national_prefix.diff uploaded by dvossel
	  (license 671) Review: http://reviewboard.digium.com/r/220/

2009-04-15 20:04 +0000 [r188582]  Mark Michelson <mmichelson@digium.com>

	* main/file.c: Update ast_readvideo_callback to match
	  ast_readaudio_callback. This fixes potential refcount errors that
	  may occur on ast_filestreams. AST-208

2009-04-14 15:02 +0000 [r188287]  David Vossel <dvossel@digium.com>

	* main/audiohook.c: audio_audiohook_write_list() does not correctly
	  update sample size after ast_translate.
	  audio_audiohook_write_list() does not take into account that the
	  sample size may change after translation depending on if the
	  original frame is is 8khz or 16khz. While no 16kz codecs are
	  supported in 1.4 at the moment, this will save headaches in the
	  future if they ever are. the sample size is now updated after
	  translating to reflect this possibility. Thanks to jcolp and
	  mmichelson for helping me work this out. (issue AST-197)

2009-04-13 23:04 +0000 [r188149]  Tilghman Lesher <tlesher@digium.com>

	* res/res_odbc.c: If fileconfig limit exceeds our maximum, then set
	  the limit to the maximum. (Closes issue #14888) Reported by:
	  falves11

2009-04-10 22:16 +0000 [r187962]  Jeff Peeler <jpeeler@digium.com>

	* channels/Makefile: Fix module embedding for chan_h323. Include
	  libchanh323.a in the modules.link file so that all the symbols
	  can be resolved at link time. (closes issue #11966) Reported by:
	  dome

2009-04-10 19:26 +0000 [r187865]  Russell Bryant <russell@digium.com>

	* channels/chan_dahdi.c: Support "signaling" in addition to
	  "signalling". The sample configuration file has references to
	  both spellings.

2009-04-10 17:28 +0000 [r187763]  Tilghman Lesher <tlesher@digium.com>

	* contrib/scripts/realtime_pgsql.sql,
	  contrib/scripts/sip-friends.sql: Add lastms column to the
	  contributed table designs

2009-04-09 18:51 +0000 [r187484]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Handle a SIP race condition (reinvite before
	  an ACK) properly. RFC 5047 explains the proper course of action
	  to take if a reINVITE is received before the ACK from a previous
	  invite transaction. What we are to do is to treat the reINVITE as
	  if it were both an ACK and a reINVITE and process it normally.
	  Later, when we receive the ACK we had been expecting, we will
	  ignore it since its CSeq is less than the current iseqno of the
	  sip_pvt representing this dialog. (closes issue #13849) Reported
	  by: klaus3000 Patches: 13849_v2.patch uploaded by mmichelson
	  (license 60) Tested by: mmichelson, klaus3000

2009-04-09 18:39 +0000 [r187209-187482]  Tilghman Lesher <tlesher@digium.com>

	* include/asterisk/lock.h: Oops, typo

	* main/manager.c, include/asterisk/lock.h: Race condition between
	  ast_cli_command() and 'module unload' could cause a deadlock. Add
	  lock timeouts to avoid this potential deadlock. (closes issue
	  #14705) Reported by: jamessan Patches:
	  20090320__bug14705.diff.txt uploaded by tilghman (license 14)
	  Tested by: jamessan

	* channels/chan_sip.c, apps/app_sendtext.c: Permit zero-length text
	  messages in SIP. (Related to an issue posted to the -users list,
	  subject "AEL2, BASE64_DECODE and hexadecimal")

	* main/astfd.c (added): Oops, missed this file in the last commit.

	* main/asterisk.c, agi/Makefile, build_tools/cflags.xml,
	  utils/Makefile, include/asterisk.h, main/Makefile, main/file.c:
	  Add debugging mode for diagnosing file descriptor leaks. (Related
	  to issue #14625)

	* main/manager.c: Backport resolution for file descriptor leak in
	  1.6.0 to 1.4. This fixes short reads in http manager sessions,
	  such as those done by the ast-gui branch. (Fixes AST-198)

2009-04-08 19:16 +0000 [r186832-187135]  Mark Michelson <mmichelson@digium.com>

	* apps/app_dial.c: Fix a crash due to too few arguments to
	  RetryDial. (closes issue #14852) Reported by: junky Patches:
	  retry_fix.diff uploaded by junky (license 177)

	* res/res_musiconhold.c: Fix a small logical error when loading moh
	  classes. We were unconditionally incrementing the number of
	  mohclasses registered. However, we should actually only increment
	  if the call to moh_register was successful. While this probably
	  has never caused problems, I noticed it and decided to fix it
	  anyway.

	* main/channel.c: Make a couple of changes with regards to a new
	  message printed in ast_read(). "ast_read() called with no
	  recorded file descriptor" is a new message added after a bug was
	  discovered. Unfortunately, it seems there are a bunch of places
	  that potentially make such calls to ast_read() and trigger this
	  error message to be displayed. This commit does two things to
	  help to make this message appear less. First, the message has
	  been downgraded to a debug level message if dev mode is not
	  enabled. The message means a lot more to developers than it does
	  to end users, and so developers should take an effort to be sure
	  to call ast_read only when a channel is ready to be read from.
	  However, since this doesn't actually cause an error in operation
	  and is not something a user can easily fix, we should not spam
	  their console with these messages. Second, the message has been
	  moved to after the check for any pending masquerades. ast_read()
	  being called with no recorded file descriptor should not
	  interfere with a masquerade taking place. This could be seen as a
	  simple way of resolving issue #14723. However, I still want to
	  try to clear out the existing ways of triggering this message,
	  since I feel that would be a better resolution for the issue.

	* formats/format_wav.c, formats/format_wav_gsm.c: Fix a few typos
	  of the word "frequency." (closes issue #14842) Reported by:
	  jvandal Patches: frequency-typo.diff uploaded by jvandal (license
	  413)

	* main/channel.c: Set the AST_FEATURE_WARNING_ACTIVE flag when a
	  p2p bridge returns AST_BRIDGE_RETRY. Without this flag set,
	  warning sounds will not be properly played to either party of the
	  bridge. (closes issue #14845) Reported by: adomjan

2009-04-07 22:16 +0000 [r186775]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_macro.c: Fix Macro documentation to match current (and
	  intended) behavior. (See -dev mailing list)

2009-04-07 20:43 +0000 [r186719]  Mark Michelson <mmichelson@digium.com>

	* main/manager.c: Ensure that \r\n is printed after the ActionID in
	  an OriginateResponse. (closes issue #14847) Reported by: kobaz

2009-04-06 13:54 +0000 [r186565]  Mark Michelson <mmichelson@digium.com>

	* apps/app_voicemail.c: Revert commit 186445 because it causes the
	  build to fail when IMAP_STORAGE is used.

2009-04-03 20:19 +0000 [r186458]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_dahdi.c: Fix a bug where DAHDI/Zaptel channels
	  would not properly switch formats when requested Don't offer
	  AST_FORMAT_SLINEAR on DAHDI/Zaptel channels... while it could
	  provide a slight performance benefit, the translation core in
	  Asterisk has some flaws when a channel driver offers multiple raw
	  formats. this fix is much simpler than fixing the translation
	  core to solve that issue (although that will be done later).

2009-04-03 19:56 +0000 [r186415-186445]  Tilghman Lesher <tlesher@digium.com>

	* apps/app_voicemail.c: Found a conflict in the last commit, due to
	  multiple targets

	* apps/app_voicemail.c, configs/voicemail.conf.sample: Distinguish
	  in a sent email between simple sends and forwards. (closes issue
	  #11678) Reported by: jamessan Patches:
	  20090330__bug11678.diff.txt uploaded by tilghman (license 14)
	  Tested by: tilghman, lmadsen

2009-04-03 15:48 +0000 [r186320]  Joshua Colp <jcolp@digium.com>

	* include/asterisk/crypto.h: Fix a problem with the crypto variable
	  definitions not actually being defined properly. (closes issue
	  #14804) Reported by: jvandal

2009-04-03 01:57 +0000 [r186229]  Russell Bryant <russell@digium.com>

	* cdr/cdr_radius.c: Fix a memory leak in cdr_radius. I came across
	  this while doing some testing of my ast_channel_ao2 branch. After
	  running a test overnight that generated over 5 million calls,
	  Asterisk had taken up about 1 GB of my system memory. So, I
	  re-ran the test with MALLOC_DEBUG turned on. However, it showed
	  no leaks in Asterisk during the test, even though Asterisk was
	  still consuming it somehow. Instead, I turned to valgrind, which
	  when run with --leak-check=full, told me exactly where the leak
	  came from, which was from allocations inside the radiusclient-ng
	  library. This explains why MALLOC_DEBUG did not report it. After
	  a bit of analysis, I found that we were leaking a little bit of
	  memory every time a CDR record was passed to cdr_radius. I don't
	  actually have a radius server set up to receive CDR records.
	  However, I always have my development systems compile and install
	  all modules. In addition to making sure there are not build
	  errors across modules, always loading modules helps find bugs
	  like this, too, so it is strongly recommend for all developers.

2009-04-02 21:55 +0000 [r186174]  Mark Michelson <mmichelson@digium.com>

	* configs/features.conf.sample: Fix instructions in one-step
	  parking comment to make more sense. Changed a capital K to a
	  lowercase k.

2009-04-02 17:21 +0000 [r186081]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_dahdi.c: ensure that the buffer passed to
	  DAHDI_SET_BUFINFO is fully initialized

2009-04-02 17:09 +0000 [r186057-186059]  Tilghman Lesher <tlesher@digium.com>

	* /, channels/chan_sip.c, configs/sip.conf.sample: Merged revisions
	  186056 via svnmerge from
	  https://origsvn.digium.com/svn/asterisk/branches/1.2 ........
	  r186056 | tilghman | 2009-04-02 12:02:18 -0500 (Thu, 02 Apr 2009)
	  | 2 lines Fix for AST-2009-003 ........

	* channels/chan_sip.c: Avoid multiple warning messages in SIP, due
	  to this column not existing

2009-04-02 13:43 +0000 [r185952]  Kevin P. Fleming <kpfleming@digium.com>

	* channels/chan_dahdi.c: the DAHDI_GETCONF, DAHDI_SETCONF and
	  DAHDI_GET_PARAMS ioctls were recently corrected to show that they
	  do, in fact, read data from userspace as part of their work. due
	  to this fix, valgrind now reports a number of cases where
	  chan_dahdi passed an uninitialized (or partially) buffer to these
	  ioctls, which could lead to unexpected behavior. this patch
	  corrects chan_dahdi to ensure that buffers passed to these ioctls
	  are always fully initialized.

2009-04-01 19:02 +0000 [r185845]  David Vossel <dvossel@digium.com>

	* channels/chan_sip.c: Fixes issue with dropped calles due to
	  re-Invite glare and re-Invites never executing after a 491
	  Acknowledgement for 491 responses were never being processed
	  because it didn't match our pending invite's seqno. Since the ACK
